/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

(function(){

    dojo.provide("com.ibm.epm.web.core.app.internal.common.ConfirmationDialog");
    
    dojo.require("com.ibm.epm.web.core.app.internal.Util");
    dojo.require("dijit._Widget");
    dojo.require("dijit._Templated");
    
    
    var Util = com.ibm.epm.web.core.app.internal.Util;
    
    
    /*
     Displays a confirmation dialog. Takes the following parameters:
     imgSrc: Source of the image to be displayed
     dialogQuestion: Question to be displayed
     buttonOne: first button's label
     buttonTwo: second button's label
     */
    dojo.declare("com.ibm.epm.web.core.app.internal.common.ConfirmationDialog", [dijit._Widget, dijit._Templated], {
    
        templatePath: dojo.moduleUrl("com.ibm.epm.web.core", "app/internal/common/templates/ConfirmationDialog.html"),
        
        constructor: function(args){
            this._controller = args.controller;
            this._imgSrc = args.imgSrc;
            this._dialogQuestion = args.dialogQuestion;
            this._buttonOne = args.buttonOne;
            this._buttonTwo = args.buttonTwo;
        },
        
        postCreate: function(){
            this.messageImg.src = this._imgSrc;
            
            Util.removeChildren(this.dialogQuestion);
            this.dialogQuestion.appendChild(document.createTextNode(this._dialogQuestion));
            
            if (this._buttonOne != null) {
                Util.removeChildren(this.buttonOne);
                this.buttonOne.appendChild(document.createTextNode(this._buttonOne));
            }
            else {
                this.buttonContainer.removeChild(this.buttonOne);
            }
            
            if (this._buttonTwo != null) {
                Util.removeChildren(this.buttonTwo);
                this.buttonTwo.appendChild(document.createTextNode(this._buttonTwo));
            }
            else {
                this.buttonContainer.removeChild(this.buttonTwo);
            }
        }
    });
    
})();
