/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

(function(){
    dojo.provide("com.ibm.epm.impex.web.client.internal.DocumentClient");
    
    dojo.require("com.ibm.epm.web.core.transport.EPMServerClient");
    dojo.require("com.ibm.epm.web.core.transport.ServiceRequest");
    
    var ServiceRequest = com.ibm.epm.web.core.transport.ServiceRequest;
    var EpmServerClient = com.ibm.epm.web.core.transport.EPMServerClient;
    
    com.ibm.epm.impex.web.client.internal.DocumentClient = {
        _BASE_URI: "epm/resources/",
        _DOCUMENT_URI: "epm/resources/document",
        
        getURI: function(responseHandler, uri){
            var serviceRequest = new ServiceRequest(this._BASE_URI + uri, "get");
            EpmServerClient.operateOnResource(serviceRequest, responseHandler);
        },
        
        postDocument: function(responseHandler, args){
            var serviceRequest = new ServiceRequest(this._DOCUMENT_URI, "post", args);
            EpmServerClient.operateOnResource(serviceRequest, responseHandler);
        },
        
        deleteDocument: function(responseHandler, id){
            var serviceRequest = new ServiceRequest(this._DOCUMENT_URI + "/" + id, "delete", null);
            EpmServerClient.operateOnResource(serviceRequest, responseHandler);
        },
        
        updateDocument: function(responseHandler, id, args){
            var serviceRequest = new ServiceRequest(this._DOCUMENT_URI + "/" + id, "post", args);
            EpmServerClient.operateOnResource(serviceRequest, responseHandler);
        }
    };
})();
