/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

(function(){
    dojo.provide("com.ibm.epm.financial.web.client.internal.FinancialClient");
    
    dojo.require("com.ibm.epm.web.core.transport.EPMServerClient");
    dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
    
    var ServiceRequest = com.ibm.team.repository.web.transport.ServiceRequest;
    var EpmServerClient = com.ibm.epm.web.core.transport.EPMServerClient;
    
    com.ibm.epm.financial.web.client.internal.FinancialClient = {
    
        _TIMECODE_URI: "epm/resources/timecode",
        _CHARGECODE_URI: "epm/resources/chargecode",
        _BASE_URI: "epm/resources",
        
        getAllResources: function(responseHandler){
            var serviceRequest = new ServiceRequest(this._CHARGECODE_URI, "get");
            EpmServerClient.operateOnResource(serviceRequest, responseHandler);
        },
        getProject: function(responseHandler, uri){
            var serviceRequest = new ServiceRequest(this._BASE_URI + uri, "get");
            EpmServerClient.operateOnResource(serviceRequest, responseHandler);
        },
        
        getChargeCode: function(responseHandler, uri){
            var serviceRequest = new ServiceRequest(this._BASE_URI + uri, "get");
            EpmServerClient.operateOnResource(serviceRequest, responseHandler);
        },
        
        saveChargeCode: function(responseHandler, uri, params){
            var serviceRequest = new ServiceRequest(this._BASE_URI + "/" + uri, "post", params);
            EpmServerClient.operateOnResource(serviceRequest, responseHandler);
        }
        
        
    };
})();
