 /*******************************************************************************
 * Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
 (function() { //module container
dojo.provide("com.ibm.epm.web.core.client.internal.QueryClient");

dojo.require("com.ibm.team.process.web.client.projectarea");
dojo.require("com.ibm.epm.web.core.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");
dojo.require("net.jazz.ajax.toolbox.lang.internal.Lang");

dojo.require("com.ibm.team.workitem.web.client.internal.query.AttributeExpression");
dojo.require("com.ibm.team.workitem.web.client.internal.query.SimilarityExpression");
dojo.require("com.ibm.team.workitem.web.client.internal.query.Term");
dojo.require("com.ibm.team.workitem.web.client.internal.query.Variable");
dojo.require("com.ibm.epm.web.core.transport.EPMServerClient");
dojo.require("com.ibm.epm.web.core.util.internal.DateUtil");

var DateUtil = com.ibm.epm.web.core.util.internal.DateUtil;
var checkNotNull 			= net.jazz.ajax.toolbox.lang.checkNotNull;
var checkNotEmpty 			= net.jazz.ajax.toolbox.lang.checkNotEmpty;
var findIf					= net.jazz.ajax.toolbox.lang.findIf;
var removeIf				= net.jazz.ajax.toolbox.lang.removeIf;

var getCurrentProjectArea	= com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;

//var ServiceRequest 			= com.ibm.team.repository.web.transport.ServiceRequest;
var ServiceRequest			= com.ibm.epm.web.core.transport.ServiceRequest;
var ServiceResponseHandler 	= com.ibm.team.repository.web.transport.ServiceResponseHandler;
var TeamServerClient 		= com.ibm.team.repository.web.transport.TeamServerClient;

var QUERY_SERVICE_URI		= "com.ibm.team.workitem.common.internal.rest.IQueryRestService";
var QUERY_EDITOR_SERVICE_URI= "com.ibm.team.workitem.common.internal.rest.IQueryEditorRestService";


var Term= com.ibm.team.workitem.web.client.internal.query.Term;
var AttributeExpression= com.ibm.team.workitem.web.client.internal.query.AttributeExpression;
var SimilarityExpression= com.ibm.team.workitem.web.client.internal.query.SimilarityExpression;
var Variable= com.ibm.team.workitem.web.client.internal.query.Variable;
var _RESOURCE_URI = "epm/query";
var _QUERY_EDITOR_URI = "epm/queryPresentation";
var EPMServerClient = com.ibm.epm.web.core.transport.EPMServerClient;

var searchAvailURI = "service/com.ibm.epm.availablitySearch.IAvailablitySearch";

// Expression for Exception Query
//var exceptionJsonExpression = {
//	attributeExpressions:  this.convertAttributeExprToString( [
//			{
//				attributeId: "toDate", 
//				operator: "after",
//				values: ["startDateOfInterval"],
//				variables: []
//			},
//			{
//				attributeId: "fromDate",
//				operator : "before",
//				values: ["finishDateOfInterval"],
//				variables: []}, 
//			{
//				attributeId: "link:com.ibm.epm.calendar.exception:source/selfURI", 
//				operator: "is", 
//				values: ["calendarURI"],
//				variables: []
//			}
//    ]),
//	termExpressions: [],
//	similarityExpressions: [],
//	operator: "AND"
//};
//
// Expression for Profile replacement Query
//var profileReplaceMentJsonExpression = {
//	attributeExpressions: 
//			[{
//				attributeId: "link:com.ibm.epm.resource.skills:target/name", 
//				operator: "matches",
//				values: ["skill"],
//				variables: []
//			}],
//    
//	termExpressions: [],
//	similarityExpressions: [],
//	operator: "AND"
//};
			

com.ibm.epm.web.core.client.internal.QueryClient= {

	SCOPE_PERSONAL: 0,
	SCOPE_OTHER_CONTRIBUTORS: 1,
	SCOPE_TEAM_AREA: 2,
	SCOPE_PROJECT_AREA: 3,
	
	PROCESS_REPORT_OK: 0,
	PROCESS_REPORT_WARNING: 2,
	PROCESS_REPORT_ERROR: 4, 
	
	///////////////////////////////////////////////////////////////////////////////////
	// Query Execution Helper
	///////////////////////////////////////////////////////////////////////////////////
	_executeQuery:function(responseHandler,queryID){
		
		var projectAreaName = getCurrentProjectArea().name;
		var getQueryResultURI = _RESOURCE_URI + "/" + queryID +"?execute=true&projectArea=" +projectAreaName;
		
		var serviceRequest= new ServiceRequest(
					getQueryResultURI,
					"get");
		EPMServerClient.operateOnResource(serviceRequest, responseHandler);	
	},
	
	
	
	
	 //TODO : POC
	 executeQueryForException:function(startDateOfInterval,finishDateOfInterVal,calendarURI){
	 	
		var jsonExpression1 = '{"attributeExpressions": [{"attributeId": "toDate", "operator": "after", "values":'+ 
			 '["' +  startDateOfInterval  +
			' ], "variables": []}, {"attributeId": "fromDate", "operator": "before", "values": ' +
			'["' + finishDateOfInterval  + ' "], "variables" ' +
			': []}, {"attributeId": "link:com.ibm.epm.calendar.exception:source/selfURI", "operator" '+
			': "is", "values": [" ' + calendarURI +  '"], "variables": []}], "termExpressions": [], "similarityExpressions"'+
			': [], "operator": "AND"}';
	 	
		
	 },
        _executeQuery_avail: function(responseHandler, queryId ,queryParameterForAvailablitySearch){
            
			var args = {};
			if (queryId && queryParameterForAvailablitySearch.startDate && (queryParameterForAvailablitySearch.endDate || queryParameterForAvailablitySearch.effort)) {
				args.queryId = queryId;
				args.startDate = queryParameterForAvailablitySearch.startDate;
				if(queryParameterForAvailablitySearch.endDate){
					args.endDate = queryParameterForAvailablitySearch.endDate;
				}
				args.projectId = queryParameterForAvailablitySearch.projectId;
				args.searchScope = queryParameterForAvailablitySearch.searchScope;
				args.searchType =queryParameterForAvailablitySearch.searchType;
				args.searchLevel =queryParameterForAvailablitySearch.searchLevel;
				if( queryParameterForAvailablitySearch.contour && !isNaN(queryParameterForAvailablitySearch.contour))
					args.contour = queryParameterForAvailablitySearch.contour;
				if (queryParameterForAvailablitySearch.effort) {
					args.effort = queryParameterForAvailablitySearch.effort;
				}
				
				var serviceRequest = new ServiceRequest(searchAvailURI, "get", args);
				
				EPMServerClient.operateOnResource(serviceRequest, responseHandler);
			}
			else{
				
				 throw "Invalid Query parameters";
			}
        },
	
	  _executeQuery_Avail_Json: function(responseHandler,queryParameterForUserSearch){
//		Example of json expression
//		{"attributeExpressions":[
//			{"attributeId":"link:com.ibm.epm.resource.skillassignment:target/skill/name","operator":"is","values":["skill1"],"variables":[]},
//			{"attributeId":"link:com.ibm.epm.resource.skillassignment:target/skill/name","operator":"is","values":["skill2"],"variables":[]},
//			{"attributeId":"link:com.ibm.epm.resource.competencyassignment:target/competency/name","operator":"is","values":["comp1"],"variables":[]},
//			{"attributeId":"link:com.ibm.epm.resource.competencyassignment:target/competency/name","operator":"is","values":["comp2"],"variables":[]}
//		],
//		"termExpressions":[],"similarityExpressions":[],"operator":"AND"}

//		Cache all the skills or/and compentencies in an array
//		Then prepare the comma separated json expression from this array
		var args = {};
		var strvar = new dojox.string.Builder('{"attributeExpressions":[');
		var strArrayofSkillsAndCompetency = [];			
		var skillVals = queryParameterForUserSearch.skill ;
		if(skillVals != null)
		{
			for(var i in skillVals)
			{
				if(skillVals[i] != null)
				{
					strArrayofSkillsAndCompetency.push( '{"attributeId":"link:com.ibm.epm.resource.skillassignment:target/skill/name","operator":"contains","values":["' + 
						skillVals[i] + 
						'"],"variables":[]}');
				}
			}
		}
		var compVals = queryParameterForUserSearch.competency;
		if(compVals)
		{
			for(var i in compVals)
			{
				if(compVals[i] != null)
				{
					strArrayofSkillsAndCompetency.push( '{"attributeId":"link:com.ibm.epm.resource.competencyassignment:target/competency/name","operator":"contains","values":["' + 
						compVals[i] + 
						'"],"variables":[]}');
				}
			}
		}
		
		for( i=0; i<strArrayofSkillsAndCompetency.length; i++){
			strvar.append(strArrayofSkillsAndCompetency[i]);
			if( i < strArrayofSkillsAndCompetency.length - 1) {
				strvar.append(',');
			}
		}
		strvar.append('],"termExpressions":[],"similarityExpressions":[],"operator":"AND"}');
		var jsonExpressionVal = strvar.toString();
		args.execute =	"true";
		args.filterAttribute = "";	
		args.filterValue = "";	
		args.jsonExpression	= jsonExpressionVal;
		args.maxResults ="50";
		//args.projectArea = "Tara"; //ProjectArea is no longer required for query
		args.startIndex	= "0";
		args.type =	"user";
		
        var userStartDate = (DateUtil.parseDate(queryParameterForUserSearch.startDate) != null);
		
		var userEndDate =  (DateUtil.parseDate(queryParameterForUserSearch.endDate) != null);
		if (userStartDate && userEndDate) {
			args.startDate = queryParameterForUserSearch.startDate;
			args.endDate = queryParameterForUserSearch.endDate;
			args.projectId = queryParameterForUserSearch.projectId;
			args.searchScope = queryParameterForUserSearch.searchScope;
			args.searchType =queryParameterForUserSearch.searchType;
			args.searchLevel =queryParameterForUserSearch.searchLevel;
			if (queryParameterForUserSearch.effort) {
				args.effort = queryParameterForUserSearch.effort;
			}
			var serviceRequest = new ServiceRequest(searchAvailURI, "post", args);
			
			EPMServerClient.operateOnResource(serviceRequest, responseHandler);
		}
		else{
			 throw "Invalid Query parameters";
		}
	},
	
	/*
	 * Get the query details from the server like name, id 
	 */
	_getQueryDetails:function(responseHandler,queryID){
		
		var getQueryResultURI = _RESOURCE_URI + "/" + queryID ;
		
		var serviceRequest= new ServiceRequest(
					getQueryResultURI,
					"get");
					
		EPMServerClient.operateOnResource(serviceRequest, responseHandler,true);	
	},
	///////////////////////////////////////////////////////////////////////////////////
	// Service invocation helpers
	///////////////////////////////////////////////////////////////////////////////////

	_invokeJsonService: function(responseHandler, method, appArgs) {
		var actualArgs= {};
		if (appArgs) {
			var jsonArgs= dojo.toJson(appArgs); //0.9
			actualArgs.jsonString= jsonArgs;
			actualArgs.projectAreaItemId= getCurrentProjectArea().itemId;
		}
		var serviceRequest= new ServiceRequest(QUERY_SERVICE_URI, method, actualArgs);
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	},
	
	_invokeQueryService: function(responseHandler, method, appArgs) {
		this._invokeService(QUERY_SERVICE_URI, responseHandler, method, appArgs);
	},
	
	_invokeQueryURI: function(responseHandler, method, appArgs) {
		
		var resourceRequest = new ServiceRequest(_RESOURCE_URI, method, appArgs);
		
		// Modifications to adapt to the new changes in the server side for query - surya
		// Check if the args contains value for _hasSoapEnvelop (This parameter wud be sent from 
		// _internalGetResultsSet() of QueryEditorPageController
		// If yes.. pass the value else pass the default value - true
		
		if (appArgs && appArgs._noSoapEnvelopProcessing) {
			EPMServerClient.operateOnResource(resourceRequest, responseHandler, false);
		}
		else {
			EPMServerClient.operateOnResource(resourceRequest, responseHandler, true);
		}
	},
	
	
	_invokeQueryEditorService: function(responseHandler, method, appArgs) {
		this._invokeService(QUERY_EDITOR_SERVICE_URI, responseHandler, method, appArgs);
	},

	_invokeQueryEditorURI: function(responseHandler, method, appArgs) {
		var resourceRequest = new ServiceRequest(_QUERY_EDITOR_URI, method, appArgs);
		EPMServerClient.operateOnResource(resourceRequest,responseHandler, true);
	},
	
	_invokeService: function(service, responseHandler, method, appArgs) {
		
		// appArgs is optional, so test whether or not it was sent
		if (!appArgs) {
			var serviceRequest= new ServiceRequest(service, method, { projectAreaItemId : getCurrentProjectArea().itemId });
		} else {
			appArgs.projectAreaItemId= getCurrentProjectArea().itemId;
			serviceRequest= new ServiceRequest(service, method, appArgs);
		}
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	},
	
	///////////////////////////////////////////////////////////////////////////////////
	// IQueryRestService API
	///////////////////////////////////////////////////////////////////////////////////
	
	/**
	 * Loads a query by its itemId in partial state ({@link IQueryDescriptor#SMALL_PROFILE}, 
	 * excluding the expression.
	 * @return The query including its common attributes like name, as a QueryDTO in its JavaScript representation.
	 * 
	 * @see IQueryRestService#getQuery
	 */
	getQuery: function(queryType, serviceResponseHandler, itemId, includeCount) {
		if (!itemId) {
			itemId = "";
		}
		includeCount= includeCount ? true : false;
		
		this._invokeQueryService(serviceResponseHandler, "getQuery", {itemId: itemId, includeCount: includeCount });
	},
	
	/**
	 * Loads a query by its itemId or id in partial state ({@link IQueryDescriptor#SMALL_PROFILE}, 
	 * excluding the expression.
	 * 
	 * @param args.itemId (UUID) The itemId of the QueryDescriptor
	 * @param args.id (String) Alternatively, the id of the QueryDescriptor as specified in the process spec
	 * @param args.includeCount (boolean) Include the current result count of the query 
	 * @return The query including its common attributes like name, as a QueryDTO in its JavaScript representation.
	 * @see IQueryRestService#getQuery
	 */
	getQuery2: function(queryType, serviceResponseHandler, args) {
		this._invokeQueryService(serviceResponseHandler, "getQuery", args);
	},
	
	/**
	 * Loads a number of queries by their itemId in partial state ({@link IQueryDescriptor#SMALL_PROFILE}, 
	 * excluding the expression.
	 * @return The queries (QueryDTO[])
	 * 
	 * @see IQueryRestService#getQueries
	 */
	getQueries: function(queryType, serviceResponseHandler, /* String[] */ itemIds, /* boolean */ includeCount) {
		if (!itemIds) {
			itemIds = [];
		}
		includeCount= includeCount ? true : false;
		this._invokeQueryService(serviceResponseHandler, "getQueries", {itemIds: itemIds, includeCount: includeCount });
	},

	/**
	 * Loads a number of queries by their itemId or id in partial state ({@link IQueryDescriptor#SMALL_PROFILE}, 
	 * excluding the expression.
	 * 
	 * @param args.itemIds (UUID[]) The itemIds of the QueryDescriptors
	 * @param args.ids (String[]) The ids of the QueryDescriptors as specified in the process spec
	 * @param args.includeCount [boolean] Include the current result count of the queries
	 * @return The queries (QueryDTO[])
	 * @see IQueryRestService#getQueries
	 */
	getQueries2: function(queryType, serviceResponseHandler, args) {
		this._invokeQueryService(serviceResponseHandler, "getQueries", args);
	},
	
	/**
	 * Loads a number of queries by their sharing scope in partial state ({@link IQueryDescriptor#SMALL_PROFILE}, 
	 * excluding the expression.
	 * @return The query descriptors (ScopedQueriesDTO[])
	 * 
	 * @param scope See the SCOPE_ constants defined above
	 * 		0: personal queries
	 * 		1: individually shared queries
	 * 		2: queries shared by team area
	 * 		3: queries shared by project area
	 * @param scopeItemId 
	 * 		The itemId of the item corresponding to the scope: Contributor, TeamArea or Project Area
	 * @param includeCount 
	 * 		Include the current query counts
	 * @param includeParentScopes 
	 * 		Include the scopes above the one specified, e.g. queries shared individually with the user,
	 * 		queries shared with the contributor's team areas and queries shared across the current project area if scope == 0
	 * 
	 * @see IQueryRestService#getScopedQueries
	 */
	/* ScopedQueriesDTO[] */ getScopedQueries: function(queryType, serviceResponseHandler, /* int */ scope, /* String */ scopeItemId, /* boolean */ includeCount, /* boolean */ includeParentScopes) {
		includeCount= includeCount ? true : false;
		includeParentScopes= includeParentScopes ? true : false;
		var args = {scope: scope, scopeItemId: scopeItemId, includeCount: includeCount, includeParentScopes: includeParentScopes, operation: 0, projectArea : getCurrentProjectArea().name, type : queryType, ownerId: scopeItemId };
		this._invokeQueryURI(serviceResponseHandler, "get", args);
	},
	
	/**
	 * Breaks the query results down by a specific attribute
	 * 
	 * @param args.queryItemId (UUID) The itemId of the QueryDescriptor
	 * @param args.attributeId (String) The attribute id (see WorkItemAttributes.js)
	 * @param args.includeCount (boolean, optional, default=true) Include the current result count of the query
	 * @return The histogram (see HistogramDTO)
	 * @see IQueryRestService#getHistogram
	 */
	getHistogram: function(queryType, serviceResponseHandler, args) {
		this._invokeQueryService(serviceResponseHandler, "getHistogram", args);
	},
	
	
	/**
	 * @deprecated Use getEditableQuery instead
	 * 
	 * Loads a query by its itemId in full state ({@link IQueryDescriptor#FULL_PROFILE}, 
	 * including the expression.
	 * @return The query including its expression tree as a QueryDTO in its JavaScript representation.
	 * 
	 * @see IQueryRestService#getQuery
	 */
	getCompleteQuery: function(queryType, serviceResponseHandler, itemId, includeCount) {
		if (!itemId) {
			itemId = "";
		}
		includeCount= includeCount ? true : false;
		this._invokeQueryService(serviceResponseHandler, "getQuery", {itemId: itemId, includeExpression: true, includeCount: includeCount});
	},
	
	/**
	 * @deprecated Use getResultSet instead
	 * 
	 * Executes a query and returns one page of the result set. 
	 * The use of the parameters is different when the query is initially
	 * executed and for subsequent calls to fetch additional data.
	 * 
	 * The initial call has to specify startIndex, maxResults and jsonQuery.
	 * Subsequent calls have to specifyx startIndex, maxResults and token. The
	 * jsonQuery parameters is optional and only used if the query result identified
	 * by token is not available anymore and the query has to be executed.
	 * 
	 * @param startIndex The index of the first work item to be included in the result page,
	 * 		relative to the entire result set.
	 * @param maxResults The number of results that should be returned.
	 * @param token The token identifying the result set. This token is available
	 * 		from the WorkItemSummaryPage that was returned in the initial call.
	 *		Note: This is not true yet. The token field has to be added to WorkItemSummaryPage first.
	 * @param query
	 * 		The query as retrieved by getQueriesForOwner or getPredefinedQueries or getQuery. If the
	 * 		query is stored in the repository, a simple object like { itemId: ... } is sufficient, too.
	 * @param orderAttributes
	 *      An array of attribute identifiers that describes which columns are to be sorted.
	 *		E.g. [ "modifiedDate" ]
	 * @param orderDirections
	 *		A boolean array of the same size as orderAttributes, that specifies for each attribute if
	 *		the order direction should be ascending (true) or descending (false).
	 *		E.g. [ true ]
	 * 
	 * Returns the JavaScript representation of an IWorkItemSummaryPage
	 */
	execute: function(queryType, startIndex, maxResults, token, query, orderAttributes, orderDirections, serviceResponseHandler) {
		var args= new Object();
		args.startIndex= startIndex;
		args.maxResults= maxResults;
		args.token= token;
		args.jsonQuery= dojo.toJson(query); //0.9
		args.orderAttributes= orderAttributes;
		args.orderDirections= orderDirections;
		args.type= queryType;
		this._invokeQueryService(serviceResponseHandler, "postExecute", args);
	},
	
	/**
	 * @param {QueryDTO} query
	 * @param {Object} args
	 * 		An object with the following properties set:
	 * 		- {int} startIndex [0..]
	 * 		- {int} maxResults [0..500]
	 * 		- {String/UUID} projectAreaItemId
	 * 		- {String/UUID} itemId
	 * 		- {String} id
	 * 		- {String[]} columnIdentifiers (optional)
	 * 		- {Object[]} sortOrder (optional)
	 * 		- {UUID} token (optional)
	 * 		
	 * @param {Object} serviceResponseHandler
	 * @return A ResultSetDTO
	 */
	getResultSet: function(queryType, query, userArgs, serviceResponseHandler) {
		
		var args= dojo.clone(userArgs);
		args.type=queryType;
		
		if (!args.resultColumns) {
			args.resultColumns = [];
		}
	
		if (!args.filterAttribute) {
			args.filterAttribute = "";
		}

		if (!args.filterValue) {
			args.filterValue = "";
		}
			
		if (args.sortOrder) {
			var sortColumns= new Array();
			var sortDirections= new Array();
			for (var i= 0; i < args.sortOrder.length; i++) {
				var sortColumn= args.sortOrder[i];
				sortColumns.push(sortColumn.id);
				sortDirections.push(sortColumn.ascending);
			}
			args.sortColumns= sortColumns;
			args.sortDirections= sortDirections;
			delete args.sortOrder;
		}
			
		// compatibility
		if (query) {
			
			if (query.itemId) {
				args.itemId= query.itemId;
			}
			
			if (query.id) {
				args.id= query.id;
			}
			
			args.execute = true;
		
			args.projectArea= getCurrentProjectArea().name;
					
			if (!args.jsonExpression) {
				if (query.internalExpression) {
					args.jsonExpression= dojo.toJson(query.internalExpression._term); //query.internalExpression.serialize();
				} else {
					args.jsonQuery= dojo.toJson(query); //0.9
				}
			}
		}
		this._invokeQueryURI(serviceResponseHandler, "post", args);
	},
	
	/**
	 * @deprecated Use getResultSet instead
	 * See IQueryRestService#getResults
	 */
	getResults: function(queryType, args, serviceResponseHandler) {
		this._invokeQueryService(serviceResponseHandler, "getResults", args);
	},
	
	/**
	 * See IQueryRestService#getQueriesForOwner.
	 */
	getQueriesForOwner: function(queryType, appArgs, serviceResponseHandler) {
		appArgs.getQueriesForOwner = true;
		appArgs.type= queryType;
		appArgs.projectArea = getCurrentProjectArea().name;	
		appArgs.operation = "0";
		this._invokeQueryURI(serviceResponseHandler, "get", appArgs);
	},
	
	getTime: function(responseHandler, appArgs) {
		appArgs.getTime= true;
		appArgs.projectArea = getCurrentProjectArea().name;	
		appArgs.operation = "0";
		//WorkItemClient._invokeWorkItemService(responseHandler, "getTime", appArgs);
		this._invokeQueryURI(responseHandler, "get", appArgs);
	},
	/**
	 * See IQueryRestService#getDefaultQuery.
	 */
	getDefaultQuery: function(queryType, serviceResponseHandler) {
		this._invokeQueryService(serviceResponseHandler, "getDefaultQuery");
	},
	
	deleteQuery: function(queryType, itemId, serviceResponseHandler) {
		var args= { type: queryType,  itemId: itemId, projectArea: getCurrentProjectArea().name ,deleteQuery: true};		
		
		var deleteURI = _RESOURCE_URI + "/" + itemId ;
		var resourceRequest = new ServiceRequest(deleteURI, "delete", args);
		
		EPMServerClient.operateOnResource(resourceRequest, serviceResponseHandler, false);

	},
	
	
	///////////////////////////////////////////////////////////////////////////////////
	// IQueryEditorRestService API
	///////////////////////////////////////////////////////////////////////////////////
	
	/* TreeDTO<AttributeDTO> */ getAttributeTree: function(queryType, serviceResponseHandler) {
		var args= { type: queryType, operation: 2, projectArea: getCurrentProjectArea().name };
		this._invokeQueryEditorURI(serviceResponseHandler, "get", args);
	},
		/* TreeDTO<AttributeDTO> */ getAttributeTreeForQuery: function(queryType, serviceResponseHandler, qid) {
		var args= { type: queryType, operation: 2, projectArea: getCurrentProjectArea().name, queryId: qid };
		this._invokeQueryEditorURI(serviceResponseHandler, "get", args);
	},
	/* PresentationDTO */ getPresentation: function(queryType, serviceResponseHandler, /* String */ attributeId) {
		checkNotNull(attributeId);
		var args= { type: queryType,  attributeIdentifier: attributeId, projectArea: getCurrentProjectArea().name ,operation: "5"};
		this._invokeQueryEditorURI(serviceResponseHandler, "get", args);
	},
	
	saveQuery: function(queryType, serviceResponseHandler, userArgs) {
		
		var args= dojo.clone(userArgs);
		args.type= queryType;
		args.SaveQuery = true;
		args.projectArea= getCurrentProjectArea().name;
		
		if (args.expression) {
			args.jsonExpression= args.expression.serialize();
			delete args.expression;
		}

		var setArguments= new Array();
		args.setArguments= setArguments;
		
		if (args.teamAreaAssociations) {
			setArguments.push("teamAreaAssociations");
		}
			
		if (args.contributorAssociations) {
			setArguments.push("contributorAssociations");
		}
			
		if (args.resultColumns) {
			setArguments.push("resultColumns");
		}
			
		if (args.sortColumns) {
			setArguments.push("sortColumns");
		}
			
			
		this._invokeSaveQueryURI(serviceResponseHandler, "post", args);
	},
	
	_invokeSaveQueryURI: function(responseHandler, method, appArgs) {
		
		// If the appArgs has ItemId then the call is for update query
		// else create a new query
		var uri = _RESOURCE_URI;
		if(appArgs.itemId){
			
			uri = uri + "/" + appArgs.itemId;
			// Set this flag to true so that EPMServerClient.operateOnResource is called with hasSoapEnvelope=false
			// Note: This needs to be set for get [its done in _internalGetResultsSet() of QueryEditorPageController]
			// and update which is done below but not for create
			appArgs._noSoapEnvelopProcessing = true;
		}
		var resourceRequest = new ServiceRequest(uri, method, appArgs);
		
		// Modifications to adapt to the new changes in the server side for query - surya
		// Check if the args contains value for _hasSoapEnvelop (This parameter wud be sent from 
		// _internalGetResultsSet() of QueryEditorPageController
		// If yes.. pass the value else pass the default value - true
		
		if (appArgs && appArgs._noSoapEnvelopProcessing) {
			EPMServerClient.operateOnResource(resourceRequest, responseHandler, false);
		}
		else {
			EPMServerClient.operateOnResource(resourceRequest, responseHandler, true);
		}
	},
	
	getEditableQuery: function(queryType, serviceResponseHandler, /* UUID */ itemId) {
		
		var args= new Object();
		args.type= queryType;
		if (itemId) 
		{
			args.queryId = itemId;
			args.operation= "1";
		}
		else
		{
			args.operation= "0";
		}
		args.projectArea= getCurrentProjectArea().name;
		
		this._invokeQueryEditorURI(serviceResponseHandler, "get", args);
	},
	
	///////////////////////////////////////////////////////////////////////////////////
	// Client side query creation
	///////////////////////////////////////////////////////////////////////////////////
	
	/* QueryDTO */ createFulltextQuery: function(queryType, /* String */ queryName, /* String */ pattern, /* boolean */ openOnly) {
		
		var term= new Term(Term.AND);
		var patternExpression= new AttributeExpression("all", "contains", [ pattern ]);
		term.addAttributeExpression(patternExpression);
		
		if (openOnly) {
			var openStateVariable= new Variable("state", "open or in progress");
			var stateExpression= new AttributeExpression("internalState", "is");
			stateExpression.setVariables([ openStateVariable ]);
			term.addAttributeExpression(stateExpression);
		}
		
		return { name: queryName, internalExpression: term, itemId: ""};
	},
	
	createSimilarityQuery: function(queryType, queryName, itemId, summary, content) {

		var similarityExpression= new SimilarityExpression();
		if (arguments.length > 2) {
			similarityExpression.setContent(summary, content);
		}
		similarityExpression.setWorkItem(itemId);

		var term= new Term(Term.AND);
		term.addSimilarityExpression(similarityExpression);

		return { name: queryName, internalExpression: term, itemId: ""};
	}
	


};
 
})();