/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

(function(){
    dojo.provide("com.ibm.epm.financial.web.client.internal.TimecodeClient");
    
    dojo.require("com.ibm.epm.web.core.transport.EPMServerClient");
    dojo.require("com.ibm.epm.web.core.transport.ServiceRequest");
    
    var ServiceRequest = com.ibm.epm.web.core.transport.ServiceRequest;
    var EpmServerClient = com.ibm.epm.web.core.transport.EPMServerClient;
    
    com.ibm.epm.financial.web.client.internal.TimecodeClient = {
        _BASE_URI: "epm/resources",
        _TIMECODE_URI: "epm/resources/timecode",
        
        /**
         *  getTimecode : This function is to retrive a timecode details
         *  Incoming Arguments : responseHandler, uri
         *  Outgoing Argument :
         *
         */
        getTimecode: function(responseHandler, uri){
            var serviceRequest = new ServiceRequest(this._BASE_URI + uri, "get");
            EpmServerClient.operateOnResource(serviceRequest, responseHandler);
        },
        /**
         *  getTimecode : This function is to retrive a project details
         *  Incoming Arguments : responseHandler, uri
         *  Outgoing Argument :
         *
         */
        getProject: function(responseHandler, uri){
            var serviceRequest = new ServiceRequest(this._BASE_URI + uri, "get");
            EpmServerClient.operateOnResource(serviceRequest, responseHandler);
        },
        /**
         *  getTimecode : This function is to save the proejct timecode association details
         *  Incoming Arguments : responseHandler, uri, params
         *  Outgoing Argument :
         *
         */
        saveTimecode: function(responseHandler, uri, params){
            var serviceRequest = new ServiceRequest(this._BASE_URI + "/" + uri, "post", params);
            EpmServerClient.operateOnResource(serviceRequest, responseHandler);
        },
        
        /**
         *  getTimecode : This function is to retrive all the root level timecodes
         *  Incoming Arguments : responseHandler
         *  Outgoing Argument :
         *
         */
        getAllTimecodes: function(responseHandler){
            var serviceRequest = new ServiceRequest(this._TIMECODE_URI, "get");
            EpmServerClient.operateOnResource(serviceRequest, responseHandler);
        },
        
        /**
         *  getTimecode : This function is to save a timecode details
         *  Incoming Arguments : responseHandler, args
         *  Outgoing Argument :
         *
         */
        postTimecode: function(responseHandler, args){
            var serviceRequest = new ServiceRequest(this._TIMECODE_URI, "post", args);
            EpmServerClient.operateOnResource(serviceRequest, responseHandler);
        }
    };
})();
