/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

(function(){
    dojo.provide("com.ibm.epm.admin.web.client.internal.chargecodes.ChargecodesClient");
    
    dojo.require("com.ibm.epm.web.core.transport.EPMServerClient");
    dojo.require("com.ibm.epm.web.core.transport.ServiceRequest");
    
    var ServiceRequest = com.ibm.epm.web.core.transport.ServiceRequest;
    var EpmServerClient = com.ibm.epm.web.core.transport.EPMServerClient;
    
    com.ibm.epm.admin.web.client.internal.chargecodes.ChargecodesClient = {
        _BASE_URI: "epm/resources",
        _CHARGECODE_URI: "epm/resources/chargecode",
        
        /**
         *  getChargecodes : This function calls the approriate service method to get all
         *   the charge codes in the repository
         *  Incoming Arguments : responseHandler, uri
         *  Outgoing Argument :
         *
         */
        getChargecodes: function(responseHandler, uri){
            var serviceRequest = new ServiceRequest(this._BASE_URI + uri, "get");
            EpmServerClient.operateOnResource(serviceRequest, responseHandler);
        },
        /**
         *  saveChargecode : This function calls appropriate service method for saving
         *  charge code in db
         *  Incoming Arguments : responseHandler, uri,params
         *  Outgoing Argument :
         *
         */
        saveChargecode: function(responseHandler, uri, params){
            var serviceRequest = new ServiceRequest(this._BASE_URI + uri, "post", params);
            EpmServerClient.operateOnResource(serviceRequest, responseHandler);
        },
        /**
         *  getAllChargecodes : This function calls the approriate service method to get all
         *   the charge codes in the repository
         *  Incoming Arguments : responseHandler
         *  Outgoing Argument :
         *
         */
        getAllChargecodes: function(responseHandler){
            var serviceRequest = new ServiceRequest(this._CHARGECODE_URI, "get");
            EpmServerClient.operateOnResource(serviceRequest, responseHandler);
        },
        /**
         *  postChargecode : This function helps appropriate service method for posting changes to charge code
         *  Incoming Arguments :
         *  Outgoing Argument :
         *
         */
        postChargecode: function(responseHandler, args){
            var serviceRequest = new ServiceRequest(this._CHARGECODE_URI, "post", args);
            EpmServerClient.operateOnResource(serviceRequest, responseHandler);
        },
        /**
         *  updateChargecode : This function helps calling appropriate service method for updating charge code
         *  charge code in db
         *  Incoming Arguments :
         *  Outgoing Argument :
         *
         */
        updateChargecode: function(responseHandler, id, args){
            var serviceRequest = new ServiceRequest(this._BASE_URI + "/" + id, "post", args);
            EpmServerClient.operateOnResource(serviceRequest, responseHandler);
        }
    };
})();
