/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

(function(){
    dojo.provide("com.ibm.epm.admin.web.client.internal.projectprofile.ProfilesClient");
    
    dojo.require("com.ibm.epm.web.core.transport.EPMServerClient");
    dojo.require("com.ibm.epm.web.core.transport.ServiceRequest");
    
    //Constants
    dojo.require("com.ibm.epm.admin.web.ui.internal.Util.Constants");
    
    var ServiceRequest = com.ibm.epm.web.core.transport.ServiceRequest;
    var EpmServerClient = com.ibm.epm.web.core.transport.EPMServerClient;
    var Constants = com.ibm.epm.admin.web.ui.internal.Util.Constants;
    
    com.ibm.epm.admin.web.client.internal.projectprofile.ProfilesClient = {
    
        _PROJECT_PROFILE_URI: "epm/resources/profile",
        _BASE_URI: "epm/resources/",
        _PROFILE_URI: "profile",
        
        getAllProfiles: function(responseHandler){
            this._invokeWorkService(responseHandler, "get", null);
        },
        
        getAllProjectsWithPagination: function(responseHandler, args){
            this._invokeWorkService(responseHandler, "get", args);
        },
        getURI: function(responseHandler, uri){
            var serviceRequest = new ServiceRequest(this._BASE_URI + uri, "get");
            EpmServerClient.operateOnResource(serviceRequest, responseHandler);
        },
        
        getLinksURI: function(responseHandler, uri){
            var serviceRequest = new ServiceRequest(this._BASE_URI + uri, "get");
            EpmServerClient.operateOnResource(serviceRequest, responseHandler);
        },
        
        deleteProfile: function(responseHandler, uri){
            var serviceRequest = new ServiceRequest(this._BASE_URI + "/" + uri, "delete", null);
            EpmServerClient.operateOnResource(serviceRequest, responseHandler);
        },
        
        postCreateProfile: function(responseHandler, args){
            this._invokeWorkService(responseHandler, "post", args);
        },
        
        /**
         * Invokes the requested method on the work REST service.
         */
        _invokeWorkService: function(responseHandler, method, args){
        
            var profileURI = this._PROJECT_PROFILE_URI;
            
            if (method == "post") {
            
                if (args.resourceID.indexOf(Constants.NEW_PROFILE) != -1) {
                
                    profileURI = this._PROJECT_PROFILE_URI;
                }
                else {
                    profileURI = this._BASE_URI + Constants.SLASH + args.resourceID;
                }
            }
            if (arguments.length == 2) {
                var serviceRequest = new ServiceRequest(profileURI, method);
            }
            else {
                serviceRequest = new ServiceRequest(profileURI, method, args);
            }
            EpmServerClient.operateOnResource(serviceRequest, responseHandler);
        }
    };
})();
