/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

(function(){
    dojo.provide("com.ibm.epm.web.core.grid.controller.ControllerUtil");
    
    dojo.require("com.ibm.epm.web.core.grid.controller.TreeBasedGridController");
	dojo.require("com.ibm.epm.web.core.grid.controller.TreeBasedGridController1");
    dojo.require("com.ibm.epm.web.core.grid.controller.EPMGridController");
    dojo.require("com.ibm.epm.web.core.grid.controller.EPMFinancialGridController");
    dojo.require("com.ibm.epm.web.core.grid.controller.EPMAssignmentGridController");
    dojo.require("com.ibm.epm.web.core.grid.controller.EPMGanttController");
    dojo.require("com.ibm.epm.admin.web.ui.internal.view.user.EPMUserGridController");
    
    
    function getTreeBasedGridController(controllerID){
        var controller = dijit.byId(controllerID);
        if (!controller) {
			if (controllerID == "com.ibm.epm.work.WBSGeneralGridController") {
			controller = new com.ibm.epm.web.core.grid.controller.TreeBasedGridController1({
					id: controllerID
				});
			}
			else {
				controller = new com.ibm.epm.web.core.grid.controller.TreeBasedGridController({
					id: controllerID
				});
			}
        }
        return controller;
    }
    com.ibm.epm.web.core.grid.controller.ControllerUtil.getTreeBasedGridController = getTreeBasedGridController;
    
    function getEPMGridController(controllerID){
        var controller = dijit.byId(controllerID);
        if (!controller) {
            controller = new com.ibm.epm.web.core.grid.controller.EPMGridController({
                id: controllerID
            });
        }
        return controller;
    }
    com.ibm.epm.web.core.grid.controller.ControllerUtil.getEPMGridController = getEPMGridController;
    
    function getEPMUserGridController(controllerID, collectionElement){
        var controller = dijit.byId(controllerID);
        if (!controller) {
            controller = new com.ibm.epm.admin.web.ui.internal.view.user.EPMUserGridController({
                id: controllerID,
                collectionElements: collectionElement
            });
        }
        return controller;
    }
    com.ibm.epm.web.core.grid.controller.ControllerUtil.getEPMUserGridController = getEPMUserGridController;
    
    function getEPMFinancialGridController(controllerID){
        var controller = dijit.byId(controllerID);
        if (!controller) {
            controller = new com.ibm.epm.web.core.grid.controller.EPMFinancialGridController({
                id: controllerID
            });
        }
        return controller;
    }
    com.ibm.epm.web.core.grid.controller.ControllerUtil.getEPMFinancialGridController = getEPMFinancialGridController;
    
    function getEPMAssignmentGridController(controllerID){
    
        var controller = dijit.byId(controllerID);
        
        if (!controller) {
            controller = new com.ibm.epm.web.core.grid.controller.EPMAssignmentGridController({
                id: controllerID
            });
        }
        return controller;
    }
    com.ibm.epm.web.core.grid.controller.ControllerUtil.getEPMAssignmentGridController = getEPMAssignmentGridController;
    
    function getGanttController(controllerID){
        var controller = dijit.byId(controllerID);
        if (!controller) {
            var params = {
                id: controllerID
            };
            controller = new com.ibm.epm.web.core.grid.controller.EPMGanttController(params);
        }
        return controller;
    }
    com.ibm.epm.web.core.grid.controller.ControllerUtil.getGanttController = getGanttController;
    
    
    
    
    function getLink(data, linkName){
        if (data && data[linkName]) {
            var links = data[linkName];
            return links;
        }
        return null;
    }
    com.ibm.epm.web.core.grid.controller.ControllerUtil.getLink = getLink;
    
    var randomNumberCount = 1;
    function getRandomNumber(){
        return randomNumberCount++;
    }
    com.ibm.epm.web.core.grid.controller.ControllerUtil.getRandomNumber = getRandomNumber;
})();
