/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

(function(){
    dojo.provide("com.ibm.epm.web.core.grid.controller.ControllersFactory");
    
    dojo.require("com.ibm.epm.web.core.grid.controller.EPMFinancialGridController");
    dojo.require("com.ibm.epm.web.core.grid.controller.EPMEstimateGridController");
    dojo.require("com.ibm.epm.web.core.grid.controller.EPMAssignmentGridController");
    dojo.require("com.ibm.epm.web.core.grid.controller.EPMRiskGridController");
    dojo.require("com.ibm.epm.web.core.grid.controller.EPMRiskGridQueryController");
    dojo.require("com.ibm.epm.web.core.grid.controller.EPMProjectProfileGridController");
    dojo.require("com.ibm.epm.web.core.grid.controller.EPMGanttController");
    dojo.require("com.ibm.epm.web.core.grid.controller.EPMRiskStrategiesGridController");
	dojo.require("com.ibm.epm.web.core.grid.controller.EPMRiskActionsGridController");
    dojo.require("com.ibm.epm.web.core.grid.controller.EPMRateAssignmentGridController");
	dojo.require("com.ibm.epm.web.core.grid.controller.EPMProfileSkillGridController");
	dojo.require("com.ibm.epm.web.core.grid.controller.EPMProfileCompetencyGridController");
	dojo.require("com.ibm.epm.web.core.ui.internal.WorkItems.WorkItemConfigurationsHandler");
	
	
	function getWIConfigHandler(){
        var handler = dijit.byId("com.ibm.epm.web.core.ui.internal.WorkItems.WorkItemConfigurationsHandler.instance");
        if (!handler) {
            var params = {
                id: "com.ibm.epm.web.core.ui.internal.WorkItems.WorkItemConfigurationsHandler.instance"
            };
            handler = new com.ibm.epm.web.core.ui.internal.WorkItems.WorkItemConfigurationsHandler(params);
        }
        return handler;
    }
    com.ibm.epm.web.core.grid.controller.ControllersFactory.getWIConfigHandler = getWIConfigHandler;
	
    function getGanttController(controllerID){
        var controller = dijit.byId(controllerID);
        if (!controller) {
            var params = {
                id: controllerID
            };
            controller = new com.ibm.epm.web.core.grid.controller.EPMGanttController(params);
        }
        return controller;
    }
    com.ibm.epm.web.core.grid.controller.ControllersFactory.getGanttController = getGanttController;
    
    function getEPMFinancialGridController(controllerID){
        var controller = dijit.byId(controllerID);
        if (!controller) {
            controller = new com.ibm.epm.web.core.grid.controller.EPMFinancialGridController({
                id: controllerID
            });
        }
        return controller;
    }
    com.ibm.epm.web.core.grid.controller.ControllersFactory.getEPMFinancialGridController = getEPMFinancialGridController;
    
    function getEPMEstimateGridController(controllerID){
        var controller = dijit.byId(controllerID);
        if (!controller) {
            controller = new com.ibm.epm.web.core.grid.controller.EPMEstimateGridController({
                id: controllerID
            });
        }
        return controller;
    }
    com.ibm.epm.web.core.grid.controller.ControllersFactory.getEPMEstimateGridController = getEPMEstimateGridController;
    
    function getEPMAssignmentGridController(controllerID){
    
        var controller = dijit.byId(controllerID);
        
        if (!controller) {
            controller = new com.ibm.epm.web.core.grid.controller.EPMAssignmentGridController({
                id: controllerID
            });
        }
        return controller;
    }
    com.ibm.epm.web.core.grid.controller.ControllersFactory.getEPMAssignmentGridController = getEPMAssignmentGridController;
    
    function getEPMRiskGridController(controllerID){
        var controller = dijit.byId(controllerID);
        if (!controller) {
            controller = new com.ibm.epm.web.core.grid.controller.EPMRiskGridController({
                id: controllerID
            });
        }
        return controller;
    }
    com.ibm.epm.web.core.grid.controller.ControllersFactory.getEPMRiskGridController = getEPMRiskGridController;
    
    function getEPMRiskGridQueryController(controllerID){
        var controller = dijit.byId(controllerID);
        if (!controller) {
            controller = new com.ibm.epm.web.core.grid.controller.EPMRiskGridQueryController({
                id: controllerID
            });
        }
        return controller;
    }
    com.ibm.epm.web.core.grid.controller.ControllersFactory.getEPMRiskGridQueryController = getEPMRiskGridQueryController;
    
    function getEPMProjectProfileGridController(controllerID){
    
        var controller = dijit.byId(controllerID);
        
        if (!controller) {
            controller = new com.ibm.epm.web.core.grid.controller.EPMProjectProfileGridController({
                id: controllerID
            });
        }
        return controller;
    }
    com.ibm.epm.web.core.grid.controller.ControllersFactory.getEPMProjectProfileGridController = getEPMProjectProfileGridController;
    
    /**
         *  getEPMRiskStrategiesGridController : This method is called from the grid view classes
         *  to load the specific controller for Risk strategies grid.
         *
         */
	function getEPMRiskStrategiesGridController(controllerID){
        var controller = dijit.byId(controllerID);
        if (!controller) {
            controller = new com.ibm.epm.web.core.grid.controller.EPMRiskStrategiesGridController({
                id: controllerID
            });
        }
        return controller;
    }
    com.ibm.epm.web.core.grid.controller.ControllersFactory.getEPMRiskStrategiesGridController = getEPMRiskStrategiesGridController;
    
	/**
         *  getEPMRiskActionsGridController : This method is called from the grid view classes
         *  to load the specific controller for Risk actions grid.
         *
         */
    function getEPMRiskActionsGridController(controllerID){
        var controller = dijit.byId(controllerID);
        if (!controller) {
            controller = new com.ibm.epm.web.core.grid.controller.EPMRiskActionsGridController({
                id: controllerID
            });
        }
        return controller;
    }
    com.ibm.epm.web.core.grid.controller.ControllersFactory.getEPMRiskActionsGridController = getEPMRiskActionsGridController;
    
    function getEPMRateAssignmentGridController(controllerID){
    
        var controller = dijit.byId(controllerID);
        
        if (!controller) {
            controller = new com.ibm.epm.web.core.grid.controller.EPMRateAssignmentGridController({
                id: controllerID
            });
        }
        return controller;
    }
    com.ibm.epm.web.core.grid.controller.ControllersFactory.getEPMRateAssignmentGridController = getEPMRateAssignmentGridController;
    
	function getEPMProfileSkillController(controllerID){
        var controller = dijit.byId(controllerID);
        if (!controller) {
            controller = new com.ibm.epm.web.core.grid.controller.EPMProfileSkillGridController({
                id: controllerID
            });
        }
        return controller;
    }
    com.ibm.epm.web.core.grid.controller.ControllersFactory.getEPMProfileSkillController = getEPMProfileSkillController;
    
	function getEPMProfileCompetencyController(controllerID){
        var controller = dijit.byId(controllerID);
        if (!controller) {
            controller = new com.ibm.epm.web.core.grid.controller.EPMProfileCompetencyGridController({
                id: controllerID
            });
        }
        return controller;
    }
    com.ibm.epm.web.core.grid.controller.ControllersFactory.getEPMProfileCompetencyController = getEPMProfileCompetencyController;
    
})();
