/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

(function(){
    dojo.provide("com.ibm.epm.web.core.grid.controller.EPMProfileCompetencyGridController");
    
    dojo.require("com.ibm.epm.web.core.grid.controller.EPMGridController");
    
    var abstractEPMGridController = com.ibm.epm.web.core.grid.controller.EPMGridController;
    
    dojo.declare("com.ibm.epm.web.core.grid.controller.EPMProfileCompetencyGridController", abstractEPMGridController, {
        /* 
         * initializeController calling the super function
         */
        initializeController: function(allElementsURI, viewer, model, linksToBeLoaded){
            // Calling super function			
            this.inherited(arguments);
            this.EPMCollection = allElementsURI;
        },
        
        /* 
         * buildGridModel - This function creates the grid model
         */
        buildGridModel: function(){
            this._get_n_updateModel();
			this._createBlankRow();
        },
        
        
        /* 
         * massageCodeLinks - This function will wrap the links into an array.
         */
        massageCodeLinks: function(massagedLinks, collectionElementsLinks){
            massagedLinks.push(collectionElementsLinks);
        },
        
		_getAndUpdateRow: function(rowURI, rowID, linkName){
			if(!this.EPMCollection.profile.competencyassignment){
				if (this.EPMCollection && this.EPMCollection.profile &&
				this.EPMCollection.profile.loadedelement &&
				this.EPMCollection.profile.loadedelement[0] &&
				this.EPMCollection.profile.loadedelement[0].competencyassignment) {
					this.EPMCollection.profile.competencyassignment = this.EPMCollection.profile.loadedelement[0].competencyassignment;
				}
			}
			if(this.EPMCollection.profile.competencyassignment && this.EPMCollection.profile.competencyassignment.length > 0){
				var asmts = this.EPMCollection.profile.competencyassignment;
				for (var k in asmts) {
					if ((asmts[k].id === rowURI) && !asmts[k].deleted) {
						var loaded = {
							relativeHref: asmts[k].id,
							id: asmts[k].id,
							name: asmts[k].competency ? asmts[k].competency.title : asmts[k].name,
							proficiencyLevel: asmts[k].proficiency ? asmts[k].proficiency.title : asmts[k].proficiencyLevel,
							competencyid: asmts[k].competency ? asmts[k].competency.relativeHref : asmts[k].competencyid,
							pid: asmts[k].proficiency ? asmts[k].proficiency.relativeHref : asmts[k].pid
						};
						this._updateGridRow(loaded, rowID, linkName);
					}
				}
			}
		},
		
        _get_n_updateModel: function(){
            if(!this.EPMCollection.profile.competencyassignment){
				if (this.EPMCollection && this.EPMCollection.profile &&
				this.EPMCollection.profile.loadedelement &&
				this.EPMCollection.profile.loadedelement[0] &&
				this.EPMCollection.profile.loadedelement[0].competencyassignment) {
					this.EPMCollection.profile.competencyassignment = this.EPMCollection.profile.loadedelement[0].competencyassignment;
				}
			}
			if(this.EPMCollection.profile.competencyassignment && this.EPMCollection.profile.competencyassignment.length > 0){
				var massagedLinks = new Array(1);
				var asmts = this.EPMCollection.profile.competencyassignment;
				for (var k in asmts) {
					if (!asmts[k].deleted) {
						var itemHandle = {
							relativeHref: asmts[k].id,
							id: asmts[k].id,
							name: asmts[k].competency ? asmts[k].competency.title : asmts[k].name,
							proficiencyLevel: asmts[k].proficiency ? asmts[k].proficiency.title : asmts[k].proficiencyLevel,
							competencyid: asmts[k].competency ? asmts[k].competency.relativeHref : asmts[k].competencyid,
							pid: asmts[k].proficiency ? asmts[k].proficiency.relativeHref : asmts[k].pid
						};
						massagedLinks.push(itemHandle);
					}
				}
				this.updateModel(false, massagedLinks);
			}
        },
		
		/**
         * _deleteElement: This method deletes the row from the Actions grid. <br>
         * This is called from the click event handler for the delete toolbar button <br>
         * rowIndex: Index of the selected row. <br>
         */
        _deleteElement: function(rowIndex){
            if (rowIndex >= 0) {
				var item = this._gridData.getRow(rowIndex);
				if (item && item.id) {
					this._removeGridRow(item.id);
				}
			}
        }
    });
})();
