/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

(function(){
    dojo.provide("com.ibm.epm.web.core.grid.controller.GridModelClient");
    
    dojo.require("com.ibm.epm.web.core.transport.EPMServerClient");
    dojo.require("com.ibm.epm.web.core.transport.ServiceRequest");
    
    var ServiceRequest = com.ibm.epm.web.core.transport.ServiceRequest;
    var EpmServerClient = com.ibm.epm.web.core.transport.EPMServerClient;
    
    var _BASE_URI = "epm/resources/";
    
    com.ibm.epm.web.core.grid.controller.GridModelClient = {
    
        getURI: function(responseHandler, uri){
            if (uri == null && responseHandler != null) {
                responseHandler.doErrorCallback("URI cannot be null");
            }
            var serviceRequest = new ServiceRequest(_BASE_URI + uri, "get");
            EpmServerClient.operateOnResource(serviceRequest, responseHandler);
        },
        
        postURI: function(responseHandler, uri, params){
            if (uri == null && responseHandler != null) {
                responseHandler.doErrorCallback("URI cannot be null");
            }
            var serviceRequest = new ServiceRequest(_BASE_URI + uri, "post", params);
            EpmServerClient.operateOnResource(serviceRequest, responseHandler);
        },
        
        deleteURI: function(responseHandler, uri){
        
            if (uri == null && responseHandler != null) {
                responseHandler.doErrorCallback("URI cannot be null");
            }
            var serviceRequest = new ServiceRequest(_BASE_URI + uri, "delete");
            EpmServerClient.operateOnResource(serviceRequest, responseHandler);
        },
        
        getQueryURI: function(responseHandler, uri){
            if (uri == null && responseHandler != null) {
                responseHandler.doErrorCallback("URI cannot be null");
            }
            var serviceRequest = new ServiceRequest(uri, "get");
            EpmServerClient.operateOnResource(serviceRequest, responseHandler);
        },
		
		 postQueryURI: function(responseHandler, uri, params){
            if (uri == null && responseHandler != null) {
                responseHandler.doErrorCallback("URI cannot be null");
            }
            var serviceRequest = new ServiceRequest(uri, "post", params);
            EpmServerClient.operateOnResource(serviceRequest, responseHandler);
        },
        
        //TODO : This code will be removed once work item 4288is complete
        getURIWithQueryArgs: function(responseHandler, uri, param){
            var args = {};
            
            args.projectId = param;
            
            if (uri == null && responseHandler != null) {
                responseHandler.doErrorCallback("URI cannot be null");
            }
            var serviceRequest = new ServiceRequest(_BASE_URI + uri, "get", args);
            
            EpmServerClient.operateOnResource(serviceRequest, responseHandler);
        }
        
    };
})();
