/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

(function(){
    dojo.provide("com.ibm.epm.web.core.grid.controller.TreeBasedGridController1");
	
	dojo.require("com.ibm.epm.web.core.grid.controller.TreeBasedGridController");
	
	dojo.require("com.ibm.epm.web.core.grid.controller.GridModelClient");
	
	dojo.requireLocalization("com.ibm.epm.web.core.ui", "Messages");
	
	var GridModelClient = com.ibm.epm.web.core.grid.controller.GridModelClient;
	
	var TreeBasedGridController = com.ibm.epm.web.core.grid.controller.TreeBasedGridController;	
	
	var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
	
	dojo.declare("com.ibm.epm.web.core.grid.controller.TreeBasedGridController1", TreeBasedGridController, {
		
		 _getAndUpdateRow: function(rowURI, rowID, linkName){
            var self = this;
            var updateWBSGeneralGridFunctions = {
                success: function(loadedElement){
                    if (loadedElement) {
                        self._updateGridRow(loadedElement, rowID, linkName);
                        self._getLinkedResources(loadedElement, rowID);
                    }
                },
                failure: function(errorMsg){
                    console.debug(errorMsg);
                    //sending null as the row is not fetched here.
                    self._propogateErrorMessage(errorMsg, null, rowID);
                }
            };
            
            var srh = new ServiceResponseHandler(updateWBSGeneralGridFunctions, "success", "failure");
            var getURI = this._gridModel._getRowURI(rowURI);
			rowURI += "?noChildren=true&noPercents=true";
			
			//TODO currently disabling schedule fetch only for projects, in future can be revisited for other WBS types.
			if (rowURI.indexOf('projects/') == 0)
			{
				rowURI += "&noSchedule=true";
			}

            if ((getURI != null) && (getURI.indexOf(this.newElementPrefix) == -1)) {
                GridModelClient.getURI(srh, rowURI);
            }
        }
		 
		})
	})();
