/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

(function(){
    dojo.provide("com.ibm.epm.web.core.ui.internal.DojoData");
    
    dojo.require("dojox.grid.compat._data.model");
    
    var DojoData = dojox.grid.data.DojoData;
    
    dojo.declare("com.ibm.epm.web.core.ui.internal.DojoData", DojoData, {
    
        // returns the rownIndex if found else returns -1
        getRowByIdentity: function(id){
            var row = -1;
            
            if (this._rowIdentities[id]) {
                row = this._rowIdentities[id].rowId;
            }
            return row;
        },
        
        rebuildRowIdentities: function(){
            // summary:
            // Rebuild the rowIdentities, this is needed i.e. when a row got removed.
            //TODO my impression is that this should be triggered by the grid when some change occured there, may be there is even an event, that is fired, but i am not deep enough in there ... 
            this._rowIdentities = {};
            for (var i = 0, l = this.data.length; i < l; i++) {
                var d = this.data[i];
                if (d) {
                    if (d.__dojo_data_item) {
                        this._rowIdentities[this.store.getIdentity(d.__dojo_data_item)] = {
                            rowId: i
                        };
                    }
              	}   
            }
        }
    });
})();
