/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

(function(){
    dojo.provide("com.ibm.epm.web.core.ui.internal.EPMErrorHandler");
    
    com.ibm.epm.web.core.ui.internal.EPMErrorHandler = {
    
        instantiateErrorObject: function(MainPageInstance){
            // intialize the object instance of main page where error has to be updated
            if (!this._MainPage) {
                this._MainPage = MainPageInstance;
            }
        },
        
        setError: function(err, code){
            // store error message and update main page
            this._errorMessage = err;
            if (this._MainPage == null) {
                // if main page is not loaded, show error in pop up window
                alert(err);
            }
            else {
                this._MainPage.errorDisplay(err, code);
            }
            
        },
        
        clearError: function(){
            // clear the message stored 
            this._errorMessage = "";
            if (this._MainPage) {
                // clear error from main page
                this._MainPage.clearDisplay();
                
            }
        }
    };
    
})();
