/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/


if (!dojo._hasResource["com.ibm.epm.web.core.ui.internal.EPMTreeDialog"]) {
    dojo._hasResource["com.ibm.epm.web.core.ui.internal.EPMTreeDialog"] = true;
    dojo.provide("com.ibm.epm.web.core.ui.internal.EPMTreeDialog");
    
    dojo.require("dijit.Dialog");
    dojo.require("dijit.form.Button");
    dojo.require("dijit._Widget");
    dojo.require("dijit._Templated");
    
    
    dojo.declare("com.ibm.epm.web.core.ui.internal.EPMTreeDialog", [dijit._Widget, dijit._Templated], {
    
        dialog: null,
        show: function(){
            this.dialog.show();
        },
        widgetsInTemplate: true,
        templatePath: dojo.moduleUrl("com.ibm.epm.web.core", "ui/internal/templates/EPMTreeDialog.html"),
        
        postCreate: function(){
            com.ibm.epm.web.core.ui.internal.EPMTreeDialog.superclass.postCreate.apply(this);
            this.addbuttons(this.buttonlist);
            this.addTreeNode(this.tree);
        },
        
        addTreeNode: function(tree){
            if (this.tree) {
                this.treeContent.appendChild(this.tree.domNode);
            }
        },
        
        addbuttons: function(buttonlist){
            if (buttonlist) {
                for (var i = 0; i < buttonlist.length; i++) {
                    var button = new dijit.form.Button({
                        label: buttonlist[i].label
                    });
					
					if (buttonlist[i].disabled) {
                        button.attr('disabled', buttonlist[i].disabled);
                    }
					
                    if (buttonlist[i].action) {
                        dojo.connect(button, "onClick", buttonlist[i].action);
                    }
                    else {
                        dojo.connect(button, "onClick", this, "hide");
                    }
                    this.buttons.appendChild(button.domNode);
                }
            }
        },
        
        destroy: function(){
			
			
        	if(this.tree){
				this.treeContent.removeChild(this.tree.domNode);
				this.tree.destroy();
				delete this.tree;
			}
            this.hide();
            this.dialog.destroy();
			
        },
        
        hide: function(){
            this.dialog.hide();
        }
        
    });
}
