/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

dojo.provide("com.ibm.epm.web.core.ui.internal.EPMTreePubSub");

(function(){

    com.ibm.epm.web.core.ui.internal.EPMTreePubSub = {
        /**
         * the object publish:
         * publishObj = nodeWidget.item; // Store Item for the node
         * publishObj = {
         treeID		: The unique identifier.
         }
         */
        ON_MOUSE_OVER: "OnMouseOver",
        
        /**
         * the object publish:
         * publishObj = nodeWidget.item; // Store Item for the node
         * publishObj = {
         treeID		: The unique identifier.
         }
         */
        ON_MOUSE_OUT: "OnMouseOut",
        
        /**
         * the object publish:
         * publishObj = nodeWidget.item; // Store Item for the node
         * publishObj = {
         treeID		: The unique identifier.
         }
         */
        ON_SELECT: "OnSelect",

        /**
         * the object publish:
         * publishObj = nodeWidget.item; // Store Item for the node
         * publishObj = {
         treeID		: The unique identifier.
         }
         */
		ON_DESELECT: "OnDeSelect",

        /**
         * the object publish:
         * publishObj = {
         treeID		: The unique identifier.
         }
         */
        ON_BLUR: "OnBlur",
        
        /**
         * the object publish:
         * publishObj = node.item; // Store Item for the node
         * publishObj = {
         treeID		: The unique identifier.
         }
         */
        ON_COLLAPSE: "OnCollapse",
        
        /**
         * the object publish:
         * publishObj = node.item; // Store Item for the node
         * publishObj = {
         treeID		: The unique identifier.
         }
         */
        ON_EXPAND: "OnExpand",
        
        /**
         * This event is published by the inherited Tree widget
         * the object publish:
         * var publishedObj = {
         * 	publishedObj.uniqueIdentifier.treeID :
         * }
         */
        ON_CREATE_NODE: "CreateNode",
		
		/**
         * the object publish:
         * var publishedObj = {
         *		treeID: The unique identifier
		 *	    item: tree node item
         *      oldValue: oldValue,
         *      newValue: newValue
         * }
         */
        ON_RENAME_NODE: "RenameNode",
		
		/**
         * This event is published after all the root nodes are added to the tree.
         * the object publish:
         * var publishedObj = {
         * 	publishedObj.treeID :
         * }
         */
        ROOT_NODES_LOADED: "rootNodesLoaded",
		
		/**
         * This event is published by the inherited Tree widget
         * the object publish:
         * var publishedObj = {
         * 	publishedObj.uniqueIdentifier.treeID :
         * }
         */
        ON_DELETE_NODE: "DeleteNode",
        
        /**
         * This event is published when a key is pressed in the tree and
         * when the tree is not being edited.
         * var publishedObj = {
         *  treeID: The unique identifier
         *  keySet: keyCode, altKey, ctrlKey, metaKey, shiftKey
         * }
         */
        ON_KEY_DOWN: "_onKeyDown",
        
        /**
         * This event is published when a key is pressed in the grid
         * to request creation of a new node in the tree.
         * var publishedObj = {
         *     keySet: charCode, altKey
         * }
         */
        ON_REQUEST_NEW_NODE: "_onRequestNewNode",
        
        /**
         * This event is published when the work item type is 
         * changed in the grid.
         * var publishedObj = {
         *     gridID: ID of the grid
         *	   workItemType: New type of the work item
         *     rowIndex: Index of the row the change was made
         * }
         */
        ON_WI_TYPE_CHANGE: "onWITypeChange",
		
		/**
		 * ON_NODE_REFRESH: Event published by tree to trigger refresh the grid. <br>
		 * var publishedObject: {
		 * 		treeID ID of the tree.
		 * 		collectionItemHandle information about the item which needs to be refreshed. <br>
		 * } 
		 */
		ON_NODE_REFRESH: "onNodeRefresh", 
		
		/**
		 * ON_NODE_DELETE is published to update the entire model.<br>
		 * This event will trigger a bunch of rows to be updated.
		 * var publishedObject: {
		 * 		treeID: ID of the tree.
		 * 		collectionItemHandle: information about the item which needs to be deleted. <br>
		 * } 
		 * 
		 */
		ON_NODE_DELETE: "onDeleteNode",
        
        /**
         * ON_PARENT_CHILD_SAVE is published to after the change is persisted on the server
         * after the user initiated Drag-n-Drop in the Tree.<br>
         * This event is published after the server updates the parent-child links between 
         * the node<->old parent and node<->new parent.
         * publishObj = {
                sourceItem: source item,
                targetItem: target item (new parent),
                oldParentItem: old parent item,
                treeID: treeID (Tree where DND was initiated),
                postToServer: Boolean to indicate if we need to POST to server
                error: Boolean to indicate if the server threw an exception
                       true: Server threw an exception on persisting change
                       false: Success on saving change on server
         * }
         * 
         */
        ON_PARENT_CHILD_SAVE: "OnDragNDropSave",
        
        /**
         * ON_PARENT_CHILD_CHANGE_SYNC_GRID is published after saving the parent-child
         * links on the server (after a user initiated Drag-n-Drop) to indicate to
         * the grid to align itself with the structure in the tree.<br>
         * This event triggers a bunch of rows to be updated.
         * var publishedObject: {
         *      treeID: ID of the tree.
         *      collectionItemHandle: information about the item which needs to be synchronized. 
         *      <br>
         * }
         */
        ON_PARENT_CHILD_CHANGE_SYNC_GRID: "OnParentChildChangeSyncGrid"
    };
    
})();
