/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/
(function() {
dojo.provide("com.ibm.epm.web.core.ui.internal.EPMView.ConfigureEnvPage");

dojo.require("jazz.ui.Button");

dojo.require("com.ibm.epm.web.core.ui.internal.EPMView.Dashboard.Util");
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
dojo.require("com.ibm.epm.web.core.client.internal.EPMWebUIServiceClient");
		
dojo.requireLocalization("com.ibm.epm.web.core.ui", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$

var Util = com.ibm.epm.web.core.ui.internal.EPMView.Dashboard.Util;
var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
var EPMWebUIServiceClient = com.ibm.epm.web.core.client.internal.EPMWebUIServiceClient;

dojo.declare("com.ibm.epm.web.core.ui.internal.EPMView.ConfigureEnvPage",
	[dijit._Widget, dijit._Templated], {
	
	templatePath: dojo.moduleUrl("com.ibm.epm.web.core", "ui/internal/EPMView/templates/ConfigureEnvPage.html"),

	constructor: function () {
		this.messages = dojo.i18n.getLocalization("com.ibm.epm.web.core.ui", "Messages");
	},
	
	postCreate: function() {
		var self = this;
		var args = {
			callback: function(){
				self.initializePA();
			},
			buttonText: this.messages.configureEnvTitle, 
			size: "small",
			"class": "com-ibm-epm-web-core-ui-internal-ConfigureEnvPage"
		};
		this.configureButton = new jazz.ui.Button(args);
		this._configureButton.appendChild(this.configureButton.domNode);
	},

    /**
	 * initializePA: Invokes the initialization service.
	 */	
	initializePA: function(){
		this.configureButton.disabled = true;
		Util._lockPage(this.messages.msgConfigureEnvInProgress);
		var self = this;
		var serviceObj = {
			success: function(/* ResponseDTO */ responseDTO) {
				Util._releasePage();		
				window.location.reload(true);
			},
			failure: function(errorObj) {
				Util._releasePage();
				console.log(errorObj);
				dojo.publish(net.jazz.ajax.internal.events.viewErrorPage, [self.messages.msgConfigureEnvErrorOccurred, errorObj.message, true]);
			}
		};
		var srh = new ServiceResponseHandler(serviceObj, "success", "failure");
		EPMWebUIServiceClient.postInitializeDB(srh);
	}	
});
})();