/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

dojo.provide("com.ibm.epm.work.web.ui.internal.GanttMover");

dojo.require("dojo.dnd.move");
dojo.require("dojo.dnd.Mover");
dojo.require("dojo.dnd.Moveable");

dojo.require("com.ibm.epm.work.web.ui.internal.WBSGridGanttPubSub");

var WBSGridGanttPubSub = com.ibm.epm.work.web.ui.internal.WBSGridGanttPubSub;

dojo.declare("com.ibm.epm.work.web.ui.internal.GanttMover", dojo.dnd.move.boxConstrainedMoveable, {
    box: {},
    
    // markup methods
    markupFactory: function(params, node){
        return new com.ibm.epm.work.web.ui.internal.GanttMover(node, params);
    },
    
    /**
     *  constructor : constructor
     *  Incoming : domnode, boundingbox
     *  Outgoing : none
     *
     */
    constructor: function(node, params){
        this._node = node;
        var box = params && params.box;
        this.constraints = function(){
            return box;
        };
        this._pconnects = [];
        // summary: setup our one major listener upon creation
        dojo.connect(node, "onmousedown", this, "_selectNode");
    },
    
    /**
     *  _selectNode : after mouse down register for key press and mouse up
     *  Incoming : Event e
     *  Outgoing : none
     *
     */
    _selectNode: function(/*Event*/e){
        this._pconnects.push(dojo.connect(document, "onkeypress", this, "_onKeyPress"));
        this._pconnects.push(dojo.connect(document, "onmouseup", this, "_deSelectNode"));
    },
    
    /**
     *  _deSelectNode : if mouse up is registered then disconnect all listeners
     *  Incoming : Event e
     *  Outgoing : none
     *
     */
    _deSelectNode: function(/*Event*/e){
        dojo.forEach(this._pconnects, dojo.disconnect);
        this._pconnects = [];
    },
    
    /**
     *  _onKeyPress : filter Escape and perform command abort
     *  Incoming : Event e
     *  Outgoing : none
     *
     */
    _onKeyPress: function(/*Event*/e){
        var key = e.keyCode || e.charCode;
        var k = dojo.keys;
        if (key == k.ESCAPE) {
            this._deSelectNode(e);
            dojo.publish(WBSGridGanttPubSub.ON_GANTTBAR_MOVE_ABORT, [this._node]);
        }
    }
    
});
