/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

// Creating an editor for the calendar column
if (!dojo._hasResource["com.ibm.epm.work.web.ui.internal.ProjectCalendarEditor"]) { //_hasResource checks added by build. Do not use _hasResource directly in your code.
    dojo._hasResource["com.ibm.epm.work.web.ui.internal.ProjectCalendarEditor"] = true;
    dojo.provide("com.ibm.epm.work.web.ui.internal.ProjectCalendarEditor");
    
    dojo.require("com.ibm.epm.web.core.ui.internal.EPMGridEditor");
    dojo.require("com.ibm.epm.admin.web.ui.internal.view.calendar.Calendar");
    dojo.require("com.ibm.epm.web.core.grid.controller.ControllerUtil");
    dojo.require("com.ibm.epm.work.web.ui.internal.grid.WBSControllerConstants");
    dojo.require("com.ibm.epm.work.web.ui.internal.WBSConstants");
    dojo.require("com.ibm.epm.web.core.ui.internal.EPMCalendarDialog");

    dojo.requireLocalization("com.ibm.epm.work.web.ui", "Messages");

    var WBSConstants = com.ibm.epm.work.web.ui.internal.WBSConstants;
    var controllerUtil = com.ibm.epm.web.core.grid.controller.ControllerUtil;
    var controllerID = com.ibm.epm.work.web.ui.internal.grid.WBSControllerConstants.WBSGeneralGridController;
    var WorkMessages = dojo.i18n.getLocalization("com.ibm.epm.work.web.ui", "Messages");
    var CalendarWidget = com.ibm.epm.admin.web.ui.internal.view.calendar.Calendar;
    var EPMCalendarDialog = com.ibm.epm.web.core.ui.internal.EPMCalendarDialog;
	var EPMGridEditor = com.ibm.epm.web.core.ui.internal.EPMGridEditor;
	
    dojo.declare("com.ibm.epm.work.web.ui.internal.ProjectCalendarEditor", EPMGridEditor, {
    
        _selectedRow: null,
        // summary:
        // grid cell editor that provides a pop up box on click
        
        format: function(inDatum, inRowIndex){
            var presentValues = this.getTreeBasedGridController().getRowByIndex(inRowIndex).calendarName;
            presentValues = presentValues.toString();
            return presentValues;
            
        },
        
        getTreeBasedGridController: function(){
            if (!this._gridController) {
                this._gridController = controllerUtil.getTreeBasedGridController(controllerID);
            }
            return this._gridController;
        },
        
        dodblclick: function(e){
            this._onClick(e);
        },
        
        _onClick: function(e){
			this._selectedRow = this.getTreeBasedGridController().getRowByIndex(e.rowIndex);
			if ((this._selectedRow !== null) &&
			(this._selectedRow.resourcetype == WBSConstants.EPM_PROJECT_TYPE)) {
				
				if(this.calendarDialog) {
					this.calendarDialog.destroy();
				}
				this.projectCalendar = new CalendarWidget();
				this.calendarDialog = new EPMCalendarDialog({
					calendar: this.projectCalendar,
					title: WorkMessages.PROJECTCALENDAR_TITLE,
					buttonlist: []
				});
				this.projectCalendar.load(this._selectedRow.calendarURI, false, true, this.calendarDialog);
				this.calendarDialog.show();
				
			}
        },
		
		destroy: function() {
			this.inherited(arguments);
			if(this.calendarDialog) {
				this.calendarDialog.destroy();
			}
		},
		
		/* Enter KeyDown Event on grid brings control here */		
		onEnterKeyDown: function(e){	
			this._onClick(e);   
        }
        
    });
}
