/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007-2008. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
    dojo.provide("com.ibm.epm.risk.web.ui.internal.RiskManagementViewlet");
    
	dojo.require("com.ibm.team.process.web.client.projectarea");    
    dojo.require("com.ibm.epm.web.core.ui.internal.Viewlet");    
    dojo.require("com.ibm.epm.web.core.ui.internal.EPMTreePubSub");    
    dojo.require("com.ibm.epm.web.core.ui.internal.EPMErrorHandler");
    dojo.require("com.ibm.epm.risk.web.ui.internal.RiskGridView");
	dojo.require("com.ibm.epm.web.core.grid.controller.ControllerUtil");
	dojo.require("com.ibm.epm.risk.web.ui.internal.RiskDetails");
	dojo.require("com.ibm.epm.risk.web.ui.internal.RiskStrategies");
	dojo.require("com.ibm.epm.web.core.ui.internal.EPMToolbar");
	dojo.require("com.ibm.epm.web.core.ui.internal.EPMGridPubSub");    
	dojo.require("com.ibm.epm.risk.web.client.internal.RiskClient");
    
    dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
    dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.DiscussionWidget");
	dojo.require("com.ibm.epm.web.core.ui.internal.EPMConfirmDialog");
    // Localization
    dojo.requireLocalization("com.ibm.epm.risk.web.ui", "Messages");
    dojo.require("com.ibm.epm.risk.web.ui.internal.RiskConstants");
	dojo.require("com.ibm.epm.risk.web.ui.internal.RiskDiscussion");
	dojo.require("com.ibm.epm.risk.web.ui.internal.RiskDescription");
	dojo.require("com.ibm.epm.web.core.client.internal.EPMWebUIServiceClient");
	dojo.require("com.ibm.team.process.web.client.internal.ProcessClient");
	dojo.require("com.ibm.epm.web.core.ui.internal.IconClassConstants");
	
	var webclient = com.ibm.epm.web.core.client.internal.EPMWebUIServiceClient;
	var getCurrentProjectArea = com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;	
    var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
	var RiskClient = com.ibm.epm.risk.web.client.internal.RiskClient;
    var RiskConstants = com.ibm.epm.risk.web.ui.internal.RiskConstants;
    var EPMTreePubSub = com.ibm.epm.web.core.ui.internal.EPMTreePubSub;
    var Viewlet = com.ibm.epm.web.core.ui.internal.Viewlet;
	var EPMToolbar = com.ibm.epm.web.core.ui.internal.EPMToolbar;
	var EPMErrorHandler = com.ibm.epm.web.core.ui.internal.EPMErrorHandler;
	var controllerUtil = com.ibm.epm.web.core.grid.controller.ControllerUtil;
    var RiskMessages = dojo.i18n.getLocalization("com.ibm.epm.risk.web.ui", "Messages");
	var ProcessClient = com.ibm.team.process.web.client.internal.ProcessClient;
	var EPMConfirmDialog = com.ibm.epm.web.core.ui.internal.EPMConfirmDialog;
	var IconClassConstants = com.ibm.epm.web.core.ui.internal.IconClassConstants;   
	var EPMGridPubSub = com.ibm.epm.web.core.ui.internal.EPMGridPubSub;
    dojo.declare("com.ibm.epm.risk.web.ui.internal.RiskManagementViewlet", Viewlet, {
    
        templatePath: dojo.moduleUrl("com.ibm.epm.risk.web", "ui/internal/templates/RiskManagementViewlet.html"),
		wbsNode : null,
		details : true,
		discussion: true,
		description: true,
		strategies: true,
        noWBSTree: false,
		contextHelpId: RiskConstants.RISK_MANAGEMENT_VIEWLET_CONTEXT_HELP_ID,
		priorityIDs: [],
		priorityLabels: [],
		stateIDs: [],
		stateLabels: [],
		projectAreaDetails: null,
		wiTypes: [],
		wiTypeIds: [],
		wiTypeIcons: [],
		
		//Tree Event Subscription handler
        treeEventSubscriptionHandler: "",
		gridEventSubscriptionHandler: "",
        
		init: function(){
			this.inherited(arguments);
            this._createInformationLabel();
            
            // Disable viewlet if no WBS tree
		    if (this._disableViewletIfNoWBSTree()){
				return;
			}
		        		
            this._createListOfSubscription();
			this._createBasicToolbar();
			this._createRiskDetails();
			this._createRiskDescription();
			this._createRiskStrategies();
			this._createRiskDiscussion();
        },
		
		setStates: function(data)
		{
			if(data && data.allValues && data.allValues.length > 0)
			{
				for(var index in data.allValues)
				{
					if (data.allValues[index].attributeName === "internalPriority") {
						this.populateArrays(this.priorityIDs, this.priorityLabels, data.allValues[index].uiItems);
					}
					else 
						if (data.allValues[index].attributeName === "internalState") {
							this.populateArrays(this.stateIDs, this.stateLabels, data.allValues[index].uiItems);
						}
						else 
							if (data.allValues[index].attributeName === "workItemType") {
								this.wiTypes = [];
								this.wiTypeIds = [];
								this.wiTypeIcons = [];
								this.populateWITypes(this.wiTypes,this.wiTypeIds, this.wiTypeIcons, data.allValues[index].uiItems);
							}
				}
				if(this._RiskDetails){
					this._RiskDetails.updateStateAndPriorityCombos();
				}
			}
		},
		populateWITypes: function(wiTypes,wiTypeIds, wiTypeIcons, uiItems){
			if (uiItems && uiItems.length > 0) {
				for (var indUIItem in uiItems) {
					if (uiItems[indUIItem].id != RiskConstants.EPM_PROJECT_TYPE && uiItems[indUIItem].id != RiskConstants.RISK_TYPE) {
						wiTypes.push(uiItems[indUIItem].label);
						wiTypeIds.push(uiItems[indUIItem].id);
						wiTypeIcons.push(uiItems[indUIItem].iconUrl);
					}
				}
			}
		},
		populateArrays: function(ids, labels, uiItems){
			if (uiItems && uiItems.length > 0) {
				for (var indey in uiItems) {
					ids.push(uiItems[indey].id);
					labels.push(uiItems[indey].label);
				}
			}
		},
		
		getStates : function(projectAreaItemID){
			var self = this;
			var serviceObj = {
                        success: function(data){
                           self.setStates(data);
						   
                        },
                        failure: function(errorObj){}
                    };
                    var srh = new ServiceResponseHandler(serviceObj, "success", "failure");
                    webclient.getStates(srh,projectAreaItemID);
		},	
		/*
		 * Disable viewlet and display an appropriate message if there is no WBS Tree
		 * for the viewlet to make use of. Returns true if viewlet was disabled, signifying
		 * to caller that further setup is not necessary.
		 */
		_disableViewletIfNoWBSTree: function() {
            var tree = dijit.byId(RiskConstants.WBS_TREE_ID);
            this.noWBSTree = tree ? false : true;
            if (this.noWBSTree) {
				this._displayInformationLabel(RiskMessages.WBS_TREE_MISSING);
			}
   		    return this.noWBSTree;
		},
		
        /*
         * Displays information label and hides the rest of the viewlet.
         */
        _displayInformationLabel: function(text) {
            dojo.addClass(this._content, "HiddenClass");
            this.informationLabel.innerHTML = text;
            dojo.removeClass(this._informationLabel, "HiddenClass");
        },
        
        /*
         * Hides information label and shows the rest of the viewlet.
         */
        _hideInformationLabel: function() {
            dojo.addClass(this._informationLabel, "HiddenClass");
            this.informationLabel.innerHTML = "";
            dojo.removeClass(this._content, "HiddenClass");
        },
        
		toggleSaveButton: function(state){
        	
			this.saveButton.disabled = state;
			this.lowerSaveButton.disabled = state;
			if (state) {
                this.resetDirtyFlag();
            }
            else {
                this.setDirtyFlag();
            }
        },
		
		toggleAddButton: function(state){
        
			this.addButton.disabled = state;
        },
		
		toggleRemoveButton: function(state){
			var oldState = this.removeButton.attr('disabled');
            if (oldState != state) {
                this.removeButton.attr('disabled',state);
                if (state) {
					this.removeButton.attr('iconClass', IconClassConstants.EPM_DELETE_ICON_CLASS + " " + IconClassConstants.EPM_DISABLED_ICON_CLASS);
				}
				else {
					this.removeButton.attr('iconClass', IconClassConstants.EPM_DELETE_ICON_CLASS);
				}
            }
        },
        
        /*
         * List of subscription which the viewlet should be subscribed to
         */
        _createListOfSubscription: function(){
			if (this.treeEventSubscriptionHandler === "") {
                this.treeEventSubscriptionHandler = dojo.subscribe(EPMTreePubSub.ON_SELECT, this, "_updateWBSNodeIdentifier");
            }
		},
		
		_gridRowSelectionChanged: function(e){
            if (this._riskGrid && this._riskGrid._generalGrid && e.gridID == RiskConstants.RISKGRIDNAME) {
				var cnt = this._riskGrid._generalGrid.selection.getSelectedCount();
				var state = (0 == cnt) ? true : false;
				this._riskGrid.riskGridSelectionChanged(state);
				this.toggleRemoveButton(state);
				this._RiskDetails.toggleRiskDetailsState(state);
				this._RiskStrategiesSection.toggleAddButton(state);
				this._RiskDescriptionSection.toggleDescriptionEditor(state);
				this._RiskDiscussionSection.toggleDiscussionWidget(state);
			}
			else if(e.gridID == RiskConstants.RISK_STRATEGIES){
				var selectedCount = this._RiskStrategiesSection.RiskPlanGrid._generalGrid.selection.getSelectedCount();
				this._RiskStrategiesSection.toggleButtons(selectedCount === 0);
			}
        },
			
		
		
		setActive: function(/* boolean */active){
			this.inherited(arguments);
            if (active) {
                // Subscribe to all the events
                this.subscribeToTreeEvents();
				this._updateViewBasedonTree();
            }
            else {
                // Unsubscribe to all the events 
                this.unSubscribeFromTreeEvents();
            }
            
         },
		
	   /*
		* Get the current tree node to load the view
		* Incoming : None
		* Outgoing : None
		*/
		_updateViewBasedonTree: function(){
			var tree = dijit.byId(RiskConstants.WBS_TREE_ID);
			if (tree && tree._selectedNode) {
				var item = tree._selectedNode.item;
				if (item && item.identifier != this.identifier) {
					var obj = {
						treeID: RiskConstants.WBS_TREE_ID,
						identifier: item.identifier,
						name: item.name,
						resourcetype: item.resourcetype
					};
					this._updateWBSNodeIdentifier(obj);
				}
			}
		},
		/**
         *  _createRiskGrid : This function is for creating Risk Grid.
         *  Incoming Arguments : Uri.
         *  Outgoing Argument : none
         */
        _createRiskGrid: function(link){
			
			if (!this._riskGrid) {
				this._riskGrid = new com.ibm.epm.risk.web.ui.internal.RiskGridView({
					_treeID: link
				});
			}else{
				
				this.removeAllRows(this._riskGrid);
				if (this._riskGrid && this._riskGrid._generalGrid) {
					this._riskGrid.setTreeId(link);
					this._riskGrid._generalGrid.selection.unselectAll();
				}
				
			}
			this._riskGrid.containerViewlet = this;
			this.populateProjectAreaMembers(this._riskGrid.setSelectOptionsForOwner,this.projectAreaDetails.projectAreaItemID);
			this.getoptions(this._riskGrid.setSelectOptionsForCategory,"riskcategory");
			
            this._riskGrid.buildRiskViewGrid();
            this._riskGrid._rowIndexSelected = 0;
			this._riskgrid.appendChild(this._riskGrid.domNode);
        },
			
		/**
		 * 
		 * @param {Object} function
		 * @param {Object} projectHref
		 */
		getProjectAreaDetails: function(projectHref){
			
			var self = this;
			var serviceObj2 = {
                success: function(projectData){
						self.projectAreaDetails = null;
						self.projectAreaDetails = projectData;
						self.getStates(self.projectAreaDetails.projectAreaItemID);
						self._createRiskGrid(self.projectAreaDetails.projectAreaItemID);
                },
                failure: function(errorObj){
					console.log("Error in getting ProjectAreadDetails");
                }
            };
			var srh2 = new ServiceResponseHandler(serviceObj2, "success", "failure");
			RiskClient.getURI(srh2, projectHref);
			
		},
		
	
		/**
		 * 
		 * @param {Object} projectAreaItemId
		 */
		populateProjectAreaMembers: function(callBkToSetSelectOptionValues,projectAreaItemId)
		{
			var serviceObj2 = {
                success: function(data){
					var collectionElements1 = [];
					var collectionElements2 = [];
					var allMembers = data.members;
					if (allMembers && allMembers.length > 0) {
						for (var i = 0; i < allMembers.length; i++) {
							collectionElements1.push(allMembers[i].name);
							collectionElements2.push(allMembers[i].userId);
						}
					}
					callBkToSetSelectOptionValues(collectionElements1,collectionElements2);
                },
                failure: function(errorObj){
					console.log("Error in getting Contributors");
                }
            };
			var srh = new ServiceResponseHandler(serviceObj2, "success", "failure"); //$NON-NLS-1$ //$NON-NLS-2$
            ProcessClient.getProjectAreaByUUID({uuid: projectAreaItemId}, srh);
		},
		/**
		 * 
		 * @param {Object} funtion
		 * @param {Object} uri
		 */
		getoptions : function(funtion,uri){
			var self = this;
			var serviceObj = {
                        success: function(data){
                           var collectionElements1 = [];
						   var collectionElements2 = [];
						   for (var i = 0; i < data.length; i++) {							
								collectionElements1.push(data[i].title);
								collectionElements2.push(data[i].relativeHref);
							}
							funtion(collectionElements1,collectionElements2);
                        },
                        failure: function(errorObj){
                            console.log("Failed to Risk category");
                        }
                    };
                    var srh = new ServiceResponseHandler(serviceObj, "success", "failure");
                    RiskClient.getURI(srh, uri);
		},	
		
		/**
         *  _createRiskDetails : This function is for creating Risk Details Section.
         *  Incoming Arguments : Uri.
         *  Outgoing Argument : none
         */
        _createRiskDetails: function(){
			if (!this._RiskDetails) {
				this._RiskDetails = new com.ibm.epm.risk.web.ui.internal.RiskDetails({
					containerViewlet: this
				});
				this._riskdetails.appendChild(this._RiskDetails.domNode);
			}
        },
        
		/**
         *  _createRiskDetails : This function is for creating Risk Details Section.
         *  Incoming Arguments : Uri.
         *  Outgoing Argument : none
         */
        _createRiskStrategies: function(){
			this._RiskStrategiesSection = new com.ibm.epm.risk.web.ui.internal.RiskStrategies({
                                containerViewlet: this
                            });
            this._riskStrategiesSection.appendChild(this._RiskStrategiesSection.domNode);
        },

        /*
		 * Collapse and Expand of Risk Strategies.
		 */   
		_clickedRiskStrategies: function(){
			if(this.strategies === true){
				this.strategies = false;
				dojo.removeClass(this._RiskStrategiesSection.domNode,"OpenClass");
				dojo.addClass(this._RiskStrategiesSection.domNode ,"ClosedClass");
			}else{
				this.strategies = true;
				dojo.removeClass(this._RiskStrategiesSection.domNode,"ClosedClass");
				dojo.addClass(this._RiskStrategiesSection.domNode ,"OpenClass");
			}
		},
		
        /**
         *  _updateWBSNodeIdentifier : This function is called when the WBS tree elemnt is selected.
         *  Incoming Arguments : Selected Node details.
         *  Outgoing Argument : none
         */
        _updateWBSNodeIdentifier: function(wbsNodeDetail){
        	
            // Process only if the Tree even has come from WBSTree
            if (!wbsNodeDetail.identifier || this.needToHandleEvent(wbsNodeDetail) === false) {
                //Event ignored due to ID mismatch
                return;
            }
			
			if(this.wbsNode && this.wbsNode.identifier){
				var wbsid = (dojo.isArray(this.wbsNode.identifier))?this.wbsNode.identifier[0]:this.wbsNode.identifier;
				var pubwbsid = (dojo.isArray(wbsNodeDetail.identifier))?wbsNodeDetail.identifier[0]:wbsNodeDetail.identifier;
				if(wbsid == pubwbsid){
					return;
				}
			}
            
			this.wbsNodeType = wbsNodeDetail.resourcetype;
            
            if ((this.wbsNodeType == RiskConstants.EPM_PROJECT_TYPE) && this.getSite().isActive() ){
				this.wbsNode = wbsNodeDetail;
				this._hideInformationLabel();
				
				this.getProjectAreaDetails(wbsNodeDetail.identifier);
			}
			else{
				
				this._displayInformationLabel(RiskMessages.NO_WBS_PROJECT_SELECTED);
				this.wbsNode = null;
			} 
        },
        
        /**
         *  updateDetails : Updates the fields changed in Details Section
         *  Incoming Arguments : data.
         *  Outgoing Argument : none
         */
		updateDetails: function(data)
		{
			if(this._RiskDetails)
			{
				this._RiskDetails.UpdateRiskValues(data);
			}
		},
		
        getJSONExpression: function(projectUri){        
            var jsonExpressionVal = '{"attributeExpressions":[{"attributeId":"workItemType","operator":"is","values":["risk"]},{"attributeId":"link:com.ibm.epm.risk.associated:source/id","operator":"is","values":[' +
            projectUri + ']},{"attributeId":"internalTags","operator":"does not contain","values":["' + RiskConstants.WBS_REMOVED_TAG +'"]} ],"operator":"AND"}';            
            return jsonExpressionVal;
        },
        
        getUri: function(link){       
            var jsonExpression = "";
            if (link === null) {
                return;
            }else{
                jsonExpression = this.getJSONExpression(link);
            }
            var URI = "epm/query/";
            URI += "?" + "type" + "=" + "risk&execute=true&jsonExpression="; //"?ype=risk&execute=true&jsonExpression=";
            URI += jsonExpression;            
            URI += '&';
            return URI;
        },
        
        needToHandleEvent: function(publishedData){
        
            var boolNeedToHandleEvent = false;
            if (publishedData.treeID == RiskConstants.WBS_TREE_ID){
                boolNeedToHandleEvent = true;
            }
            return boolNeedToHandleEvent;
        },
        
		_createInformationLabel: function() {
            this.informationLabel = document.createElement("label");
            this.informationLabel.innerHTML = RiskMessages.NO_WBS_PROJECT_SELECTED;
			this.setCSHelpIdInToolbar(this.contextHelpId, this._informationLabel);
			this._informationLabel.appendChild(this.informationLabel);
        },
        
		/*
         * Display and clear the error message
         * incoming : Error Message Object
         * OutGoing : None
         */
        _displayAndClearErrorMessage: function(errorMessage){
            var self = this;
            EPMErrorHandler.setError(errorMessage);
            
            // Set an interval and clear the error message
            var intervalID = setInterval(function(){
                self._hideInformationLabel();
                clearInterval(intervalID);
            }, 10000);
        },
        
	
        cleanup: function(){
			
			if(this._riskGrid){
				if (this._riskgrid.hasChildNodes()) {
					this._riskgrid.removeChild(this._riskGrid.domNode);
				}
				this._riskGrid.destroy();
				delete this._riskGrid;
				
			}       
        },
		
        
		/**
         *  _confirmDialog : Function for refresh values..
         *  Incoming Arguments : none.
         *  Outgoing Argument : none
         */
        _confirmDialog: function(){
            if (this.wbsNode) {
				if(!this.saveButton.disabled){
					this.discardUnsavedChanges();
					return;
				}else{
					this.getProjectAreaDetails(this.wbsNode.identifier);
				}
            }
        },
		
		
		/**
		 * Popup dialog to confirm whether to save Unsaved changes or not. 
		 */
		
		discardUnsavedChanges: function(){
            var buttonlist = [{
                label: RiskMessages.YES,
                action: dojo.hitch(this, this._discardChanges)
            }, {
                label: RiskMessages.NO,
                action: dojo.hitch(this, this._cancelOperation)
            }];
            
            var labelList = [{
                label: RiskMessages.CONFIRM_UNSAVED_CHANGES
            }];
            
			
	        this.discardUnsavedDialog = new EPMConfirmDialog({
	            labelList: labelList,
	            title: RiskMessages.DISCARD_CHANGES_TITLE,
	            buttonlist: buttonlist
	        });
	        
	        this.discardUnsavedDialog.show();
		},
		
		/**
		 * Discard unsaved changes if selected "Yes"
		 */
		_discardChanges: function(){
			this.discardUnsavedDialog.destroy();
			this.toggleSaveButton(true);
			if(this.wbsNode){
				this.getProjectAreaDetails(this.wbsNode.identifier);
			}
		},
		
		/**
		 * Destroy confirmation dialog.
		 */
		_cancelOperation: function(){
			this.discardUnsavedDialog.destroy();
		},
		
        /**
         *  destroy : Destroy function for viewlet.
         *  Incoming Arguments : none.
         *  Outgoing Argument : none
         */
        destroy: function(){
			this.unSubscribeFromTreeEvents();
			
            if (this._riskGrid) {
                this._riskGrid.destroy();
                delete this._riskGrid;
            }
			if (this._RiskStrategiesSection) {
                this._RiskStrategiesSection.destroy();
                delete this._RiskStrategiesSection;
            } 
			if (this._RiskDetails) {
                this._RiskDetails.destroy();
                delete this._RiskDetails;
            } 
			if (this._RiskDiscussionSection) {
                this._RiskDiscussionSection.destroy();
                delete this._RiskDiscussionSection;
            }            
        },
      
		/**
         *  setSubSectionTitles : Updates the Title for the risk grid with the name of the project
         *  Incoming Arguments : title.
         *  Outgoing Argument : none
         *
         */
		setSubSectionTitles: function(title){
			if(title && title.length > 0)
			{
				title = RiskConstants.SINGLE_QUOTE + title +RiskConstants.SINGLE_QUOTE;
				this._riskStrategiesToolBar.domNode.title = RiskMessages.STRATEGIES_SECTION_TITLE + title;
				this._riskDetailsToolBar.domNode.title = RiskMessages.DETAILS_SECTION_TITLE + title;
				this.DiscussionBar.domNode.title = RiskMessages.DISCUSSION_SECTION_TITLE + title;
				this.DescriptionToolbar.domNode.title = RiskMessages.DESCRIPTION_SECTION_TITLE + title;
			}
		},
	
		/**
         *  _createBasicToolbar : This function is create toolbar.
         *  Incoming Arguments : none.
         *  Outgoing Argument : none
         *
         */
		_createBasicToolbar: function(){ 
			this.addButton = new dijit.form.Button({
                title: RiskMessages.ADD_RISK_TITLE,
				label : RiskMessages.ADD,
				showLabel : false,
                iconClass: "com-ibm-epm-web-core-ui-internal-templates-EPMIconImages com-ibm-epm-web-core-ui-internal-templates-EPMIconImages-AddButtonIcon",
                onClick: dojo.hitch(this, this._addRisk)
            }); 
			
			this.removeButton = new dijit.form.Button({
                title: RiskMessages.REMOVE_RISK_TITLE,
				label : RiskMessages.REMOVE,
				showLabel : false,
                iconClass: "com-ibm-epm-web-core-ui-internal-templates-EPMIconImages com-ibm-epm-web-core-ui-internal-templates-EPMIconImages-DeleteButtonIcon",
                onClick: dojo.hitch(this, this._deleteRisk)
            }); 
			
			this.refreshButton = new dijit.form.Button({
                title: RiskMessages.REFRESH_RISK_TITLE,
				label : RiskMessages.REFRESH,
				showLabel : false,
                iconClass: "com-ibm-epm-web-core-ui-internal-templates-EPMIconImages com-ibm-epm-web-core-ui-internal-templates-EPMIconImages-RefreshButtonIcon",
                onClick: dojo.hitch(this, this._confirmDialog)
            });
		
			this.saveButton = document.createElement("button");
            this.saveButton.innerHTML = RiskMessages.SAVE;
            this.saveButton.title = RiskMessages.SAVE_RISK_TITLE;
            			
			this.lowerSaveButton = dojo.clone(this.saveButton);
			
            this.toggleSaveButton(true);
            dojo.connect(this.saveButton, "onclick", this, this._save);
  			dojo.connect(this.lowerSaveButton, "onclick", this, this._save);
			var rightContentList = [ this.addButton,/* this.removeButton,*/this.refreshButton, this.saveButton];
            
            this._riskManagementToolBar = new EPMToolbar({
                rightContentList: rightContentList
            });            
			dojo.addClass(this._riskManagementToolBar.domNode, RiskConstants.TRANSPARENT_TOOLBAR_CLASS);
			this.setCSHelpIdInToolbar(this.contextHelpId, this._riskManagementToolBar);
			
            this.toolbarDIV.appendChild(this._riskManagementToolBar.domNode);
			
			this._riskManagementLowerToolBar = new EPMToolbar({rightContentList: [this.lowerSaveButton]});
			dojo.addClass(this._riskManagementLowerToolBar.domNode, RiskConstants.TRANSPARENT_TOOLBAR_CLASS);
			this.toolbarDIVLower.appendChild(this._riskManagementLowerToolBar.domNode);
			
			this._riskDetailsToolBar = new EPMToolbar({
                title : RiskMessages.RISKDETAILS
            }); 
            
            this._riskDtailsLabel.appendChild(this._riskDetailsToolBar.domNode);
			
			this._riskStrategiesToolBar = new EPMToolbar({
                title : RiskMessages.STRATEGIES
            }); 
            
            this._riskStrategiesLabel.appendChild(this._riskStrategiesToolBar.domNode);
			
			this.AddCommentsButton = new dijit.form.Button({
                title: RiskMessages.ADD_COMMENTS,
                label: RiskMessages.ADD_COMMENTS,
                disabled: true,
                onClick: dojo.hitch(this, this._addComments)
            });
			var discContents = [/*this.AddCommentsButton*/];
			this.DiscussionBar = new EPMToolbar({ 
				title : RiskMessages.DISCUSSION,
			    rightContentList: discContents         
            });
			this._riskDiscussionBar.appendChild(this.DiscussionBar.domNode);
			
			this.DescriptionToolbar = new EPMToolbar({ 
				title : RiskMessages.DESCRIPTION,
			    rightContentList: []         
            });
			this._riskDescriptionLabel.appendChild(this.DescriptionToolbar.domNode);			
		},
		
		_addRisk:function(){			
			if( this._riskGrid && this.wbsNode !== null){
				 this._riskGrid.addrisk(this.wbsNode.identifier);
				 this.toggleSaveButton(false);
			}
		},
		
		/**
		 * This method is called when one of the save buttons in the view let is clicked.
		 */		
		_save: function(){
			this.toggleSaveButton(true);
			if(this._riskGrid){
				this._riskGrid.SaveGrid();
			}
		},
		
		
		/**
		 * Adds a new Comment
		 */ 
		_addComments:function(){
			if( this._RiskDiscussionSection && this.wbsNode !== null){
				this.discussion = false;
				this._RiskDiscussionSection._addComments(true);	
                this.AddCommentsButton.attr('disabled', true);		
			}
		},
		/**
         * Deletes the selected risk
         */
        _deleteRisk: function(){
            if (this._riskGrid && this._riskGrid._generalGrid && this._riskGrid._generalGrid ) {
				var rowCnt = this._riskGrid._generalGrid.selection.getSelected();
				if (rowCnt.length > 0) {
					this._riskGrid.deleterisks();
				}
            }
        },
		
		
		/**
		 * Collapse and Expand of Risk Details.
		 */   
		_clickedRiskDetails: function(){
			if(this.details === true){
				this.details = false;
				dojo.removeClass(this._RiskDetails.domNode,"OpenClass");
				dojo.addClass(this._RiskDetails.domNode ,"ClosedClass");
			}else{
				this.details = true;
				dojo.removeClass(this._RiskDetails.domNode,"ClosedClass");
				dojo.addClass(this._RiskDetails.domNode ,"OpenClass");
			}
		},
		
		/**
		 * Removes all the rows of the Grid
		 */
		removeAllRows: function(grid){
          try{
				if (grid._controller) {
					var _gridData = grid._controller.getDataModel();
					if (_gridData && grid._generalGrid) {
						var count = _gridData.getRowCount();
						grid._generalGrid.beginUpdate();
						for (var i = 0; i < count; i++) {
							var row = _gridData.data[0];
							if (row) {
								_gridData.remove([0]);
							}
						}
						//save the model
						_gridData.store.save();
					}
				}
			}catch(Error){
				console.log("Error during removing all rows :" +Error.message);				
			}finally{
				if (grid._generalGrid) {
					grid._generalGrid.endUpdate();
				}
            }
        },
		subscribeToTreeEvents: function(){
            if (this.treeEventSubscriptionHandler === "") {
                this.treeEventSubscriptionHandler = dojo.subscribe(EPMTreePubSub.ON_SELECT, this, "_updateWBSNodeIdentifier");
            }
			if (this.gridEventSubscriptionHandler === "") {
				this.gridEventSubscriptionHandler = dojo.subscribe(EPMGridPubSub.ON_ROW_SELECTION_CHANGED, this, "_gridRowSelectionChanged");
			}
            
        },
        
        unSubscribeFromTreeEvents: function(){
            if (this.treeEventSubscriptionHandler !== "") {
                dojo.unsubscribe(this.treeEventSubscriptionHandler);
                this.treeEventSubscriptionHandler = "";
            }
			if(this.gridEventSubscriptionHandler !== ""){
				dojo.unsubscribe(this.gridEventSubscriptionHandler);
                this.gridEventSubscriptionHandler = "";
			}
        },
		
		/**
         * Create the discussion section in the viewlet
         */
		 _createRiskDiscussion: function(){
			this._RiskDiscussionSection = new com.ibm.epm.risk.web.ui.internal.RiskDiscussion({
                                containerViewlet: this
                            });
            this._riskDiscussionSection.appendChild(this._RiskDiscussionSection.domNode);
        },
		
		/*
         * This takes care of collapsing the section in the viewlet
         */
		_clickedRiskDiscussion: function(){
			if(this.discussion === true){
				this.discussion = false;
				dojo.removeClass(this._RiskDiscussionSection.domNode,"OpenClass");
				dojo.addClass(this._RiskDiscussionSection.domNode ,"ClosedClass");
			}else{
				this.discussion = true;
				dojo.removeClass(this._RiskDiscussionSection.domNode,"ClosedClass");
				dojo.addClass(this._RiskDiscussionSection.domNode ,"OpenClass");
			}
		},
		
		/**
		 * Enable editing of description
		 */ 
		_editDescription:function(){
			if (this._RiskDescriptionSection && this.wbsNode && this.rownode) {
				if (this.EditDescriptionButton.label == RiskMessages.EDIT) {
					this.EditDescriptionButton.attr('label', RiskMessages.PREVIEW);
					this._RiskDescriptionSection.disableDescriptionEdit(false);
				}
				else {
					this.EditDescriptionButton.attr('label', RiskMessages.EDIT);
					this._RiskDescriptionSection.disableDescriptionEdit(true);
				}
			}
		},
		       
        /**
         * undoEditDescription : This function is to  disable editor after save call.
         *  Incoming Arguments : none
         *  Outgoing Argument : none
         *
         */
        undoEditDescription: function(){            
            this.EditDescriptionButton.attr('label', RiskMessages.EDIT);
			if (this._RiskDescriptionSection) {
				this._RiskDescriptionSection.disableDescriptionEdit(true);
			}
            
        },
		/**
         * Create the description section in the viewlet
         */
		 _createRiskDescription: function(){
			this._RiskDescriptionSection = new com.ibm.epm.risk.web.ui.internal.RiskDescription({
                                containerViewlet: this
                            });
            this._riskDescriptionSection.appendChild(this._RiskDescriptionSection.domNode);
        },
		/**
         * This takes care of collapsing the section in the viewlet
         */
		_clickedRiskDescription: function(){
			if(this.description === true){
				this.description = false;
				dojo.removeClass(this._RiskDescriptionSection.domNode,"OpenClass");
				dojo.addClass(this._RiskDescriptionSection.domNode ,"ClosedClass");
			}else{
				this.description = true;
				dojo.removeClass(this._RiskDescriptionSection.domNode,"ClosedClass");
				dojo.addClass(this._RiskDescriptionSection.domNode ,"OpenClass");
			}
		},
		
		_keypressRiskDescription: function(e){
			if(e.keyCode === 32 || e.keyCode === 13){					
				this._clickedRiskDescription();							
			}			
		},
		
		_keypressRiskStrategies: function(e){
			if(e.keyCode === 32 || e.keyCode === 13){					
				this._clickedRiskStrategies();							
			}			
		},
		
		_keypressRiskDetails: function(e){			
			if(e.keyCode === 32 || e.keyCode === 13){					
				this._clickedRiskDetails();							
			}			
		},
		_keypressRiskDiscussion: function(e){
			if(e.keyCode === 32 || e.keyCode === 13){					
				this._clickedRiskDiscussion();							
			}			
		}
    });
})();
