/**
 * @author paul
 */
/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
    dojo.provide("com.ibm.epm.risk.web.ui.internal.RiskStrategiesGridModel");
    
	dojo.require("com.ibm.epm.web.core.grid.model.AbstractGridModel");
    dojo.requireLocalization("com.ibm.epm.risk.web.ui", "Messages");
	
	var abstractGridModel = com.ibm.epm.web.core.grid.model.AbstractGridModel;
	var RiskMessages = dojo.i18n.getLocalization("com.ibm.epm.risk.web.ui", "Messages");
    
    dojo.declare("com.ibm.epm.risk.web.ui.internal.RiskStrategiesGridModel", abstractGridModel, {
    	constructor: function(){
			this._containingGrid = arguments[0]._containingGrid;
		},
        /*
         * This is called by controller. Returns the empty row structure to the controller.
         */
        getEmptyRow: function(rowID,collectionItemHandle){
            
			var row;
			if (collectionItemHandle) {
				row = {
					"id": rowID,
					"href": rowID,
					"summary": collectionItemHandle.summary ? collectionItemHandle.summary : "",
					"description": "",
					"actions": "",
					"name": collectionItemHandle.name ? collectionItemHandle.name : ""
				};
			}
			else {
				row = {
					"id": rowID,
					"href": rowID,
					"summary": " ",
					"description": "",
					"actions": "",
					"name": ""
				};
			}
			return row;
        },

        SaveGrid: function(){
            //this.persistGrid();
        },
        
        Refresh: function(){
            this.refreshGrid();
        },

        /*
         * This is called by controller.
         * After inserting a row in Grid, the getAndUpdateRow() calls updateRowData with RowURI, RowID params.
         */
        updateRowData: function(row, loadedElement, linkName){
            if (linkName === null) {
                row.summary = loadedElement.summary;
                row.description = loadedElement.description;   
				row.actions = loadedElement.actions;
				row.loadedelement = [loadedElement];
            }   
			row.loadedelement = [loadedElement];         
        }
    });
})();
