/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

(function(){
    dojo.provide("com.ibm.epm.resource.web.ui.internal.StaticPoolAssignedUsersGridModel");
    
    dojo.require("com.ibm.epm.web.core.grid.model.AbstractGridModel");
    dojo.require("com.ibm.epm.web.core.grid.controller.ControllerUtil");
    // Constants
    dojo.require("com.ibm.epm.resource.web.ui.internal.ResourceConstants");
    
    var abstractGridModel = com.ibm.epm.web.core.grid.model.AbstractGridModel;
    var getLink = com.ibm.epm.web.core.grid.controller.ControllerUtil.getLink;
    var Constants = com.ibm.epm.resource.web.ui.internal.ResourceConstants;
    
    dojo.declare("com.ibm.epm.resource.web.ui.internal.StaticPoolAssignedUsersGridModel", abstractGridModel, {
        newElementPrefix: Constants.NEW_ELEMENT_PREFIX,
        staticpoolId: "",
        
        constructor: function(poolId){
            this.staticpoolId = poolId;
        },
        
        
        getEmptyRow: function(rowID, collectionItemHandle){
            var row = null;
            
            if (!collectionItemHandle) {
                row = {
                    "id": rowID,
                    "href": rowID,
                    "name": ""
                };
            }
            else {
            
                row = {
                    "id": rowID,
                    "href": collectionItemHandle.href ? collectionItemHandle.href : rowID,
                    "name": collectionItemHandle.name ? collectionItemHandle.name : ""
                };
            }
            
            return row;
        },
        
        
        
        /*
         * This is called by controller.
         * After inserting a row in Grid, the getAndUpdateRow() calls updateRowData with RowURI, RowID params.
         */
        updateRowData: function(row, loadedElement, linkName){
        
            if (linkName == null) {
                row.name = loadedElement.name;
                row.userHref = loadedElement.relativeHref;
                
            }
            
        }
        
        
    });
})();

