/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

(function(){
    dojo.provide("com.ibm.epm.resource.web.ui.internal.StaticPoolUsersGridView");
    
    
    dojo.require("com.ibm.epm.web.core.grid.view.AbstractGridView");
    dojo.require("com.ibm.epm.resource.web.ui.internal.StaticPoolUsersGridModel");
    dojo.require("com.ibm.epm.web.core.grid.controller.ControllerUtil");
    // Constants
    dojo.require("com.ibm.epm.resource.web.ui.internal.ResourceConstants");
    // Localization
    dojo.requireLocalization("com.ibm.epm.resource.web.ui", "Messages");
    
    
    var Constants = com.ibm.epm.resource.web.ui.internal.ResourceConstants;
    var controllerUtil = com.ibm.epm.web.core.grid.controller.ControllerUtil;
    var abstractView = com.ibm.epm.web.core.grid.view.AbstractGridView;
    var StaticPoolMessages = dojo.i18n.getLocalization("com.ibm.epm.resource.web.ui", "Messages");
    
    dojo.declare("com.ibm.epm.resource.web.ui.internal.StaticPoolUsersGridView", abstractView, {
        templatePath: dojo.moduleUrl("com.ibm.epm.resource.web", "ui/internal/templates/StaticPoolUsersGrid.html"),
        
        
        /* 
         * buildStaticPoolsGrid calls the buildGrid() in abstractView.
         * buildGrid() creates the controller, initializes and the dataModel mapping will be done with StaticPoolsGrid.
         */
        buildStaticPoolUsersGrid: function(){
            if (!this._gridModel) {
                this._gridModel = new com.ibm.epm.resource.web.ui.internal.StaticPoolUsersGridModel();
            }
            this.StaticPoolUsersController = controllerUtil.getEPMGridController(Constants.STATICPOOL_USERS_GRID_CONTROLLER);
            this.buildGrid(this, this._gridModel, this.StaticPoolUsersController);
        },
        
        /*
         * getGridTitle funtion - Override the abstract class and returns the title of the grid.
         *
         */
        getGridTitle: function(){
            return Constants.STATICPOOLUSERS_GRID_TITLE;
        },
        
        /*
         * This is called by controller. Returns the Attachpoint to the controller.
         */
        getAttachpoint: function(){
            return this.staticpoolusersGridAttachPoint;
        },
        
        /*
         * This is called by abstractView while creating the view.
         * getGridLayout() is to return grid structure to abstractView.
         */
        getGridLayout: function(){
            var gridLayout = [{
                noscroll: false,
                rows: [[{
                    name: StaticPoolMessages.AVLUSERS_GRID_COLUMNNAME,
                    width: "100%",
                    field: "name"
                
                }]]
            }];
            
            return gridLayout;
        },
        
        handleError: function(errorObject){
            this.inherited("handleError", arguments);
            this._displayError(errorObject);
        },
        
        /*
         * gets the selected row
         */
        getSelectedUsers: function(){
            var selectedRows = [];
            if (this._generalGrid) {
                var selectedRow = this._generalGrid.selection.getSelected();
                if (selectedRow) {
                    for (var rowIndex = 0; rowIndex < selectedRow.length; rowIndex++) {
                        selectedRows[rowIndex] = this._generalGrid.model.getRow(selectedRow[rowIndex]);
                    }
                }
            }
            return selectedRows;
        },
        
        
        //TODO : remove and chk
        _refreshGrid: function(){
            this.destroy();
            this.buildStaticPoolUsersGrid();
        }
		
    });
})();

