/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

/**
*
* Timesheet Attributes
*/

dojo.provide("com.ibm.epm.timesheet.web.ui.internal.TimesheetAttributes");

(function(){

    com.ibm.epm.timesheet.web.ui.internal.TimesheetAttributes = {
    
    
        relativeHref: 'relativeHref',
        selfuri: 'selfURI',
        title: 'title',
        containingProject: 'containingProject',
        id: 'id',
        
        // Link Names
        TimeCode: 'TimeCode',
        Timesheets: 'Timesheets',
        TaskAssigned: 'Task', // The link name should be changed in the xsd. Remove the space
        // Dates
        startDate: 'startDate',
        finishDate: 'finishDate',
        effort: 'effort',
        
        actualSchedule: 'actualSchedule',
        actualScheduleStartDate: 'actualScheduleStartDate', //actualSchedule + '.' + startDate,
        actualScheduleFinishDate: 'actualScheduleFinishDate', //actualSchedule + '.' + finishDate,
        plannedSchedule: 'plannedSchedule',
        plannedScheduleStartDate: 'plannedScheduleStartDate', //plannedSchedule + '.' + startDate,
        plannedScheduleFinishDate: 'plannedScheduleFinishDate', //plannedSchedule + '.' + finishDate,
        plannedScheduleEffort: 'plannedScheduleEffort', //plannedSchedule + '.' + effort,
        plannedScheduleDuration: 'plannedScheduleDuration', 
        forecastFinish: 'forecastFinish',
        forecastStart: 'forecastStart',
        
        // Timesheet calculated fields
        percentageComplete: 'percentageComplete',
        percentageProgress: 'percentageProgress',
        percentageDC: 'percentageDC',
        totalActualHours: 'totalActualHours',
		totalActualDuration: 'totalActualDuration',
        remainingWork: 'remainingWork',
        eetc: 'eetc',
		additionalEffort: 'additionalEffort',
        
        billable: 'billable',
        
        // Notes
        summaryNotes: 'summaryNotes',
        approvalNotes: 'approvalNotes',
        
        // States
        timesheetApprovalState: 'timesheetApprovalState',
        eetcApprovalState: 'eetcApprovalState',
		
		// Task Type
		constraint: 'constraint',
        taskAssignmentType: 'taskAssignmentType',
		taskAssignmentTypeEffort: 'Effort',
		taskAssignmentTypeDuration: 'Duration',
		duration: 'duration',
        
        // Hours fields
        hours: 'workTime',
        hoursID: 'hoursID',
        sundayRegular: 'sundayRegular',
        mondayRegular: 'mondayRegular',
        tuesdayRegular: 'tuesdayRegular',
        wednesdayRegular: 'wednesdayRegular',
        thursdayRegular: 'thursdayRegular',
        fridayRegular: 'fridayRegular',
        saturdayRegular: 'saturdayRegular',
        
        // TODO: check this field, it is not coming from server
        ExpectedWorkWeek: 'ExpectedWorkWeek',
        
        // For client use
        
        timesheeturi: 'timesheeturi',
        timesheeturilist: 'timesheeturilist',
        taskURI: 'taskURI',
        timecodeURI: 'TimeCode',
        timecode: 'timecode',
        
        //POST PARAMETERS
        assignmentURI: 'TaskAssignment',
        action: 'action',
        // Week
        weekOf: 'weekOf',
		
		actions: 'actions'
    
    };
    
})();
