/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

(function(){
    dojo.provide("com.ibm.epm.web.core.ui.internal.TreeEventListener");
    dojo.require("com.ibm.epm.web.core.ui.internal.EPMTreePubSub");
    
    var EPMTreePubSub = com.ibm.epm.web.core.ui.internal.EPMTreePubSub;
    
    /*
     * An tree event class which viewlets may subclass.
     */
    dojo.declare("com.ibm.epm.web.core.ui.internal.TreeEventListener", null, {
		constructor: function() {
			this._treeEvents = [];
		},
    
        postCreate: function(){
            //subscribe to events which make the viewlet dirty
			this._treeEvents = [
	            dojo.subscribe(EPMTreePubSub.ON_SELECT, this, this.afterTreeModified),
	            dojo.subscribe(EPMTreePubSub.ON_COLLAPSE, this, this.afterTreeModified),
	            dojo.subscribe(EPMTreePubSub.ON_EXPAND, this, this.afterTreeModified),
				dojo.subscribe(EPMTreePubSub.ON_CREATE_NODE, this, this.afterTreeModified)
			];
        },
        
        afterTreeModified: function(){
            /* Viewlets may override */
        },
        
		destroy: function() {
            if (this._treeEvents != null) {
                for (var i in this._treeEvents) {
                    var handler = this._treeEvents[i];
                    if (handler) {
                        dojo.unsubscribe(handler);
                    }
                }
            }
            this._treeEvents = [];
		}
        
    });
    
})();
