/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
    dojo.provide("com.ibm.epm.admin.web.ui.internal.Util.AdminUtil");
        
    //Localization
    dojo.requireLocalization("com.ibm.epm.admin.web.ui", "Messages");
    dojo.require("com.ibm.epm.web.core.ui.internal.EPMDomNodeConstants");
    
    var EPMDomNodeConstants = com.ibm.epm.web.core.ui.internal.EPMDomNodeConstants;
    
    var AdminViewletMessages = dojo.i18n.getLocalization("com.ibm.epm.admin.web.ui", "Messages");
    /*
     * Date related  purpose utility methods.
     */
    com.ibm.epm.admin.web.ui.internal.Util.AdminUtil = {
    
        errorDivId: "",

		displayErrorMessage: function(divId, errorMessage) {
			this.errorDivId = divId;
            var errorDiv = document.getElementById(this.errorDivId);
            var errorLabel = document.createElement(EPMDomNodeConstants.LABEL);
            if (errorDiv.hasChildNodes()) {
                while (errorDiv.childNodes.length >= 1) {
                    errorDiv.removeChild(errorDiv.firstChild);
                }
            }
			
			//Below if {} is to display the error label with styles corresponding to error code returned by server
			if (errorMessage.errorCode) {
				var errStringArr = ["error","warn","info"];
				var errCodeArr = ["E", "W", "I"];
				
				//Clearing wrong styles and adding appropriate style according to the error code.
				for (var i = 0; i < errStringArr.length; i++) {
					if ( errCodeArr[i]==errorMessage.errorCode.substring(10, 9) )
						dojo.addClass(errorLabel,"message-"+errStringArr[i]);
					else
						dojo.removeClass(errorLabel,"message-"+errStringArr[i]);
				}
			}
			else { //Error messages without error codes. This is for client level error messages.
				dojo.addClass(errorLabel, "message-error");
			}
			
            errorLabel.innerHTML = errorMessage.errorMessage;
            errorDiv.appendChild(errorLabel);
			errorDiv.style.display = "block";
            var closeButton = new dijit.form.Button({
                title: AdminViewletMessages.CLOSE,
				label : AdminViewletMessages.CLOSE,
				showLabel : false,
                iconClass: "com-ibm-epm-admin-web-ui-internal-util-EPMAdmin-CloseButtonIcon",
                onClick: dojo.hitch(this, this.clearErrorMessage)
            });
			errorDiv.appendChild(closeButton.domNode);
		},
        
        clearErrorMessage: function(){
            var errorDiv = document.getElementById(this.errorDivId);
            errorDiv.style.display = "none";
            if (errorDiv) {
                if (errorDiv.hasChildNodes()) {
                    while (errorDiv.childNodes.length >= 1) {
                        errorDiv.removeChild(errorDiv.firstChild);
                    }
                }
            }
        }
    };
    
})();
