/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
/*
 * grid cell editor that provides a standard Multi - select
 * returnIndex: editor returns only the index of the selected option and not the value
 */
(function(){

    dojo.provide("com.ibm.epm.admin.web.ui.internal.Util.MultiSelectEditor");
    
    //	dojo.require("dojox.grid.compat._data.dijitEditors");
    dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
    dojo.require("com.ibm.epm.resource.web.client.internal.ProfilesClient");
    dojo.require("com.ibm.epm.admin.web.ui.internal.Util.SystemProfileUtil");
    
    var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
    var ProfilesClient = com.ibm.epm.resource.web.client.internal.ProfilesClient;
    var SystemProfileUtil = com.ibm.epm.admin.web.ui.internal.Util.SystemProfileUtil;
    
    var valueIdMap = [];
    
    dojo.declare("com.ibm.epm.admin.web.ui.internal.Util.MultiSelectEditor", dojox.grid.editors.Input, {
    
        constructor: function(inCell){
        
            this.commaSeparatedValues = "";
            this.commaSeperatedIds = "";
            this.numberOfValues = 0;
            // get the competencies value
            this._getCompetencies(inCell.field);
            this.selectNode = null;
            this.cell = inCell;
        },
        
        format: function(inDatum, inRowIndex){
        
            //if the inDatum is an object get the string value
            var currentValue = inDatum.toString();
            this.needFormatNode(inDatum, inRowIndex);
            this.selectNode = ['<select id="ProfileMultiselectEditor" multiple="true" size=5>'];
            
            var arrayOfValues = this.commaSeparatedValues.split(",");
            var arrayOfIds = this.commaSeperatedIds.split(",");
            this.numberOfValues = arrayOfValues.length;
            var isSelectedHash = new Array(this.numberOfValues);
            var arrayOfValuesSelected;
            var numberOfValuesSelected;
            if (currentValue) {
                arrayOfValuesSelected = currentValue.split(', ');
                numberOfValuesSelected = arrayOfValuesSelected.length;
                for (var i = 0; i < this.numberOfValues; i++) {
                    for (var j = 0; j < numberOfValuesSelected; j++) {
                    
                        if (arrayOfValuesSelected[j] === arrayOfValues[i]) {
                            isSelectedHash[i] = 1;
                        }
                    }
                }
                
            }
            else {
                for (i = 0; i < this.numberOfValues; i++) {
                    isSelectedHash[i] = 0;
                }
            }
            
            
            
            for (i = 0; i < this.numberOfValues; i++) {
                this.selectNode.push("<option", (isSelectedHash[i] === 1 ? ' selected="true"' : ''), ' value="' + arrayOfIds[i] + '"', ">", arrayOfValues[i], "</option>");
            }
            
            this.selectNode.push('</select>');
            
            return this.selectNode.join('');
        },
        
        
        getValue: function(inRowIndex){
        
            var returnValue = "";
            // check the alignment on a number of cells in a table. 
            var multiSelect = dojo.byId("ProfileMultiselectEditor");
            var options = multiSelect.getElementsByTagName("option");
            
            for (var i = 0; i < options.length; i++) {
            
                if (options[i].selected) {
                
                    returnValue = returnValue + ", " + options[i].text;
                    
                }
                
            }
            if (returnValue != "") {
                return returnValue.substring(1);
            }
            else {
                return returnValue;
            }
        },
        
        
        _getCompetencies: function(field){
            var self = this;
            self.commaSeparatedValues = "";
            self.commaSeperatedIds = "";
            var serviceObj = {
                success: function(data){
                    var len = data.length;
                    if (!data || len == 0) {
                        //TODO
                    }
                    else {
                        var relativeHref, title;
                        
                        for (var i = 0; i < data.length; i++) {
                            relativeHref = data[i].relativeHref;
                            title = data[i].title;
                            var val = relativeHref.substring(relativeHref.lastIndexOf("/") + 1);
                            
                            self.commaSeparatedValues = self.commaSeparatedValues + "," + title;
                            self.commaSeperatedIds = self.commaSeperatedIds + "," + val;
                        }
                        self.commaSeparatedValues = self.commaSeparatedValues.substring(1);
                        self.commaSeperatedIds = self.commaSeperatedIds.substring(1);
                        SystemProfileUtil.initMap(field, self.commaSeparatedValues, self.commaSeperatedIds);
                        
                    }
                },
                failure: function(errorObj){
                    //TODO Handle Error
                }
            };
            var srh = new ServiceResponseHandler(serviceObj, "success", "failure");
            var tempField = field.toLowerCase();
            tempField = tempField.substring(3);
            ProfilesClient.getURI(srh, tempField);
        }
    });
})();
