/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
/**
 * @author suryakant
 */
(function(){
    dojo.provide("com.ibm.epm.admin.web.ui.internal.Util.SystemProfileUtil");
    dojo.require("com.ibm.epm.admin.web.ui.internal.Util.Constants");
    
    var Constants = com.ibm.epm.admin.web.ui.internal.Util.Constants;
    
    var skillNameIdMap = [];
    var compNameIdMap = [];
    /*
     * Skill and Competency Name to ID conversion
     */
    com.ibm.epm.admin.web.ui.internal.Util.SystemProfileUtil = {
    
        initMap: function(field, valueString, idString){
        
            if (field == Constants.EPM_SKILL) {
                skillNameIdMap = [];
                if (valueString && idString) {
                    var valueArray = valueString.split(",");
                    var idArray = idString.split(",");
                    for (var i = 0; i < valueArray.length; i++) {
                    
                        skillNameIdMap[valueArray[i]] = idArray[i];
                    }
                }
            }
            else 
                if (field == Constants.EPM_COMPETENCY) {
                    compNameIdMap = [];
                    if (valueString && idString) {
                        var valueArray1 = valueString.split(",");
                        var idArray1 = idString.split(",");
                        for (var j = 0; j < valueArray1.length; j++) {
                        
                            compNameIdMap[valueArray1[j]] = idArray1[j];
                        }
                    }
                }
        },
        
        getIds: function(field, valueString){
        
            var IdArray = new Array();
            
            if (field == Constants.EPM_SKILL) {
            
                if (valueString) {
                
                    var valueArray = valueString.split(", ");
                    
                    for (var i = 0; i < valueArray.length; i++) {
                        if (valueArray[i].charAt(0) == " ") {
                            valueArray[i] = valueArray[i].substring(1);
                        }
                        IdArray.push(Constants.SKILL_URI + Constants.SLASH + skillNameIdMap[valueArray[i]]);
                    }
                }
            }
            else {
            
                if (field == Constants.EPM_COMPETENCY) {
                
                    if (valueString) {
                    
                        var valueArray1 = valueString.split(", ");
                        
                        for (var j = 0; j < valueArray1.length; j++) {
                            if (valueArray1[j].charAt(0) == " ") {
                                valueArray1[j] = valueArray1[j].substring(1);
                            }
                            IdArray.push(Constants.COMPETENCY_URI + Constants.SLASH + compNameIdMap[valueArray1[j]]);
                        }
                    }
                }
            }
            
            
            return IdArray;
            
        }
    };
    
})();
