/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

/**
 * @author atenneti
 */
(function(){
    dojo.provide("com.ibm.epm.work.web.ui.internal.details.CalendarEditorPart");
    
    dojo.require("dijit._Widget");
    dojo.require("dijit._Templated");
    
    dojo.require("com.ibm.epm.work.web.ui.internal.details.EPMWorkItemUtils");
    dojo.require("com.ibm.epm.admin.web.ui.internal.view.calendar.Calendar");
    dojo.require("com.ibm.epm.web.core.ui.internal.EPMCalendarDialog");
    dojo.requireLocalization("com.ibm.epm.work.web.ui", "Messages");

    var WorkMessages = dojo.i18n.getLocalization("com.ibm.epm.work.web.ui", "Messages");
    var EPMWorkItemUtils = com.ibm.epm.work.web.ui.internal.details.EPMWorkItemUtils;
	var CalendarWidget = com.ibm.epm.admin.web.ui.internal.view.calendar.Calendar;
    var EPMCalendarDialog = com.ibm.epm.web.core.ui.internal.EPMCalendarDialog;
    
    dojo.declare("com.ibm.epm.work.web.ui.internal.details.CalendarEditorPart", [dijit._Widget, dijit._Templated], {
    
        templatePath: dojo.moduleUrl("com.ibm.epm.work.web", "ui/internal/details/templates/CalendarEditorPart.html"),
        calendarDialog: null,
        
        postCreate: function(){
			var self = this;
		    self.calendarName.innerHTML = "";
			var intervalID = setInterval(function(){
                if (EPMWorkItemUtils.wiLoading == false) {
                    clearInterval(intervalID);
		            self._selectedRow = EPMWorkItemUtils.controllerNode;
		            if (self._selectedRow && self._selectedRow.Calendar) {
						self.calendarName.appendChild(document.createTextNode(self._selectedRow.Calendar.title));
		            }
					else {
						self.calendarName.innerHTML = WorkMessages.FAILED_TO_LOAD_PROJECT_CALENDAR;
					}
                }
            }, 100);			

            this._setSelection(this.values);
            this._content._parentWidget = this.parentWidget;
        },
        
        _update: function(){
            var intervalID = setInterval(function(){
                if (this.parentController) {
                    clearInterval(intervalID);
                    this._selectedRow = this.parentController.pageController.loadedNode;
                }
            }, 500);
        },
        
		/**
		 * _clicked: This function is called on click event of calendar link in details view.
		 */
        _clicked: function(e){
			if (e.stopPropagation) {
				e.stopPropagation();
				e.preventDefault();
			}
			
			if(this.calendarDialog) {
				this.calendarDialog.destroy();
			}
			if (this._selectedRow && this._selectedRow.Calendar) {
				this.projectCalendar = new CalendarWidget();
				this.calendarDialog = new EPMCalendarDialog({
					calendar: this.projectCalendar,
					title: WorkMessages.PROJECTCALENDAR_TITLE,
					buttonlist: []
				});
				this.projectCalendar.load(this._selectedRow.Calendar.relativeHref, false, true, this.calendarDialog);
				this.calendarDialog.show();
			}
        },
        
        getFormElementValues: function(formElements){
            var value = "";
            formElements[this.attributeId] = value;
        },
        
        setFormElementValues: function(retainedState){
            var value = retainedState[this.attributeId];
            if (value == null) {
                return;
            }
        },
        
        _setSelection: function(values){
            //Here to write the initial project calendar value to be displayed when opened for a project.
            //Plan is to get the project assigned calendar and display the name
        
        }
        
    });
    
})();
