/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

/**
 * This file is to store the intermediate values used by WBSItem controller & new widgets.
 */
(function(){
    dojo.provide("com.ibm.epm.work.web.ui.internal.details.EPMWorkItemUtils");
    dojo.require("net.jazz.ajax.toolbox.lang.internal.Lang");
	dojo.require("com.ibm.team.workitem.web.client.util");
	
    var checkNotNull 			= net.jazz.ajax.toolbox.lang.checkNotNull;
	var checkNonNegative		= net.jazz.ajax.toolbox.lang.checkNonNegative;
	var WIUtils	= com.ibm.team.workitem.web.client.util;
	var selectedWBSTreeNode = null;
    var controllerNode = null;
    var workitemID = null;
	var pageView = null;	//This flag is used by WBSDetailsViewlet for storing the created pageview.
	var WIsaveInProgress = false;	//This flag is used by individual widgets to get rid of parallel post calls. 
	var wiLoading = false;

com.ibm.epm.work.web.ui.internal.details.EPMWorkItemUtils = {
	_basicPrefix: "#action=com.ibm.epm.web.core.",

	/**
	 * getViewWorkItemURI: To update the action prefix with epm core action prefix.
	 * 						Updates the URL with com.ibm.epm.web.core instead of com.ibm.team.workitem. action prefix.
	 * 						This resolves pageID not found exception.
	 */
	updateWITeamURI: function() {
		WIUtils._basicPrefix = "#action=com.ibm.epm.web.core.";
	},
	
	/**
	 * getViewWorkItemURI: Implementing this method for details view. 
	 * 						Used while registering the page actions for the WI editor tabs.
	 * @param {Object} id
	 * @param {Object} query
	 * @param {Object} tab
	 */
	getViewWorkItemURI: function(id, query, tab){
		checkNotNull(id, "id-util3");
		return this._getViewSingleWorkItemURI(id, tab);
	},

	/**
	 * _getViewSingleWorkItemURI: Implementing this method for details view.
	 * 								Used while registering the page actions for the WI editor tabs.
	 * @param {Object} id
	 * @param {Object} tab
	 */
	_getViewSingleWorkItemURI: function(id, tab){
		checkNotNull(id, "id-util2");
		
		var idNum = parseInt(id, 10);
		checkNonNegative(idNum, "idNum");
		
		return this._basicPrefix + "viewWorkItem&id=" + id + (tab ? "&tab=" + tab : "");
	}
};

})();
