/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
    dojo.provide("com.ibm.epm.admin.web.ui.internal.view.calendar.CalendarWithGrid");
    
    
    // Widgets
    dojo.require("com.ibm.epm.admin.web.ui.internal.view.calendar.Calendar");
    dojo.require("com.ibm.epm.admin.web.ui.internal.view.calendar.CalendarGrid");
    
    //PubSub
    dojo.require("com.ibm.epm.web.core.grid.controller.PubSub");
    dojo.require("com.ibm.epm.admin.web.ui.internal.Util.Constants");

    var Constants = com.ibm.epm.admin.web.ui.internal.Util.Constants;
    var GridEvents = com.ibm.epm.web.core.grid.controller.PubSub;
    
    dojo.declare("com.ibm.epm.admin.web.ui.internal.view.calendar.CalendarWithGrid", [dijit._Widget, dijit._Templated], {
    
        templatePath: dojo.moduleUrl("com.ibm.epm.admin.web", "ui/internal/view/calendar/templates/CalendarWithGrid.html"),
        
        /**
         * Begins load of a given calendar
         */
        _loadCalendar: function(selectedCalendar){
            if (this.calendar) {
                this.calendar.load(selectedCalendar.id, false, true);
            }
        },
        
        postCreate: function(){
            var self = this;
            this._calendarGrid = new com.ibm.epm.admin.web.ui.internal.view.calendar.CalendarGrid();
            this._gridContent.appendChild(this._calendarGrid.domNode);
            
            //Load default calendar here
            this.calendar = new com.ibm.epm.admin.web.ui.internal.view.calendar.Calendar({
                dayWidth: "abbr"
            });
            this.calendar.load(Constants.DEFAULT_CALENDAR_URI, false, "abbr");
            this._content.appendChild(this.calendar.domNode);
            
            // Load the calendar selected on the grid
            dojo.subscribe(Constants.SELECT_CALENDAR_EVENT, this, "_loadCalendar");
            
            // We must load a new calendar that got created
            dojo.subscribe(GridEvents.REPLACE_NODE, this, "_loadNewCalendar");
            
        },
        
        /**
         * Loads a newly added calendar
         */
        _loadNewCalendar: function(publishedObj){
            var uniqueId = publishedObj.uniqueIdentifier;
            if (uniqueId && uniqueId.allElementsURI && uniqueId.allElementsURI == Constants.CALENDAR_URI) {
                this._loadCalendar(publishedObj.newObject);
            }
        },
        
        destroy: function(){
            if (this._calendarGrid && this._calendarGrid.destroy) {
                this._calendarGrid.destroy();
                delete this._calendarGrid;
            }
            if (this.calendar && this.calendar.destroy) {
                this.calendar.destroy();
                delete this.calendar;
            }
        }
    });
})();
