/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

(function(){
    dojo.provide("com.ibm.epm.admin.web.ui.internal.view.chargecodes.Chargecodes");
    
    /*
     * DO NOT REMOVE: For some reason this is needed even though the page does not use
     * it. If removed, the main Admin UI page will not load properly.
     */
    dojo.require("com.ibm.epm.web.core.ui.internal.Viewlet");
    
    // Widgets
    dojo.require("com.ibm.epm.admin.web.ui.internal.view.chargecodes.ChargecodesGridView");
    dojo.require("com.ibm.epm.admin.web.ui.internal.view.chargecodes.ChargecodesTreeWidget");
    dojo.require("dijit.form.Button");
    dojo.require("com.ibm.epm.web.core.ui.internal.EPMToolbar");
    dojo.require("com.ibm.epm.web.core.ui.internal.IconClassConstants");
    dojo.requireLocalization("com.ibm.epm.admin.web.ui", "Messages");
    dojo.require("com.ibm.epm.admin.web.ui.internal.view.AdminGrid");

    var IconClassConstants = com.ibm.epm.web.core.ui.internal.IconClassConstants;
    var EPMToolbar = com.ibm.epm.web.core.ui.internal.EPMToolbar;
    var AdminMessages = dojo.i18n.getLocalization("com.ibm.epm.admin.web.ui", "Messages");
    var AdminGrid = com.ibm.epm.admin.web.ui.internal.view.AdminGrid;
    
    dojo.declare("com.ibm.epm.admin.web.ui.internal.view.chargecodes.Chargecodes", AdminGrid, {
    
        templatePath: dojo.moduleUrl("com.ibm.epm.admin.web", "ui/internal/view/chargecodes/templates/Chargecodes.html"),
        _ChargecodesTree: null,
        _ChargecodesGrid: null,
        
        postCreate: function(){
			this._createToolbar();
            this._refreshChargecodes();
        },
        
		
        /*
         * Creating the toolbar. In appadmin tree-grid views, tree & grid will not have separate toolbar.
         * It's a common toolbar will have Add, Delete, Save, Refresh icons.
         */
        _createToolbar: function(){
            this.addButton = new dijit.form.Button({
                title: AdminMessages.ADD_CHARGECODE,
				label : AdminMessages.ADD,
				showLabel : false,
                iconClass: IconClassConstants.EPM_ADD_ICON_CLASS,
                onClick: dojo.hitch(this, this._addChargecode)
            });
            
			this.deleteButton = new dijit.form.Button({
                title: AdminMessages.DELETE_CHARGECODE,
				label : AdminMessages.DELETE,
				showLabel : false,
                iconClass: IconClassConstants.EPM_DELETE_ICON_CLASS,
                onClick: dojo.hitch(this, this._deleteChargecodes)
            });
			
            this.refreshButton = new dijit.form.Button({
                title: AdminMessages.REFRESH,
				label : AdminMessages.REFRESH,
				showLabel : false,
                iconClass: IconClassConstants.EPM_REFRESH_ICON_CLASS,
                onClick: dojo.hitch(this, this._refreshChargecodes)
            });
            
            this.saveButton = this.createSaveButton(this._saveChargecodes);
            
            var rightContentList = [this.addButton, this.deleteButton, this.refreshButton, this.saveButton];
            
            this._chargecodesGridToolBar = new EPMToolbar({
                rightContentList: rightContentList,
				title:AdminMessages.CHARGECODES_ADMIN_PAGE_TITLE
            });
          
		    this._toolbar.appendChild(this._chargecodesGridToolBar.domNode);
        },
        
		/**
		 * The method _deleteChargecodes will be called whenever the delete button is clicked
		 */
		_deleteChargecodes: function(){
			if (this._ChargecodesGrid) {
                this._ChargecodesGrid._deleteChargecodes();
            }
		},
		
        _refreshChargecodes: function(){
            if (!this._confirmRefresh())
                return;

            this.destroy();
            this._createWidgets();
        },
        
		/**
		 * _addChargecode - method will be called when
		 * the add button is clicked.
		 */
        _addChargecode: function(){
			if ((this._ChargecodesGrid) &&
				(this._ChargecodesGrid._generalGrid)){
					this._ChargecodesGrid._generalGrid.edit.apply();
			}
            if (this._ChargecodesTree) {
                this._ChargecodesTree._createRootChargecode();
            }
        },
        
        _saveChargecodes: function(){
            if (this._ChargecodesGrid) {
                this.disableSaveButton(true);
                this._ChargecodesGrid._saveChargecodes();
            }
        },
        
        destroy: function(){
            if (this._ChargecodesTree) {
                this._ChargecodesTree.destroy();
                this._treeContent.removeChild(this._ChargecodesTree.domNode);
                delete this._ChargecodesTree;
            }
            if (this._ChargecodesGrid) {
                this._ChargecodesGrid.destroy();
                this._gridContent.removeChild(this._ChargecodesGrid.domNode);
                delete this._ChargecodesGrid;
            }
            this._unregisterNavigation();            
        },
        
        _createWidgets: function(){
            this.disableSaveButton(true);
            this.disableDeleteButton(true);
        
            if (this._ChargecodesTree == null) {
                this._ChargecodesTree = new com.ibm.epm.admin.web.ui.internal.view.chargecodes.ChargecodesTreeWidget();
			    this._ChargecodesTree.setContainingPage(this);
                this._treeContent.appendChild(this._ChargecodesTree.domNode);
            }
            this._ChargecodesTree._buildChargecodesTree();
            
            if (this._ChargecodesGrid == null) {
                this._ChargecodesGrid = this._grid = new com.ibm.epm.admin.web.ui.internal.view.chargecodes.ChargecodesGridView({
                    _treeID: "ChargecodesTree"
                });
			    this._ChargecodesGrid.setContainingPage(this);
                this._gridContent.appendChild(this._ChargecodesGrid.domNode);
            }
            this._ChargecodesGrid.buildChargecodesGrid();
            this._registerNavigation();
        }
    });
})();
