/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

/**
 * @author suryakant
 */
(function(){
    dojo.provide("com.ibm.epm.admin.web.ui.internal.view.skills.SkillsGridModel");
    
    dojo.require("com.ibm.epm.admin.web.ui.internal.view.AdminGridModel");
    
    dojo.require("com.ibm.epm.web.core.grid.controller.ControllerUtil");
    
    // Constants
    dojo.require("com.ibm.epm.admin.web.ui.internal.Util.Constants");
    
    //Localization
    dojo.requireLocalization("com.ibm.epm.admin.web.ui", "Messages");
    
    
    var Constants = com.ibm.epm.admin.web.ui.internal.Util.Constants;
    
    var AdminViewletMessages = dojo.i18n.getLocalization("com.ibm.epm.admin.web.ui", "Messages");
    
    var abstractGridModel = com.ibm.epm.admin.web.ui.internal.view.AdminGridModel;
    
    var getLink = com.ibm.epm.web.core.grid.controller.ControllerUtil.getLink;
    
    dojo.declare("com.ibm.epm.admin.web.ui.internal.view.skills.SkillsGridModel", abstractGridModel, {
    
        newElementPrefix: Constants.UNSAVED,
        
        /*
         * This is called by controller. Returns the empty row structure to the controller.
         */
        getEmptyRow: function(rowID, collectionItemHandle){
        
            //If the Flag is undefined, the data is pulled from the server and contolled by the 
            //Abstract controller
            //else the data is inserted directly by the View
            
            var row;
            
            if (rowID.indexOf(this.newElementPrefix) == -1) {
            
                row = {
                    "id": rowID,
                    "href": rowID,
                    "name": " ",
                    "description": ""
                };
            }
            else {
            
                row = {
                    "id": rowID,
                    "href": rowID,
                    "name": AdminViewletMessages.NEW_SKILL,
                    "description": ""
                };
            }
            
            return row;
        },
        
        /*
         * This is called by controller.
         * After inserting a row in Grid, the getAndUpdateRow() calls updateRowData with RowURI, RowID params.
         */
        updateRowData: function(row, loadedElement, linkName){
        
            if (linkName == null) {
                row.name = loadedElement.name;
                row.description = loadedElement.description;
                row.loadedelement = [loadedElement];
            }
        },
        
        /*
         * Prepares the parameter for the Post call
         * Incoming : Row information
         * Outgoing : Save Parameters
         */
        prepareSaveParams: function(row){
            var saveParams = {
                name: row.name,
                description: row.description
            };                
            return saveParams;
        },
        
        /*
         * Get Post call URI method
         * Incoming : Row Info
         * Outgoing : Post call URI
         */
        _getNewElementURI: function(row){
        
            return Constants.SKILL_URI;
        },
        
        /*
         * URI for Row level Info
         * Incoming : RowHandle, Row Id
         * Outgoing : URI to get row information
         */
        getRowGetURI: function(rowElementHandle, rowID){
            return rowElementHandle.relativeHref;
        }
    });
})();
