/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

if (!dojo._hasResource["com.ibm.epm.admin.web.ui.internal.view.systemprofile.SkillProficiencyEditor"]) {
    dojo._hasResource["com.ibm.epm.admin.web.ui.internal.view.systemprofile.SkillProficiencyEditor"] = true;
    dojo.provide("com.ibm.epm.admin.web.ui.internal.view.systemprofile.SkillProficiencyEditor");
    
    dojo.require("com.ibm.epm.web.core.ui.internal.EPMGridEditor");
    dojo.require("com.ibm.epm.admin.web.ui.internal.view.skills.ProfileSkillProficiencyAssociation");
    dojo.require("com.ibm.epm.web.core.grid.controller.ControllerUtil");
	dojo.require("jazz.ui.Dialog");
	dojo.require("dojo.io.iframe");
    dojo.require("com.ibm.epm.web.core.ui.internal.EPMView.Dashboard.Util");
	
	//Localization
    dojo.requireLocalization("com.ibm.epm.admin.web.ui", "Messages");
    
    // Constants
    dojo.require("com.ibm.epm.admin.web.ui.internal.Util.Constants");
    
    
    var controllerUtil = com.ibm.epm.web.core.grid.controller.ControllerUtil;
    var Constants = com.ibm.epm.admin.web.ui.internal.Util.Constants;
    var AdminViewletMessages = dojo.i18n.getLocalization("com.ibm.epm.admin.web.ui", "Messages");
    var DashboardUtil = com.ibm.epm.web.core.ui.internal.EPMView.Dashboard.Util;
	var EPMGridEditor = com.ibm.epm.web.core.ui.internal.EPMGridEditor;
    
    dojo.declare("com.ibm.epm.admin.web.ui.internal.view.systemprofile.SkillProficiencyEditor", EPMGridEditor, {
        
        /**
         *  getController : This function is to get the controller
         *  Incoming Arguments :
         *  Outgoing Argument :
         *
         */
        getController: function(){
            if (!this._gridController) {
                this._gridController = controllerUtil.getEPMGridController(Constants.SYSTEMPROFILE_CONTROLLER);
            }
            return this._gridController;
        },
        
        /**
         *  dodblclick : This function is to handle the double click event
         *  Incoming Arguments : e
         *  Outgoing Argument :
         *
         */
        dodblclick: function(e){
            this._onClick(e);
        },
        
        /**
         *  _onClick : This function is to handle the click event
         *  Incoming Arguments : e
         *  Outgoing Argument :
         *
         */
        _onClick: function(e){
			
			// Nullify the dialog if already exists	
            if (this.skillDialog != null) {
                this.skillDialog.destroy();
                this.skillDialog = null;
            }

            DashboardUtil.showMessage(AdminViewletMessages.LOADING_SKILLS_DIALOG_IN_PROGRESS);
            this._row = this.getController().getRowByIndex(e.rowIndex);
            this.skillassignmentInfo = new com.ibm.epm.admin.web.ui.internal.view.skills.ProfileSkillProficiencyAssociation();

            this.skillDialog = new jazz.ui.Dialog({
                contentNode : this.skillassignmentInfo.domNode,
                primaryTitle: AdminViewletMessages.SKILL_ASSIGNMENT_DIALOG_TITLE,
                width: "400px",
                height: "400px",
                onOpen: dojo.hitch(this, this._onOpen),
                onClose: dojo.hitch(this, this._onClose)
            });
			
            this._rowIndex = e.rowIndex;
        },
		
        /**
         *  doclick : This function is to handle the click event
         *  Incoming Arguments : e
         *  Outgoing Argument :
         *
         */
        doclick: function(e){
			//Conditions in which the pop up is opened
			//1. When the current row is being edited and this cell is clicked
			if( (e && e.grid && e.grid.edit && e.grid.edit.isEditing() && e.grid.edit.info) &&
				(e.rowIndex == e.grid.edit.info.rowIndex)) {
				this._onClick(e);
			}
		},
        
		/*
         * This method is called when the dialog opens.
         * Loads the Skills and Proficiencies into the grid.
         */
		_onOpen: function() {
			this.skillassignmentInfo.loadSkillProficiency(this._row, this);
		},
		
		/*
         * This method is called no matter how the dialog manages to close.
         * Destroys the assignment info object.
         */
        _onClose: function() {
            /*
             * Necessary because it is possible to launch and exit the dialog before it
             * fully loads, so it won't reach the hideMessageArea code provided by the
             * dialog itself.
             */
            DashboardUtil.hideMessageArea();

			if (this.skillassignmentInfo) {
				this.skillassignmentInfo.destroy();
			}
			return true;	
		},
        
		/*
         * This method is called when we click on the OK or Cancel button.
         * Closes the dialog and destroys the widgets.
         * (It is not called if "X" icon or Escape key is pressed.)
         */
        closeDialog: function(){
			if (this.skillDialog) {
				this.skillDialog.close();
				this.skillDialog.destroy();
				this.skillDialog = null;
			}
        },
        
        setRowData: function(){
            this.getController().setRowData(this._row, this._row.id, this._rowIndex);
        },
		
		/* Enter KeyDown Event on grid bring control here */		
		onEnterKeyDown: function(e){	
			dojo.stopEvent(e);
			this._onClick(e);   
        }
		
    });
}
