/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

/** 
 * EPM User widget. While most admin functionality is handled within the
 * Project Management Admin section, user management is instead handled in 
 * the RTC User Management section. All this page needs to do is let the
 * user know this and provide a link to that RTC user mgmt section.
 */
(function(){
    dojo.provide("com.ibm.epm.admin.web.ui.internal.view.user.EPMUser");
    
    dojo.requireLocalization("com.ibm.epm.admin.web.ui", "Messages");
    
    var Messages = dojo.i18n.getLocalization("com.ibm.epm.admin.web.ui", "Messages");
    
    dojo.declare("com.ibm.epm.admin.web.ui.internal.view.user.EPMUser", [dijit._Widget, dijit._Templated], {
    
        templatePath: dojo.moduleUrl("com.ibm.epm.admin.web", "ui/internal/view/user/templates/EPMUser.html"),
        
        /*
         * This widget just needs some text to provide to the user.
         */
        postCreate: function() {
			this._createPageTitle();
            this._createInformationLabel();
        },
		
		/**
         * Creates the page title 
         */
		_createPageTitle:function(){
			this.pageTitle = document.createElement("h1");
			this.pageTitle.innerHTML = Messages.USER_ADMIN_PAGE_TITLE;
			this._pageTitle.appendChild(this.pageTitle);
           
		},
		
        /*
         * Create information label text. The label text includes a link to the new page.
         */
        _createInformationLabel: function() {
			this.informationLabel = document.createElement("label");
            var pageName = Messages.USER_ADMIN_PAGE_NAME;
            var anchor = "<a class=\"\" href=\"#action=jazz.viewPage&id=com.ibm.team.repository.users\">" + pageName + "</a>";
            var text = dojo.string.substitute(Messages.USER_ADMIN_PAGE_HTML, [anchor]);
            this.informationLabel.innerHTML = text;
            this._informationLabel.appendChild(this.informationLabel);            
        }
    });
})();
