/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

(function(){

    dojo.provide("com.ibm.epm.admin.web.ui.internal.view.user.EPMUserCompetenciesGridView");
    
    dojo.require("com.ibm.epm.admin.web.ui.internal.view.competencies.CompetenciesGridView");
    dojo.require("com.ibm.epm.admin.web.ui.internal.view.user.EPMUserCompetencyGridModel");
    dojo.require("com.ibm.epm.web.core.grid.controller.ControllerUtil");
    dojo.require("com.ibm.epm.admin.web.ui.internal.view.user.EPMUserConstants");
	dojo.require("com.ibm.epm.admin.web.client.internal.proficiency.ProficiencyClient");
	dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
	dojo.require("com.ibm.epm.web.core.grid.controller.PubSub");
    
    //Localization
    dojo.requireLocalization("com.ibm.epm.admin.web.ui", "Messages");
    
    var EPMUserCompetenciesGridViewMessages = dojo.i18n.getLocalization("com.ibm.epm.admin.web.ui", "Messages");
    
    var CompetenciesGridView = com.ibm.epm.admin.web.ui.internal.view.competencies.CompetenciesGridView;
	var ProficiencyClient = com.ibm.epm.admin.web.client.internal.proficiency.ProficiencyClient;
	var CompetenciesGridModel = com.ibm.epm.admin.web.ui.internal.view.user.EPMUserCompetencyGridModel;
    var ControllerUtil = com.ibm.epm.web.core.grid.controller.ControllerUtil;
    var EPMUserConstants = com.ibm.epm.admin.web.ui.internal.view.user.EPMUserConstants;
	var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
	var GridEvents = com.ibm.epm.web.core.grid.controller.PubSub;
	
	var selectOptionsForProficiency = [];
	var selectOptionsForProficiencyId = [];
	
	var selectOptionsForCompetency = [];
	var selectOptionsForCompetencyId = [];
    
	dojo.declare("com.ibm.epm.admin.web.ui.internal.view.systemprofile.DynamicSelect", dojox.grid.editors.Select, {
    
        fieldName: null,
        constructor: function(inCell){
        
            this.fieldName = inCell.field;
            
        },
        format: function(inDatum, inRowIndex){
        
        
            if (this.fieldName === EPMUserConstants.PROFICIENCY_LEVEL) {
				if (selectOptionsForProficiency && selectOptionsForProficiency.length > 0) {
					this.options = this.values = selectOptionsForProficiency;
				}
				else {
					this.options = this.values = [];
				}
            }
			if (this.fieldName === EPMUserConstants.NAME) {
				if (selectOptionsForCompetency && selectOptionsForCompetency.length > 0) {
					this.options = this.values = selectOptionsForCompetency;
				}
				else {
					this.options = this.values = [];
				}
            }
            return this.inherited("format", arguments);
        }
    });
    
    var DynamicSelect = com.ibm.epm.admin.web.ui.internal.view.systemprofile.DynamicSelect;
    
    dojo.declare("com.ibm.epm.admin.web.ui.internal.view.user.EPMUserCompetenciesGridView", CompetenciesGridView, {
    
        /* 
         * Builds the rate Grid
         */
        buildCompetencyGrid: function(competenciesLink){
        	var self = this;
			this.getoptions(self.setSelectOptionsForProficiency,EPMUserConstants.PROFICIENCY_URI);
			this.getoptions(self.setSelectOptionsForCompetency,EPMUserConstants.COMPETENCY_URI);
            
            if (!this._gridModel) {
                this._gridModel = new CompetenciesGridModel();
            }
            if (competenciesLink === "") {
                this.userCompetencyGridController = ControllerUtil.getEPMGridController(EPMUserConstants.EPM_USER_COMPETENCY_CONTROLLER_ID, competenciesLink);
            }
            else {
                this.userCompetencyGridController = ControllerUtil.getEPMUserGridController(EPMUserConstants.EPM_USER_COMPETENCY_CONTROLLER_ID, competenciesLink);
            }
            
            this.buildGrid(this, this._gridModel, this.userCompetencyGridController);
        },
		
		postCreate: function(){
			dojo.subscribe(GridEvents.FIELD_CHANGED, this, this.setEditorDirty);			
        },
		
		setEditorDirty: function(args)
		{
			if(this._containingPage && (EPMUserConstants.EPM_USER_COMPETENCY_CONTROLLER_ID == args.controllerID))
				this._containingPage.setDirty(true);
		},
        /*
         * This is called by abstractView while creating the view.
         * getGridLayout() is to return grid structure to abstractView.
         */
        getGridLayout: function(){
        
            var competencyGridLayout = [{
            
                rows: [[{
                    name: EPMUserCompetenciesGridViewMessages.COMPETENCY,
                    width: 14,
                    field: EPMUserConstants.NAME,
					editor: DynamicSelect
                },{
                    name: EPMUserCompetenciesGridViewMessages.PROFICIENCY_LEVEL,
                    width: "auto",
                    field: EPMUserConstants.PROFICIENCY_LEVEL,
					editor: DynamicSelect
                }]]
            
            }];
            
            return competencyGridLayout;
        },
		
		getoptions : function(funtion,uri){
			var self = this;
			var serviceObj = {
                        success: function(data){
                           var collectionElements1 = [];
						   var collectionElements2 = [];
						   for (var i = 0; i < data.length; i++) {							
								collectionElements1.push(data[i].title);
								collectionElements2.push(data[i].relativeHref);
							}
							
						   funtion(collectionElements1,collectionElements2); 
                        },
                        failure: function(errorObj){
                        }
                    };
                    var srh = new ServiceResponseHandler(serviceObj, "success", "failure");
                    ProficiencyClient.getURI(srh, uri);
		},
		
		addAssignment: function()
		{
			var rowID = this._controller.getUniqueRowID(EPMUserConstants.NEW_ELEMENT_UNSAVED_PREFIX);
			var rows = {
				"id": rowID,
                "relativeHref": rowID,
                "name": selectOptionsForCompetency ? selectOptionsForCompetency[0] : "",
                "proficiencyLevel": selectOptionsForProficiency ? selectOptionsForProficiency[0] : "",
				"competencyid":"",
				"pid":""
			};
			this._controller._insertElement(rows, null, false);
			this.scrollToSelectedRow();
            this.startFirstCellEdit();
		},
		
		setSelectOptionsForProficiency: function(options, values){
        	if (options) {
				selectOptionsForProficiency = options;
				selectOptionsForProficiencyId = values;
			}
        },
		
		getSelectOptionsForProficiency: function()
		{
			return selectOptionsForProficiency;
		},
		
		getSelectOptionsForProficiencyId: function()
		{
			return selectOptionsForProficiencyId;
		},
		setSelectOptionsForCompetency: function(options, values){
        	if (options) {
				selectOptionsForCompetency = options;
				selectOptionsForCompetencyId = values;
			}
        },
		
		getSelectOptionsForCompetency: function()
		{
			return selectOptionsForCompetency;
		},
		
		getSelectOptionsForCompetencyId: function()
		{
			return selectOptionsForCompetencyId;
		},
		
		/**
		 * Checks if the list of Competencies contains any value.
		 */
		checkCompetenciesExist: function()
		{
			return (selectOptionsForCompetency && selectOptionsForCompetency.length > 0);
		},
		
		/**
		 * Checks if the list of Proficiencies contains any value.
		 */
		checkProficienciesExist: function()
		{
			return (selectOptionsForProficiency && selectOptionsForProficiency.length > 0);
		}
		
    });
})();
