/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

(function(){
    dojo.provide("com.ibm.epm.work.web.ui.internal.wbsGrids.WBSGanttGridView");
    
    dojo.require("dijit.Toolbar");
    dojo.require("dijit.form.Button");
    dojo.require("dijit.form.TextBox");
    
    dojo.require("com.ibm.epm.web.core.grid.view.AbstractGridView");
    dojo.require("com.ibm.epm.work.web.ui.internal.wbsGrids.WBSGanttGridModel");
    
    dojo.require("com.ibm.epm.work.web.ui.internal.grid.WBSControllerConstants");
    dojo.require("com.ibm.epm.web.core.grid.controller.ControllersFactory");
    dojo.require("com.ibm.epm.web.core.util.internal.DateUtil");
    dojo.require("com.ibm.epm.web.core.ui.internal.EPMGridPubSub");
    dojo.require("com.ibm.epm.web.core.ui.internal.EPMTreePubSub");

    dojo.require("com.ibm.epm.web.core.ui.internal.EPMConfirmDialog");
    dojo.require("com.ibm.epm.web.core.grid.controller.ControllerUtil");
    
    //calculation of schedule  based on project calendar
     dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
     dojo.require("com.ibm.epm.web.core.client.internal.EPMTreeClient");
    
    // Events published by the Grid/Gantt View
    dojo.require("com.ibm.epm.work.web.ui.internal.WBSGridGanttPubSub");
    
    dojo.require("com.ibm.epm.work.web.ui.internal.WBSConstants");
    // EPM Core Constants
    dojo.require("com.ibm.epm.web.core.ui.internal.EPMConstants");
	//Grid column utility
    dojo.require("com.ibm.epm.web.core.util.internal.GridColumnUtil");
	
	dojo.require("com.ibm.epm.work.web.ui.internal.util.WBSUtil");
    
    dojo.requireLocalization("com.ibm.epm.work.web.ui", "Messages");
    
    //calculation of schedule  based on project calendar
    var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
    var EPMTreeClient = com.ibm.epm.web.core.client.internal.EPMTreeClient;
    
    var EPMConstants = com.ibm.epm.web.core.ui.internal.EPMConstants;
    var controllerFactory = com.ibm.epm.web.core.grid.controller.ControllersFactory;
    var dateUtil = com.ibm.epm.web.core.util.internal.DateUtil;
    var controllerUtil = com.ibm.epm.web.core.grid.controller.ControllerUtil;
    
	// Calculated effort based on duration 
	var calcEffortPerDay = 8;
    // One day in milliseconds
    var dayInMilli = 1000 * 60 * 60 * 24;
    var generalControllerID = com.ibm.epm.work.web.ui.internal.grid.WBSControllerConstants.WBSGeneralGridController;
    var controllerID = com.ibm.epm.work.web.ui.internal.grid.WBSControllerConstants.ScheduleGridController;
    var abstractView = com.ibm.epm.web.core.grid.view.AbstractGridView;
    
    var EPMGridPubSub = com.ibm.epm.web.core.ui.internal.EPMGridPubSub;
    var EPMTreePubSub = com.ibm.epm.web.core.ui.internal.EPMTreePubSub;

    var WBSGridGanttPubSub = com.ibm.epm.work.web.ui.internal.WBSGridGanttPubSub;
    
    var WBSConstants = com.ibm.epm.work.web.ui.internal.WBSConstants;
    var EPMConfirmDialog = com.ibm.epm.web.core.ui.internal.EPMConfirmDialog;
    var GridColumnUtil = com.ibm.epm.web.core.util.internal.GridColumnUtil;
	var WBSUtil = com.ibm.epm.work.web.ui.internal.util.WBSUtil;
    var WorkMessages = dojo.i18n.getLocalization("com.ibm.epm.work.web.ui", "Messages");
	
	var mandatoryGetErrorCodes = [
		"CRIPM3687"
	];

    dojo.declare("com.ibm.epm.work.web.ui.internal.wbsGrids.WBSGanttGridView", abstractView, {
        templatePath: dojo.moduleUrl("com.ibm.epm.work.web", "ui/internal/wbsGrids/templates/WBSGeneralGrid.html"),
        
        milestone: "milestone",
        
        //		constructor: function(treeID){
        ////			this.inherited(arguments);
        //		 },

        /**
		 * Method called after a widget's dom has been setup, all initialization and event subscriptions are done here <br>
		 * @param none
		 */
        postCreate: function(){
            this._subscriptions = [
				dojo.subscribe(WBSGridGanttPubSub.ON_GANTT_ROW_SELECT, this, "_selectGridOnRowClick"),
				dojo.subscribe(EPMGridPubSub.ON_CELL_MOUSE_OVER, this, "onCellMouseOver"),
				// Tree event on rename of node
				dojo.subscribe(EPMTreePubSub.ON_RENAME_NODE, this, "_renameNode"),
                
                // Listen to the EPMTree sync grid event on parent-child change (drag-n-drop)
                dojo.subscribe(EPMTreePubSub.ON_PARENT_CHILD_CHANGE_SYNC_GRID, this, "_onParentChildChangeSyncGrid")
			];
            this.buildWBSGanttGrid();
            
            // Initialize the keyboard save event handler for saves from grid.
            // The keyboard save event is fired twice.
            // This boolean allows only one of them to persist the grid. 
            this.eventHandled = false;

            // Initialize the view to listen to the keyboard/special events
            this.subscribeToKeyboardEvents();
            
            // Objects to indicate if there is a pending request from the tree to sync the grid after
            // a drag-n-drop operation
            this.pendingSync = false;
            this.pendingSyncPublishObj = null;
        },

        /**
		 * _renameNode: Event handler when the tree publishes the EPMTreePubSub.ON_RENAME_NODE event.<br>
		 * 
		 * @param {Object} publishObj - The published object contains the tree id, the node.item, old and new values of the name field.
		 */
		_renameNode: function(publishObj) {
			 if ((publishObj) && (publishObj.treeID == WBSConstants.WBS_TREE_ID)) {
			 	var id = publishObj.item.identifier[0];
			 	var item = this._generalGrid.model.store._getItemByIdentity(id);
                if (item) {
					this._generalGrid.model.store._setValueOrValues(item, WBSConstants.NAME_FIELD_NAME, publishObj.newValue, true);
				}
			 }
		},
		        
        /**
         * destroy: destroy the grid view and unsubscribe to events. <br>
         */
        destroy: function(){
            this.inherited(arguments);
            this._unsubscribeToAllEvents();
        },
        
        /**
         * _unsubscribeToAllEvents: Method to unsubscribe to all events. <br>
         */
        _unsubscribeToAllEvents: function(){
            if (this._subscriptions != null) {
                for (var topic in this._subscriptions) {
                    var handler = this._subscriptions[topic];
                    if (handler) {
                        dojo.unsubscribe(handler);
                    }
                }
            }
            this._subscriptions = [];
        },
		
		/**
		 * over written to set the flag for making 
		 * the save calls sequential 
		 */
		persistGrid: function(){
            if (this._generalGrid) {
                this._generalGrid.edit.apply();
                if (this._controller && this._controller.persistGrid) {
                    this._controller.persistGrid(true);
                }
            }
        },
        
        buildWBSGanttGrid: function(){
            if (!this._gridModel) {
                this._gridModel = new com.ibm.epm.work.web.ui.internal.wbsGrids.WBSGanttGridModel();
            }
            if (!this._controller) {
                this._controller = controllerFactory.getGanttController(controllerID);
            }
            if (this._controller.isInitialized() === false) {
                this._controller.initializeController(this._treeID, this, this._gridModel, [WBSConstants.CRITICAL_PATH, WBSConstants.TASK_ASSIGNMENT]);
                this._controller.buildGridModel();
            }
            else {
                this._controller.addViewer(this);
                this.createView(this._controller.getDataModel());
            }
        },
        
        createView: function(){
            this.inherited('createView', arguments);

   			this._generalGrid.autoHeight = true;
			this._generalGrid.update();

            dojo.connect(this._generalGrid, EPMGridPubSub.ON_CELL_DBL_CLICK, this.onCellClick);
            dojo.connect(this._generalGrid, EPMGridPubSub.ON_CELL_CLICK, this.onCellClick);
            dojo.connect(this._generalGrid, "onApplyCellEdit", this, this.onApplyCellEdit);
            dojo.connect(this._generalGrid, "onStartEdit", this, this.onStartEdit);
			dojo.connect(this._generalGrid, "onStyleRow", this, this._onStyleRow);
        },
        
        /**
         * getGridTitle: Returns the title of the grid.
         * Incoming:
         *	none
         * Outgoing:
         *  none
         */
        getGridTitle: function(){
            return WorkMessages.WBS_SCHEDULE_GRID_ID;
        },
        
         /**
         * getGridInternalID: Returns the ID of the grid.
         * Incoming:
         *	none
         * Outgoing:
         *  none
         */
        getGridInternalID: function(){
            return WBSConstants.WBS_SCHEDULE_GRID_ID;
        },
        /**
         *  _selectGridOnRowClick : Event handler for row click event of WBSGeneralGrid
         *  Incoming :
         *  	data - event object
         *		data.gridID - unique identifier of the grid
         *		data.row - rowIndex
         *  Outgoing : none
         *
         */
        _selectGridOnRowClick: function(data){
            // Listen to the mousehover event of the Gantt
            if ((data) && (data.gridID == WBSConstants.WBS_SCHEDULE_GRID_ID)) {
                if (this._generalGrid) {
                    this._generalGrid.selection.select(data.rowIndex);
                    this._generalGrid._selected = data.rowIndex;
                }
            }
        },
        
        /**
         * newRowInserted: 	Overriding abstractView.newRowInserted()
         * @param {Object} row
         * @param {Object} rowID
         * @param {Object} rowIndex
         */
        newRowInserted: function(row, rowID, rowIndex){
            this.inherited(arguments);
            
            // Default the start and finish date to the parent's start date if its a new row
            if (row.parentId) {
                if (rowID.indexOf(EPMConstants.NEWElEMENTSUFFIX) != -1) {
                    var parentRowIndex = this._controller.getRowIndex(row.parentId);
                    var parentRow = this._controller.getRowByIndex(parentRowIndex);
                    if (parentRow) {
                        var item = this._generalGrid.model.store._getItemByIdentity(row.id);
                        if (item) {
                            var proposedstart = "";
                            if (dojo.isArray(parentRow.proposedstart)) {
                                proposedstart = parentRow.proposedstart[0];
                            }
                            else {
                                proposedstart = parentRow.proposedstart;
                            }
                            
                            var current = new Date();
                            if (dateUtil.compareDates(current, proposedstart) > 0) {
                                proposedstart = current;
                            } 
                            this._generalGrid.model.store._setValueOrValues(item, WBSConstants.PROPOSED_START_FIELD_NAME, proposedstart, true);
							this._generalGrid.model.store._setValueOrValues(item, WBSConstants.PLANNED_START_FIELD_NAME, proposedstart, true);
                            this._generalGrid.model.store._setValueOrValues(item, WBSConstants.PROPOSED_FINISH_FIELD_NAME, proposedstart, true);
							this._generalGrid.model.store._setValueOrValues(item, WBSConstants.PLANNED_FINISH_FIELD_NAME, proposedstart, true);
                        }
                    }
                }
            }
        },
        
		/*
         * Override the function defined in EPMGrid.
         */
        isCellEditable: function(event) {
			var editable = this._isCellEditable(event);
			if ((editable == false) || (!event.cell.editor)) {
				// if the cell is not editable, reset the cellEditing var
				this.cellEditing = null;
			}
				
			return editable;
        },
        
		/*
         * Internal method to do the necessary validations and return true if the cell is not editable, false if it editable
         */		
		_isCellEditable: function(event) {
            var rowIndex = parseInt(event.rowIndex, 10);
            if (isNaN(rowIndex)) {
                return true;
            }
			//If some editing is in progress for another cell, apply the changes first. 
			if (this.cellEditing && (!(this.cellEditing == event.cell))) {
				var edit = this._generalGrid.edit;
				var isEditing = edit.isEditing();
				if (isEditing) {
					edit.apply();
				}
				this.cellEditing = null;
			}			
			//If the row is blocked (for auto calculatation), return false.
			if((this.blockedRowIndex && (this.blockedRowIndex == rowIndex))){
				return false;
			}
			
            var row = this._getTreeBasedController().getRowByIndex(rowIndex);
			if (row) {
				//For iteration we will not consider the assignments/child elements, Hence marking the proposed schedule fields as editable.
				if (row.resourcetype == WBSConstants.ITERATION_TYPE &&
				((event.cell.field === WBSConstants.PROPOSED_START_FIELD_NAME) ||
				(event.cell.field === WBSConstants.PROPOSED_FINISH_FIELD_NAME) ||
				(event.cell.field === WBSConstants.PROPOSED_DURATION_FIELD_NAME))) {
					return true;
				}				
				if(!WBSUtil.isfieldEditableScheduleGrid(row, event.cell.field)){
					
					return false;
					
				} else if (event.cell.field === WBSConstants.PERCENT_DC_FIELD_NAME &&
					this._editableDC(row.loadedelement)) {
						return true;
				} else {
					return true;
				}
			}
        },
        
        /**
         * _editableDC: Determines if the loadedElement has an active user task assignment
         * Incoming: element representing the row to examine.
         * Outgoing: true to indicate a valid user task assignment for which %DC can be
         *			 edited.  False if no active assignment or if only an active profile assignment
         */
        _editableDC: function(loadedElement){
        	for (var i = 0; i < loadedElement[0].TaskAssignment.length; i++) {
            	if (loadedElement[0].TaskAssignment[i].title == "true") {
            		if (loadedElement[0].TaskAssignment[i].relativeHref.match("^profile")) {
            			return false;
            		} else {
            			return true;
            		}
              	}
            }
        	return false;
        },

        /**
         * _getTreeBasedController: To create/return the controller.
         * 							Added extra check for TreeBasedGridController._gridData. In case not found, recreating the controller again.
         * 							This extra check is because some times, the controller is partailly available without gridData.
         * Incoming: none.
         * Outgoing: TreeBasedGridController.
         */
        _getTreeBasedController: function(){
            if (!this.TreeBasedGridController) {
                this.TreeBasedGridController = controllerUtil.getTreeBasedGridController(controllerID);
            }
            if ((this.TreeBasedGridController) && (!this.TreeBasedGridController._gridData)) {
                delete this.TreeBasedGridController;
                this.TreeBasedGridController = controllerUtil.getTreeBasedGridController(controllerID);
            }
            return this.TreeBasedGridController;
        },
        
        /**
		 * This will fetch the dates from the project calendar 
		 * by making a call to IWebUiService
		 * On success the row is updated , 
		 * if there is a failure nothing is done , the simple calculation will be 
		 * taken 
		 * The duration and the finish date fields are updated 
		 * update the effort also
		 * @param {Object} projectId
		 * @param {Object} params
		 */
       _getProposedScheduleFromCalendar: function(params,item, bModifyPlannedSchedule,inRowIndex){
			var tempThis = this;
			
			var serviceObj= {
				success: function(response)
				 {
					if (params.bProposedDuration == true && params.bProposedFinishDate == false && response != null && response.duration)
					{
						tempThis._generalGrid.model.store._setValueOrValues(item, WBSConstants.PROPOSED_DURATION_FIELD_NAME, response.duration, true);
						if (bModifyPlannedSchedule) {
							tempThis._generalGrid.model.store._setValueOrValues(item, WBSConstants.PLANNED_DURATION_FIELD_NAME, response.duration, true);
						}

						 if(response.effort >= 0)
						 {
							tempThis._generalGrid.model.store._setValueOrValues(item, WBSConstants.PROPOSED_EFFORT_FIELD_NAME, response.effort, true);
							if (bModifyPlannedSchedule) {
								tempThis._generalGrid.model.store._setValueOrValues(item, WBSConstants.PLANNED_EFFORT_FIELD_NAME, response.effort, true);
							}
						 }
						 else
						 {
						 	tempThis._generalGrid.model.store._setValueOrValues(item, WBSConstants.PROPOSED_EFFORT_FIELD_NAME, response.duration * 8, true);
							if (bModifyPlannedSchedule) {
								tempThis._generalGrid.model.store._setValueOrValues(item, WBSConstants.PLANNED_EFFORT_FIELD_NAME, response.duration * 8, true);
							}
						 }
					}
		            if (params.bProposedDuration == false && params.bProposedFinishDate == true && response != null && response.finishDate)
					{
						 tempThis._generalGrid.model.store._setValueOrValues(item, WBSConstants.PROPOSED_FINISH_FIELD_NAME, dateUtil.parseDate(response.finishDate), true);
						 if (bModifyPlannedSchedule) {
						 	tempThis._generalGrid.model.store._setValueOrValues(item, WBSConstants.PLANNED_FINISH_FIELD_NAME, dateUtil.parseDate(response.finishDate), true);
						 }
						 
						 if(response.effort)
						 {
						 	tempThis._generalGrid.model.store._setValueOrValues(item, WBSConstants.PROPOSED_EFFORT_FIELD_NAME, response.effort, true);
							if (bModifyPlannedSchedule) {
								tempThis._generalGrid.model.store._setValueOrValues(item, WBSConstants.PLANNED_EFFORT_FIELD_NAME, response.effort, true);
							}
						 }
						  else
						 {
						 	tempThis._generalGrid.model.store._setValueOrValues(item, WBSConstants.PROPOSED_EFFORT_FIELD_NAME, response.duration * 8, true);
							if (bModifyPlannedSchedule) {
								tempThis._generalGrid.model.store._setValueOrValues(item, WBSConstants.PLANNED_EFFORT_FIELD_NAME, response.duration * 8, true);
							}
						 }					
					}
						 tempThis._generalGrid.model.store._setValueOrValues(item, WBSConstants.PROPOSED_START_FIELD_NAME, dateUtil.parseDate(response.startDate), true);
						 tempThis._generalGrid.model.store._setValueOrValues(item, WBSConstants.PROPOSED_FINISH_FIELD_NAME, dateUtil.parseDate(response.finishDate), true);
						 if (bModifyPlannedSchedule) {
							tempThis._generalGrid.model.store._setValueOrValues(item, WBSConstants.PLANNED_START_FIELD_NAME, dateUtil.parseDate(response.startDate), true);
							tempThis._generalGrid.model.store._setValueOrValues(item, WBSConstants.PLANNED_FINISH_FIELD_NAME, dateUtil.parseDate(response.finishDate), true);
						 }

						//Unblock the row.
						 var index = tempThis.blockedRowIndex;
						 tempThis.blockedRowIndex = null;
						 tempThis._generalGrid.updateRowStyles(index);

						//As store._setValueOrValues in turn wipes off the focus, hence added code to focus the cell.
						//WI 14915
						tempThis._generalGrid.focus.focusGrid();	
						
						 //Once auto calculation is complete , update the other listeners like Gantt with fresh data 
						 var row = tempThis._generalGrid.model.getRow(inRowIndex);
                			if (row && row.id && inRowIndex){
								 tempThis._controller._propogateUpdateElement(row, row.id, inRowIndex);
							}				 
				},
				
				failure: function(errorObj) {
					//Unblock the row in case of error.
					 var index = tempThis.blockedRowIndex;
					 tempThis.blockedRowIndex = null;
					 tempThis._generalGrid.updateRowStyles(index);
					 
					 tempThis._generalGrid.focus.focusGrid();
					  //Once auto calculation is complete , update the other listeners like Gantt with fresh data
					 var row = tempThis._generalGrid.model.getRow(inRowIndex);
                			if (row && row.id && inRowIndex){
								 tempThis._controller._propogateUpdateElement(row, row.id, inRowIndex);
							}
				}
			};
			
			var srh= new ServiceResponseHandler(serviceObj, "success", "failure");			
			EPMTreeClient.getProposedFromCalendar(srh,params);			
		},

		_onStyleRow: function(row) {
			if (this._controller && this._controller._gridData && this._controller._gridData.getRow) {
				var modelRow = this._controller._gridData.getRow(row.index);
				if (modelRow && row.index == this.blockedRowIndex) {
					if(!(row.customClasses.indexOf("nonEditableRow") > -1)){
						row.customClasses += " nonEditableRow";
					}
				}
				if(modelRow && modelRow.errorObject){
					row.customClasses += " epmGridErrorRow";
				}
			}
		},
		
		/**
		 * Return the project id 
		 * If its a new unsaved element 
		 * get it from the containingProject
		 * @param {Object} row
		 */
		_getProjectIdFromRow: function(row){
			if(row)
			{ 
				/**
				 * For new unsaved elements
				 * If the parent of the unsaved is iteration case is not handled 
				 * currently
				 */
					if (row.id && row.id.indexOf(EPMConstants.NEWElEMENTSUFFIX) != -1)
					{
					  var parentRowIndex = this._controller.getRowIndex(row.parentId);
	                  var parentRow = this._controller.getRowByIndex(parentRowIndex);
						   
						   if(!parentRow)
							{
							  return WBSConstants.EMPTY_STRING;	
							}
						   if(parentRow && parentRow.resourcetype && parentRow.resourcetype == WBSConstants.EPM_PROJECT_TYPE && parentRow.href)
							{
							   return this._getResourceIDFromURI(parentRow.href);
							}
							
							if(parentRow && parentRow.containingProject)
							{
								return this._getResourceIDFromURI(parentRow.containingProject);
							}
					
					}
				
					if(row.resourcetype && row.resourcetype == WBSConstants.EPM_PROJECT_TYPE)
						{
						return this._getResourceIDFromURI(row.href);
						}
						
					if(row.resourcetype && (row.resourcetype == WBSConstants.EPM_PROGRAM_TYPE))
					    {
							return WBSConstants.EMPTY_STRING;
						}
					if(row.loadedelement && row.loadedelement[0] && row.loadedelement[0].containingProject)
					{
						return this._getResourceIDFromURI(row.loadedelement[0].containingProject);
					}
			   
			}
		},
		
		/**
		 * Method to get the resourceID from URI. 
		 * @param {Object} relativeHref: HREF from which resourceID will be parsed
		 */
        _getResourceIDFromURI: function(relativeHref){
			if(relativeHref == null || relativeHref == WBSConstants.EMPTY_STRING)
			{
				return WBSConstants.EMPTY_STRING;
			}
            var index = relativeHref.lastIndexOf("/");
            if (index > 0) {
                return relativeHref.substring(index + 1, relativeHref.length);
            }
        },

        onStartEdit: function(inCell, inRowIndex){
			this.cellEditing = inCell;
            var row = this._generalGrid.model.getRow(inRowIndex);
            if (row) {
                this.curCellField = inCell.field;
                
                // Flag used to indicate if the updation needs to be propagated to other viewers
                this.updateFlag = false;
                
                if (inCell.field === "proposedduration") {
                    // save the oldVal of duration to handle the invalid entry case
                    this.proposeddurationOldVal = row.proposedduration;
                }
                
                if (inCell.field === WBSConstants.PROPOSED_START_FIELD_NAME) {
                    // save the oldVal of start date to handle the invalid entry case
                    this.proposedstartOldVal = row.proposedstart;
                    // save the oldVal of end date to handle the invalid entry case
                    this.proposedfinishOldVal = row.proposedfinish;
                    
                    // Publish an event for the schedule viewlet to disable the
                    // save button. The button is enabled when the date editor
                    // is either applied or canceled.
                    dojo.publish(WBSGridGanttPubSub.ON_DATE_EDITOR, [inCell.editor]);
                }
                
                if (inCell.field === WBSConstants.PROPOSED_FINISH_FIELD_NAME) {
                    // save the oldVal of start date to handle the invalid entry case
                    this.proposedstartOldVal = row.proposedstart;                
                    // save the oldVal of end date to handle the invalid entry case
                    this.proposedfinishOldVal = row.proposedfinish;
                    
                    // Publish an event for the schedule viewlet to disable the
                    // save button. The button is enabled when the date editor
                    // is either applied or canceled.
                    dojo.publish(WBSGridGanttPubSub.ON_DATE_EDITOR, [inCell.editor]);
                }
                
                if (inCell.field === WBSConstants.PROPOSED_EFFORT_FIELD_NAME) {
                    // save the oldVal of proposed effort to handle the invalid entry case
                    this.proposedeffortOldVal = row.proposedeffort;
                }
				
				if (inCell.field === WBSConstants.ACTUAL_START_FIELD_NAME) {
                    // save the oldVal of actual start to handle the invalid entry case
                    this.actualStartOldVal = row.actualstart;
                }
				
				if (inCell.field === WBSConstants.ACTUAL_FINISH_FIELD_NAME) {
                    // save the oldVal of actual finish to handle the invalid entry case
                    this.actualFinishOldVal = row.actualfinish;
                }

				if (inCell.field === WBSConstants.PERCENT_DC_FIELD_NAME) {
                    // save the oldVal of percentDC to handle the invalid entry case
                    this.percentDCOldVal = row.percentDC;
                }
            }
            
        },
		/**
		 * Populate the the params for auto calculation considering the calendar 
		 * with the fresh data 
		 * @param {Object} row
		 */
		populateTheParams : function(params,row)
		{
			if(params && row)
			{
			params.sProposedStartDate = dateUtil.formatDateForSave(row.proposedstart);
			params.sProposedFinishDate = dateUtil.formatDateForSave(row.proposedfinish);
			params.iProposedDuration = row.proposedduration;
			params.resourceType = row.resourcetype;
			params.workitemType = row.workItemType;
			}	
		
		   return params;
		},
		
        
        /**
         *  onApplyCellEdit : Event handler when "onApplyCellEdit" event is fired for the cell in the grid
         *  Incoming :
         *  	inValue - changed value for the cell
         *		inRowIndex - index of the row the cell belongs to
         *		inFieldIndex - index of the cell as per the grid layout
         *  Outgoing : none
         *  
         *  If the item is saved one , 
         *  Then on the change of any of the three ( start , finish , duration ) 
         *  A call is made to the server to get the correct set depending on the 
         *  calendar of that project . 
         *  This will be only temporary data on client , but it should give the correct 
         *  dates as the server will actually do if we go ahead and save 
         *
         */
        onApplyCellEdit: function(inValue, inRowIndex, inFieldIndex){
			
			this.cellEditing = null;
			
            var row = this._generalGrid.model.getRow(inRowIndex);
            if (row) {
				// projectId for the calendar 
				var projectId = this._getProjectIdFromRow(row);
				if(!projectId)
				 {
				 	projectId = WBSConstants.EMPTY_STRING;
				 }
				// build the params
							var params = {
								"sProposedStartDate": dateUtil.formatDateForSave(row.proposedstart),
								"sProposedFinishDate" : dateUtil.formatDateForSave(row.proposedfinish),
								"iProposedDuration": row.proposedduration,
								"iProjectId" : projectId,
								"resourceType" : row.resourcetype,
								"workitemType" : row.workItemType
							              };
                var item = this._generalGrid.model.store._getItemByIdentity(row.id);
                if (item) {
                    var cellFieldName = this.curCellField;
                    var bModifyPlannedSchedule = (!(row.resourcetype == WBSConstants.ITERATION_TYPE && row.hasChildren));
					
                    switch (cellFieldName) {
                        case WBSConstants.PROPOSED_START_FIELD_NAME:
						    params.bProposedDuration = true;
							params.bProposedFinishDate = false;
							
							// Flag to indicate that a call to change the finish was also made
							// by handleChangeInProposedStartDate()
							this.finishDateChanged = false;
							this.handleChangeInProposedStartDate(inValue, item, row, inRowIndex, bModifyPlannedSchedule);
							
							// Trigger calculation based on the finish date (as opposed to schedule)
							// if the finish date was changed
							if (this.finishDateChanged) {
							    this.finishDateChanged = false;
                                params.bProposedDuration = false;
                                params.bProposedFinishDate = true;
                                params.sProposedFinishDate = dateUtil.formatDateForSave(row.proposedfinish);				    
							}
							// get the fresh values 
							params = this.populateTheParams(params,row);
							
							if(this.updateFlag == true && row.resourcetype != WBSConstants.EPM_PROGRAM_TYPE)
							{
								this.blockedRowIndex = inRowIndex;
								this._getProposedScheduleFromCalendar(params,item, bModifyPlannedSchedule,inRowIndex);
							} 
							break;
                            
                        case WBSConstants.PROPOSED_FINISH_FIELD_NAME:
							params.bProposedDuration = true;
							params.bProposedFinishDate = false;
							row.startDateSelected = false;
							
							// Flag to indicate that the call to handleChangeInProposedFinishDate() is not
							// being made as a result of changing the start date
							var triggeredOnStartDateChange = false;
                            this.handleChangeInProposedFinishDate(inValue, item, row, inRowIndex, bModifyPlannedSchedule, triggeredOnStartDateChange);
							// get the fresh values 
							params = this.populateTheParams(params,row);
							
							if(this.updateFlag == true && row.resourcetype != WBSConstants.EPM_PROGRAM_TYPE)
							{
								this.blockedRowIndex = inRowIndex;
								this._getProposedScheduleFromCalendar(params,item, bModifyPlannedSchedule,inRowIndex);
							}
						
							break;
                            
                        case "proposedduration":
							params.bProposedDuration = false;
							params.bProposedFinishDate = true;
						    this.handleChangeInDuration(inValue, item, row);
							// get the fresh values 
							params = this.populateTheParams(params,row);
							
							if(this.updateFlag == true && row.resourcetype != WBSConstants.EPM_PROGRAM_TYPE)
							{
								this.blockedRowIndex = inRowIndex;
								this._getProposedScheduleFromCalendar(params,item, bModifyPlannedSchedule,inRowIndex);
							}
						
							
                            break;
						
						case WBSConstants.PERCENT_DC_FIELD_NAME:
							this.handleChangeInDurationComplete(inValue, item, row, inRowIndex);
							break;

						case WBSConstants.ACTUAL_START_FIELD_NAME:
							this.handleChangeInActualStartDate(inValue, item, row, inRowIndex);
							break;

						case WBSConstants.ACTUAL_FINISH_FIELD_NAME:
							this.handleChangeInActualFinishDate(inValue, item, row, inRowIndex);
							break;								
                    }
                    
                    if (this.updateFlag == true) 
					{							
                        this._controller._propogateUpdateElement(row, row.id, inRowIndex);
                    }
					if(this.blockedRowIndex){
						this._generalGrid.updateRowStyles(inRowIndex);
					}
                }
            }
        },

        /**
         *  handleChangeInActualStartDate : Handles client side validation when actual start is modified
         *  Incoming :
         *  	newValue - changed value for actual start
         *		item - item in the store
         *		row - contents of the row of modified value
         *  Outgoing : none
         *
         */
        handleChangeInActualStartDate: function(newValue, item, row, inRowIndex){
			if (!newValue) {
				if (row.percentDC > 0) {
					// If %DC is set, actualStartDate cannot be empty set the value of the cell to oldVal
					this._generalGrid.model.store._setValueOrValues(item, WBSConstants.ACTUAL_START_FIELD_NAME, this.actualStartOldVal, true);
				} else {
					// set the value of the cell to empty value (-) in case user entered an invalid value
					this._generalGrid.model.store._setValueOrValues(item, WBSConstants.ACTUAL_START_FIELD_NAME, "-", true);
				}
			}
		},

        /**
         *  handleChangeInActualFinishDate : Handles client side validation when actual finish is modified
         *  Incoming :
         *  	newValue - changed value for actual finish
         *		item - item in the store
         *		row - contents of the row of modified value
         *  Outgoing : none
         *
         */
        handleChangeInActualFinishDate: function(newValue, item, row, inRowIndex){
			if (!newValue) {
				if (row.percentDC < 100) {
					// set the value of the cell to oldVal in case user entered an invalid value
					this._generalGrid.model.store._setValueOrValues(item, WBSConstants.ACTUAL_FINISH_FIELD_NAME, "-", true);
				} else {
					// If %DC is 100, actualFinishDate cannot be empty set its value to oldVal
					this._generalGrid.model.store._setValueOrValues(item, WBSConstants.ACTUAL_FINISH_FIELD_NAME, this.actualFinishOldVal, true);
				}
			}
		},
		
        /**
         *  handleChangeInDurationComplete : Handles client side validation when percentage duration is modified
         *  Incoming :
         *  	newValue - changed value for percentDC
         *		item - item in the store
         *		row - contents of the row of modified value
         *  Outgoing : none
         *
         */
        handleChangeInDurationComplete: function(newValue, item, row, inRowIndex){
			if ((!newValue) || (isNaN(newValue)) || (newValue < 0) || 
				!this._editableDC(row.loadedelement)) {
				// set the value of the cell to oldVal in case user entered an invalid value
				this._generalGrid.model.store._setValueOrValues(item, WBSConstants.PERCENT_DC_FIELD_NAME, this.percentDCOldVal, true);
			}
			else {
				var today = new Date();
				if ((newValue > 0) && (row.actualstart == "-")) {
					// set the value for actual start to today
					this._generalGrid.model.store._setValueOrValues(item, WBSConstants.ACTUAL_START_FIELD_NAME, today, true);
				}
				
				if (newValue == 100) {
					// set the value for actual finish to today
					if (dateUtil.compareDates(row.actualstart, today) > 0) {
						// set actualFinish to actualStart if actualStart is set to a value greater than today
						this._generalGrid.model.store._setValueOrValues(item, WBSConstants.ACTUAL_FINISH_FIELD_NAME, row.actualstart, true);
					} else {
						this._generalGrid.model.store._setValueOrValues(item, WBSConstants.ACTUAL_FINISH_FIELD_NAME, today, true);
					}
				} else {
					// set the value for actual finish to today
					this._generalGrid.model.store._setValueOrValues(item, WBSConstants.ACTUAL_FINISH_FIELD_NAME, "-", true);					
				}
			}
		},
		
        /**
         *  handleChangeInProposedStartDate : Handles client side validation and auto calculations when the start date is modified
         *  Incoming :
         *  	newValue - changed value for start date
         *		item - item in the store
         *		row - contents of the row of modified value
         *  Outgoing : none
         *
         */
        handleChangeInProposedStartDate: function(newValue, item, row, inRowIndex, bModifyPlannedSchedule){
            if (!newValue) {
                // set the value of the cell to oldVal in case user entered an invalid value
                this._generalGrid.model.store._setValueOrValues(item, WBSConstants.PROPOSED_START_FIELD_NAME, this.proposedstartOldVal, true);
            }
            else {
                // Check if there is any change in the value
                if (dateUtil.compareDates(newValue, this.proposedstartOldVal) != 0) {
					if (bModifyPlannedSchedule) {
						this._generalGrid.model.store._setValueOrValues(item, WBSConstants.PLANNED_START_FIELD_NAME, newValue, true);
					}
					
					row.startDateSelected = true;
                    row.proposedstart = newValue;
                    
                    // Get a new finish date based on the duration
                    var newFinishDate = newValue;
                    if (row.proposedduration != 0) {
                        newFinishDate = dateUtil.updateDaysInDate(newValue, row.proposedduration - 1);
                    }
                      
                    // Check if the user chose a start date that is beyond the current finish date 
                    if (dateUtil.compareDates(newValue, row.proposedfinish) > 0) {
                        
                        // Check if the new finish date will be after the current finish date
                        // If yes, then update the finish date to that date
                        if (dateUtil.compareDates(newFinishDate, row.proposedfinish) > 0) {
                            row.proposedfinish = newFinishDate;
                            var triggeredOnStartDateChange = true;
                            var bModifyPlannedSchedule = (!(row.resourcetype == WBSConstants.ITERATION_TYPE && row.hasChildren));
                            this.handleChangeInProposedFinishDate(newFinishDate, item, row, inRowIndex, 
                                bModifyPlannedSchedule, triggeredOnStartDateChange);
                            
                            // Set a flag to trigger server's calculation based on the finish date
                            // This is used to change the param's map for the server call made to
                            // do the calculation based on the project's calendar
                            // For details, see onApplyCellEdit()'s case for Proposed Start Date
                            this.finishDateChanged = true;
                        }
                    }
                                                	
					// Check if this is the case for a saved milestone item
                    if (row.id.indexOf(EPMConstants.NEWElEMENTSUFFIX) == -1) {
                        if (row.id.indexOf(this.milestone) != -1) {
                            // set the finishdate to the new value of the start date
                            this._generalGrid.model.store._setValueOrValues(item, WBSConstants.PROPOSED_FINISH_FIELD_NAME, newValue, true);
                            if (bModifyPlannedSchedule) {
                                this._generalGrid.model.store._setValueOrValues(item, WBSConstants.PLANNED_FINISH_FIELD_NAME, newValue, true);
                            }
                            row.proposedfinish = newValue;
                        }	
                    }
                    this.updateFlag = true;
                }
            }   
        },
        
        /**
         *  handleChangeInProposedFinishDate : Handles client side validation and auto calculations when the finish date is modified
         *  Incoming :
         *  	newValue - changed value for finish date
         *		item - item in the store
         *		row - contents of the row of modified value
         *  Outgoing : none
         *
         */
        handleChangeInProposedFinishDate: function(newValue, item, row, inRowIndex, bModifyPlannedSchedule, triggeredOnStartDateChange){
            if (!newValue) {
                // set the value of the cell to oldVal in case user entered an invalid value
                this._generalGrid.model.store._setValueOrValues(item, WBSConstants.PROPOSED_FINISH_FIELD_NAME, this.proposedfinishOldVal, true);
            }
            else {
                // Check if there is any change in the value
                if (dateUtil.compareDates(newValue, this.proposedfinishOldVal) != 0) {
                    // Validate if the enddate is lesser than the start date, if yes revert to old value
                	if (newValue < row.proposedstart) {
                        this._generalGrid.model.store._setValueOrValues(item, WBSConstants.PROPOSED_FINISH_FIELD_NAME, this.proposedfinishOldVal, true);
                    }
                    else {
						if (bModifyPlannedSchedule) {
							this._generalGrid.model.store._setValueOrValues(item, WBSConstants.PLANNED_FINISH_FIELD_NAME, newValue, true);
						}

                        var dialogDisplayed = false;
                        
                        // Not all elements have the constraint values
                        if ((row.loadedelement) && (row.loadedelement[0].constraint)) {
                            var constraintType = row.loadedelement[0].constraint.constraintType;
                            var constraintDate = row.loadedelement[0].constraint.constraintDate;
                            if (constraintDate && (constraintType != WBSConstants.AS_SOON_AS_POSSIBLE)) {
                                constraintDate = dateUtil.parseDate(constraintDate);
                                if (!isNaN(constraintDate)) {
                                    if (newValue > constraintDate) {
                                        
                                        dialogDisplayed = true;
                                        var buttonlist = [{
                                            label: WorkMessages.OK,
                                            action: dojo.hitch(this, this._finishYesButtonHandler, row, item, newValue, 
                                                inRowIndex, triggeredOnStartDateChange)
                                        }, {
                                            label: WorkMessages.CANCEL,
                                            action: dojo.hitch(this, this._finishNoButtonHandler, row, item, newValue,
                                                inRowIndex)
                                        }];
                                        var labelList;                                        
                                        var dialogHeader = dojo.string.substitute(WorkMessages.SCHEDULE_NOT_SAVED_DIALOG, [WorkMessages.FNLT_CONSTRAINT]);
                                        
                                        // If the call to this method was made as a result of changing the
                                        // start date, then indicate that in the dialog
                                        if (triggeredOnStartDateChange) {
                                            
                                            var startDateString = dateUtil.formatDate(row.proposedstart);
                                            var finishDateString = dateUtil.formatDate(newValue);
                                            var startDateMessage = dojo.string.substitute(WorkMessages.SCHEDULE_NOT_SAVED_DIALOG_2, 
                                                [startDateString, finishDateString]);
                                            
                                            labelList = [{
                                                label: startDateMessage
                                            }, {
                                                label: dialogHeader
                                            }, {
                                                label: WorkMessages.SCHEDULE_SAVE_CONFIRMATION
                                            }];
                                            
                                        } else {
                                            labelList = [{
                                                label: dialogHeader
                                            }, {
                                                label: WorkMessages.SCHEDULE_SAVE_CONFIRMATION
                                            }];
                                        }
                                        
                                        // The naming convention is mandatory :- for list of buttons, use buttonlist 
                                        // for list of messages:- labelList
                                        // buttonlist, labellist are defined in the EPMConfirmDialog
                                        var titleMessage = dojo.string.substitute(WorkMessages.SCHEDULE_DIALOG_NOT_SAVED, 
                                            [WorkMessages.FINISH_DATE]);
                                        this._generalGrid.edit.cancel();
                                        this.scheduleSaveDialog = new EPMConfirmDialog({
                                            labelList: labelList,
                                            title: titleMessage,
                                            buttonlist: buttonlist
                                        });
                                        
                                        this.scheduleSaveDialog.show();
                                    }
                                }
                            }
                        }
                        
                        if (!dialogDisplayed) {
                            
                            if (row.startDateSelected == true) {
                                row.proposedfinish = newValue;
                                row.startDateSelected = false;
                                this._generalGrid.model.store._setValueOrValues(item, WBSConstants.PROPOSED_FINISH_FIELD_NAME, newValue, true);
                            }
                            
                            // Do post processing. 
                            // NOTE: Post processing for the case when the dialog 
                            // is displayed will be done by the dialog's handler.
                            this._finishPostProcessing(row, item, newValue);
                        }
                    }
                }
            }   
        },
        
		/**
		 * Method called when user clicks on 'Yes' to remove the constraint in order to save finish date changes.
		 * @param {Object} row: Row for which the finish date has been updated.
		 * @param {Object} item: store item corresponding to the row.
		 * @param {Object} newValue: New value of the finish date.
		 * @param {Object} inRowIndex: Index of the row for which the finish date was updated.
		 * @param {Object} triggeredOnStartDateChange: true if start date changes triggered the finish date update. 
		 */
        _finishYesButtonHandler: function(row, item, newValue, inRowIndex, triggeredOnStartDateChange){
            // The user asked to break the constraint
            this.scheduleSaveDialog.destroy();
			
			//If start date has triggered the finish date changes, finish date field would have the calendar based finish date value.
			//Track this.finishDateChanged for the relevant changes.
			if (!triggeredOnStartDateChange) {
				this._generalGrid.model.store._setValueOrValues(item, WBSConstants.PROPOSED_FINISH_FIELD_NAME, newValue, true);
				this._generalGrid.model.store._setValueOrValues(item, WBSConstants.PLANNED_FINISH_FIELD_NAME, newValue, true);
			}

            this._generalGrid.model.store._setValueOrValues(item, "constraintType", 
                WBSConstants.AS_SOON_AS_POSSIBLE, true);
            this._generalGrid.model.store._setValueOrValues(item, "constraintDate", 
                " - ", true);    
            
            if (row.startDateSelected == true) {
//              row.proposedfinish = newValue;
                row.startDateSelected = false;
            }
            
            var generalGridController = controllerUtil.getTreeBasedGridController(generalControllerID);
            if (generalGridController.isInitialized()) {
                
                if (generalGridController._viewers && generalGridController._viewers.length > 0) {
                    
                    // Find a valid view to use
                    var viewToUse = null;
                    for (var i in generalGridController._viewers) {
                        var view = generalGridController._viewers[i];
                        
                        if (view) {
                            viewToUse = view;
                            break;
                        }
                    }    
                    
                    if (viewToUse) {
                        var generalGrid = viewToUse._generalGrid;
                        if (generalGrid) {
                            var generalItem = generalGrid.model.store._getItemByIdentity(row.id);
                            if (generalItem) {
                                generalGrid.model.store._setValueOrValues(generalItem, "constraintType", 
                                    WBSConstants.AS_SOON_AS_POSSIBLE, true);
                            
                                generalGrid.model.store._setValueOrValues(generalItem, "constraintDate", 
                                    " - ", true);
                            
                                generalGridController._propogateUpdateElement(row, row.id, inRowIndex);
                            }
                        }       
                    }       
                }
            } 
            
            // Do post processing for the new finish date
            this._finishPostProcessing(row, item, newValue);
        },
        
        _finishNoButtonHandler: function(row, item, newValue, inRowIndex){
            // The user asked to keep the constraint
            
            this.scheduleSaveDialog.destroy();
            this._generalGrid.model.store._setValueOrValues(item, WBSConstants.PROPOSED_START_FIELD_NAME, this.proposedstartOldVal, true);
            this._generalGrid.model.store._setValueOrValues(item, WBSConstants.PROPOSED_FINISH_FIELD_NAME, this.proposedfinishOldVal, true);
            
            var bModifyPlannedSchedule = (!(row.resourcetype == WBSConstants.ITERATION_TYPE && row.hasChildren));
            if (bModifyPlannedSchedule) {
                this._generalGrid.model.store._setValueOrValues(item, WBSConstants.PLANNED_START_FIELD_NAME, this.proposedstartOldVal, true);
                this._generalGrid.model.store._setValueOrValues(item, WBSConstants.PLANNED_FINISH_FIELD_NAME, this.proposedfinishOldVal, true);
            }
            
            // NOTE: No post processing needed since we reverted to old finish date         
        },
        
        _finishPostProcessing: function(row, item, newValue) {
            
            if (row.id.indexOf(this.milestone) != -1) {
                // set the finishdate to the new value of the start date
                this._generalGrid.model.store._setValueOrValues(item, WBSConstants.PROPOSED_START_FIELD_NAME, newValue, true);
				this._generalGrid.model.store._setValueOrValues(item, WBSConstants.PLANNED_START_FIELD_NAME, newValue, true);
                row.proposedstart = newValue;
            }
                        
            this.updateFlag = true;
        },
        
        /**
         *  handleChangeInDuration : Handles client side validation and auto calculations when the duration is modified
         *  Incoming :
         *  	newValue - changed value for duration
         *		item - item in the store
         *		row - contents of the row of modified value
         *  Outgoing : none
         *
         */
        handleChangeInDuration: function(newValue, item, row, bModifyPlannedSchedule){
			var error;
            if ((!newValue) || (isNaN(newValue)) || (newValue <= 0)) {
				if (newValue != this.proposeddurationOldVal) {
					// set the value of the cell to oldVal in case user entered an invalid value
					this._generalGrid.model.store._setValueOrValues(item, WBSConstants.PROPOSED_DURATION_FIELD_NAME, this.proposeddurationOldVal, true);
					if ((!newValue) || isNaN(newValue)) {
						error = {
							errorMessage: dojo.string.substitute(WorkMessages.NON_NUMERIC_DURATION_NOT_ALLOWED, [row.name])
						};
					}
					else {
						error = {
							errorMessage: dojo.string.substitute(WorkMessages.NEGATIVE_DURATION_NOT_ALLOWED, [row.name])
						};
					}
					this.handleError(error);
				}
            }
            else {
				if (row.proposedduration.indexOf('.') != -1) {
						error = {
							errorMessage: dojo.string.substitute(WorkMessages.DECIMAL_DURATION_NOT_ALLOWED, [row.name])
						};
						this.handleError(error);
						row.proposedduration = this.proposeddurationOldVal;
						newValue = this.proposeddurationOldVal;
				}
				
                if ((row.id.indexOf(this.milestone) != -1) && (newValue != 1)) {
                    newValue = 1;
                    this._generalGrid.model.store._setValueOrValues(item, WBSConstants.PROPOSED_DURATION_FIELD_NAME, newValue, true);
                }
                
                // Check if there is any change in the value
                if (newValue != this.proposeddurationOldVal) {
					if (bModifyPlannedSchedule) {
						this._generalGrid.model.store._setValueOrValues(item, WBSConstants.PLANNED_DURATION_FIELD_NAME, newValue, true);
					}
                    // both start and end dates are already set
                    if ((row.proposedstart !== "") && (row.proposedfinish !== "")) {
                        // calculate end date based on new value of duration
                        this.proposedfinishOldVal = row.proposedfinish;
                        row.proposedfinish = dateUtil.updateDaysInDate(row.proposedstart, newValue - 1);
                        this._generalGrid.model.store._setValueOrValues(item, WBSConstants.PROPOSED_FINISH_FIELD_NAME, row.proposedfinish, true);
						if (bModifyPlannedSchedule) {
							this._generalGrid.model.store._setValueOrValues(item, WBSConstants.PLANNED_FINISH_FIELD_NAME, row.proposedfinish, true);
						}
                    }
                    
                    // start date is not yet set and end date is set
                    if ((row.proposedstart === "") && (row.proposedfinish !== "")) {
                        // calculate start date based on new value of duration and existing value of end date
                        this.proposedstartOldVal = row.proposedstart;
                        row.proposedstart = dateUtil.updateDaysInDate(row.proposedfinish, 1 - newValue);
                        this._generalGrid.model.store._setValueOrValues(item, WBSConstants.PROPOSED_START_FIELD_NAME, row.proposedstart, true);
						if (bModifyPlannedSchedule) {
							this._generalGrid.model.store._setValueOrValues(item, WBSConstants.PLANNED_START_FIELD_NAME, row.proposedstart, true);
						}
                    }
                    
                    // end date is not yet set and start date is set
                    if ((row.proposedstart !== "") && (row.proposedstart === "")) {
                        // calculate end date based on new value of duration and existing value of start date
                        this.proposedfinishOldVal = row.proposedfinish;
                        row.proposedfinish = dateUtil.updateDaysInDate(row.proposedfinish, newValue - 1);
                        this._generalGrid.model.store._setValueOrValues(item, WBSConstants.PROPOSED_FINISH_FIELD_NAME, row.proposedfinish, true);
						if (bModifyPlannedSchedule) {
							this._generalGrid.model.store._setValueOrValues(item, WBSConstants.PLANNED_FINISH_FIELD_NAME, row.proposedfinish, true);
						}
                    }
                    
                    // update the effort
                    this.proposedeffortOldVal = row.proposedeffort;
					calcEffortPerDay = this.proposedeffortOldVal / this.proposeddurationOldVal;
                    row.proposedeffort = newValue * calcEffortPerDay;
                    this._generalGrid.model.store._setValueOrValues(item, WBSConstants.PROPOSED_EFFORT_FIELD_NAME, row.proposedeffort, true);
					if (bModifyPlannedSchedule) {
						this._generalGrid.model.store._setValueOrValues(item, WBSConstants.PLANNED_EFFORT_FIELD_NAME, row.proposedeffort, true);
					}
                    
                    this.updateFlag = true;
                }
            }
        },
        
		/**
		 * Show a tooltip if the iteration has planned schedule beyond proposed. <br> 
		 * @param {Object} publishedObj
		 */
		onCellMouseOver: function(publishedObj){
			if(publishedObj){
				if(publishedObj.gridID == WBSConstants.WBS_SCHEDULE_GRID_ID && publishedObj.cellNode && publishedObj.rowIndex > -1 && publishedObj.cell && publishedObj.cell.field){
					if (publishedObj.cell.field == WBSConstants.PROPOSED_START_FIELD_NAME || publishedObj.cell.field == WBSConstants.PROPOSED_FINISH_FIELD_NAME ||
					publishedObj.cell.field == WBSConstants.PROPOSED_DURATION_FIELD_NAME) {
						if (this.isIterationBehindSchedule(publishedObj.rowIndex) == true) {
							//TODO: Verify by Neeti.
							publishedObj.cellNode.title = WorkMessages.ITERATION_SCHEDULE_TOOLTIP;
						}
					}
				}
			}	
		},

		/**
		 * If the iteration is running behind schedule return true <br>
		 * @param {Object} inRowIndex
		 */
		isIterationBehindSchedule: function(inRowIndex){
			
			if ( (this._controller) && (this._controller._gridData) ) {
	            var row = this._controller._gridData.getRow(inRowIndex);
	           if (row && row.resourcetype == WBSConstants.ITERATION_TYPE) {
			   	if ((dateUtil.compareDates(row.proposedfinish, row.plannedfinish) < 0) ||
			   			(dateUtil.compareDates(row.proposedstart, row.plannedstart) > 0)) {
					return true;		
			   	}
			   }
			}
		   return false;
		},
		
		
        onCellClick: function(event){
            if (event) {
                if ((event.cell.field == WBSConstants.PROPOSED_START_FIELD_NAME) || (event.cell.field == WBSConstants.PROPOSED_FINISH_FIELD_NAME)) {
                    var row;
                    row = this.model.getRow(event.rowIndex);
                    if (row) {
                        var dateTextEditor = event.cell.editor.editor;
                        if (dateTextEditor) {                            
                            if ((event.cell.field === WBSConstants.PROPOSED_FINISH_FIELD_NAME) && (row.proposedstart !== "")) {
                                // Disable all dates before start date
                                dojo.mixin(dateTextEditor.constraints, {
                                    min: row.proposedstart
                                });
                            }
                            dateTextEditor.rangeMessage = "End date cannot be earlier than start date";
                            dateTextEditor.invalidMessage = "Invalid date.";
                        }
                        else {
                            // date picker hasn't been instantiated set the constraints in the cell                            
                            if ((event.cell.field === WBSConstants.PROPOSED_FINISH_FIELD_NAME) && (row.proposedstart !== "")) {
                                // disable all dates before start date
                                dojo.mixin(event.cell.constraint, {
                                    min: row.proposedstart
                                });
                            }
                        }
                    }
                } // startDate && endDate
				else if (event.cell.field == WBSConstants.PROPOSED_DURATION_FIELD_NAME) {
					var numTextEditor = event.cell.editor.editor;
					if (numTextEditor) {
						numTextEditor.rangeMessage = "Duration cannot be negative";
						numTextEditor.invalidMessage = "The value entered is not valid.  Enter Duration in number of days";
					}
				}
			}
        },
        
        getAttachpoint: function(){
            return this.wbsGenGridAttachPoint;
        },

        /**
         *  handleError : Inherited method which is called to handle any error messages
         */         
        handleError: function(error, row, rowID){
			
			if(rowID && this.mandateError(error)){
				this._markRowAsInvalid(error, rowID);
				 this._displayError(error);
				return;
			}
            this.inherited("handleError", arguments);
            this._displayError(error);

			// since the save failed the save button is enabled
			this._viewlet.toggleSaveButton(false);
        },
		
		mandateError: function(error){
			var mandatoryError = false;
			for(var i in mandatoryGetErrorCodes){
				if(error.errorCode.indexOf(mandatoryGetErrorCodes[i]) != -1){
					mandatoryError = true;
				}
			}
			return mandatoryError;
		},

		/**
		 * Format the proposed schedule for iteration if it is planned beyond the proposed dates
		 * @param {Object} inData
		 * @param {Object} inRowIndex
		 */
		 _formatIterationSchedule: function(inData, inRowIndex){
		 	
            var row = null;
            if (this.grid && this.grid.model) {
                row = this.grid.model.getRow(inRowIndex);
            }
			if (row) {
				if(this.field == WBSConstants.PROPOSED_START_FIELD_NAME || this.field == WBSConstants.PROPOSED_FINISH_FIELD_NAME){
					inData = dateUtil.formatDate(inData);
				}
				if (this.field == WBSConstants.PROPOSED_DURATION_FIELD_NAME) {
					inData = GridColumnUtil.formatDays(inData);
				}
				if (this.field == WBSConstants.PROPOSED_DURATION_FIELD_NAME || this.field == WBSConstants.PROPOSED_START_FIELD_NAME || this.field == WBSConstants.PROPOSED_FINISH_FIELD_NAME) {
		           if (row && row.resourcetype == WBSConstants.ITERATION_TYPE) {
					   	if ((dateUtil.compareDates(row.proposedfinish, row.plannedfinish) < 0) ||
						(dateUtil.compareDates(row.proposedstart, row.plannedstart) > 0)) {
							var font = "font-weight: bold;";
							this.customStyles.push(font);
							var color = "color : rgb(255,69,0);"
							this.customStyles.push(color);
						}
					}
				}
				if(!WBSUtil.isfieldEditableScheduleGrid(row, this.field)){
					var color = "color : #999999"
					this.customStyles.push(color);
				}
			}
			
			return inData;
		 },

		/**
		 * Format the Actual schedule And Percentage DC
		 * @param {Object} inData
		 * @param {Object} inRowIndex
		 */
		 _columnFormatter: function(inData, inRowIndex){
		 	
            var row = null;
            if (this.grid && this.grid.model) {
                row = this.grid.model.getRow(inRowIndex);
            }
			if (row) {
				if(this.field == WBSConstants.ACTUAL_START_FIELD_NAME || this.field == WBSConstants.ACTUAL_FINISH_FIELD_NAME){
					inData = dateUtil.formatDate(inData);
				}
				if (this.field == WBSConstants.PERCENT_DC_FIELD_NAME) {
					inData = GridColumnUtil.formatPercentage(inData);
				}
				if(!WBSUtil.isfieldEditableScheduleGrid(row, this.field)){
					var color = "color : #999999"
					this.customStyles.push(color);
				}
			}
			
			return inData;
		 },

        /**
         *  getGridLayout : Method defines the grid layout, these attributes are static.<br>
         */        
        getGridLayout: function(){
            var gridLayout = [{
                noscroll: false,
                //                defaultCell: {styles: 'text-align: left;'},
                rows: [[{
                    name: WorkMessages.WBS_SCHEDULE_PROPOSED_START, //1
                    width: 7,
                    field: WBSConstants.PROPOSED_START_FIELD_NAME,
					formatter: this._formatIterationSchedule,
                    editor: dojox.grid.editors.DateTextBox,
                    editorClass: "dijit.form.DateTextBox",
                    constraint: {
                        formatLength: 'short',
                        selector: "date"
                    }
                }, {
                    name: WorkMessages.WBS_SCHEDULE_PROPOSED_FINISH, //2
                    width: 7,
                    field: WBSConstants.PROPOSED_FINISH_FIELD_NAME,
					formatter: this._formatIterationSchedule,
                    editor: dojox.grid.editors.DateTextBox,
                    editorClass: "dijit.form.DateTextBox",
                    constraint: {
                        formatLength: 'short',
                        selector: "date"
                    }
                }, {
                    name: WorkMessages.WBS_SCHEDULE_PROPOSED_DURATION, //3
                    width: 7,
					formatter: this._formatIterationSchedule,
					styles: 'text-align: right;',
                    field: WBSConstants.PROPOSED_DURATION_FIELD_NAME,
                    editor: dojox.grid.editors.Input
                }, {
                    name: WorkMessages.WBS_SCHEDULE_PROPOSED_EFFORT, //4
                    width: 6,
					formatter: GridColumnUtil.formatHours,
					styles: 'text-align: right;padding-right: 6px;',
                    field: WBSConstants.PROPOSED_EFFORT_FIELD_NAME
				}, {
                    name: WorkMessages.WBS_SCHEDULE_PLANNED_START, // 5
                    width: 7,
					styles: 'padding-right: 6px;',
                    field: WBSConstants.PLANNED_START_FIELD_NAME,
					formatter: dateUtil.formatDate
                }, {
                    name: WorkMessages.WBS_SCHEDULE_PLANNED_FINISH, // 6
                    width: 7,
                    field: WBSConstants.PLANNED_FINISH_FIELD_NAME,
					formatter: dateUtil.formatDate
                }, {
                    name: WorkMessages.WBS_SCHEDULE_PLANNED_DURATION, // 7
                    width: 7,
					formatter: GridColumnUtil.formatDays,
					styles: 'text-align: right;',					
                    field: WBSConstants.PLANNED_DURATION_FIELD_NAME
                }, {
                    name: WorkMessages.WBS_SCHEDULE_PLANNED_EFFORT, // 8
                    width: 6,
					formatter: GridColumnUtil.formatHours,
					styles: 'text-align: right;padding-right: 6px;',					
                    field: WBSConstants.PLANNED_EFFORT_FIELD_NAME
				}, {
                    name: WorkMessages.WBS_SCHEDULE_ACTUAL_START, // 5
                    width: 7,
					styles: 'padding-left: 6px;',
                    field: WBSConstants.ACTUAL_START_FIELD_NAME,
					formatter:this._columnFormatter,
                    editor: dojox.grid.editors.DateTextBox,
                    editorClass: "dijit.form.DateTextBox",
                    constraint: {
                        formatLength: 'short',
                        selector: "date"
                    }
                }, {
                    name: WorkMessages.WBS_SCHEDULE_ACTUAL_FINISH, // 6
                    width: 7,
                    field: WBSConstants.ACTUAL_FINISH_FIELD_NAME,
					formatter: this._columnFormatter,
                    editor: dojox.grid.editors.DateTextBox,
                    editorClass: "dijit.form.DateTextBox",
                    constraint: {
                        formatLength: 'short',
                        selector: "date"
                    }
                }, {
                    name: WorkMessages.WBS_SCHEDULE_ACTUAL_EFFORT, // 8
                    width: 7,
					formatter: GridColumnUtil.formatHours,
					styles: 'text-align: right; padding-right: 6px;',					
                    field: WBSConstants.ACTUAL_EFFORT_FIELD_NAME
				}, {
                	name: WorkMessages.WBS_SCHEDULE_PERCENT_C,
                	width: 2,
					formatter: GridColumnUtil.formatPercentage,
					styles: 'text-align: right; styles:padding-right: 2px;',					
                	field: WBSConstants.PERCENT_C_FIELD_NAME
				}, {
                	name: WorkMessages.WBS_SCHEDULE_PERCENT_EC,
                	width: 3,
					formatter: GridColumnUtil.formatPercentage,
					styles: 'text-align: right;padding-right: 2px;',					
                	field: WBSConstants.PERCENT_EC_FIELD_NAME
                }, {
					name: WorkMessages.WBS_SCHEDULE_PERCENT_DC,
                	width: 3,
					formatter: this._columnFormatter,
					styles: 'text-align: right;',					
                	field: WBSConstants.PERCENT_DC_FIELD_NAME,
					editor: dojox.grid.editors.Dijit,
	                editorClass: "dijit.form.NumberTextBox",
	                constraint: {
	                    min: 0,
						max: 100
	                },
	                rangeMessage: WorkMessages.NEGATIVE_DC_NOT_ALLOWED,
    	            invalidMessage: WorkMessages.NON_NUMERIC_DC_NOT_ALLOWED
				}]]
            }];
            
            return gridLayout;
        },
        
        saveInProgress: function() {
            if (this._viewlet) {
            	if (this._viewlet.saveInProgress) {
                    this._viewlet.saveInProgress();
            	}    
            }   
        },
        
        saveComplete: function() {
            
            if (this.pendingSync) {
                if (this.pendingSyncPublishObj) {
                    this._requestGridToSync(this.pendingSyncPublishObj);
                    this.pendingSyncPublishObj = null; 
                }
                this.pendingSync = false;
            }
            
            if (this._viewlet) {
            	if (this._viewlet.saveComplete) {
                    this._viewlet.saveComplete();
            	}    
            }   
        },
        
        /*
         * Method used to handle keyboard events from the tree
         * Currently, this method is used to respond to only the 
         * TAB key (to move from the tree to the grid) and the save
         * keyboard action of CTRL+S.
         */
        _onKeyDownFromTree: function(data) {
			if (this._viewlet) {
				// Set this variable to indicate there was a key down/press from the tree
				this._viewlet._onKeyDownFromTree = true;
			}
			
            if (data.nodeWidgetItem) {
                var rowIndex = this._validateAndGetRow(data.nodeWidgetItem);
                // Set the focus on the correct row
                if (this._generalGrid) {
                    if (rowIndex >= 0) {
                        var keys = dojo.keys;
                        // Check if the tab key was pressed
                        if (data.keySet.keyCode == keys.TAB) {
                            
                            // Set the focus to the first cell on the selected row
                            this._generalGrid.selection.select(rowIndex);
                            this._generalGrid.focus.setFocusIndex(rowIndex,0);
                            return;
                        } else {
                            // Check if CTRL+S was pressed to save the grid
                            if (data.keySet.ctrlKey && data.keySet.keyCode === 83) {
                                
                                // Check if the grid is already being saved
                                // Ignore this call to save if that was the case
                                if (this._viewlet) {
                                    if (!this._viewlet.isSaveInProgress()) {
                                        // Save the grid
                                        this._viewlet.persistViewlet();
                                    }    
                                }
                                                            
                                // This is to override the browser's standard
                                // save page dialog from popping up.
                                data.event.preventDefault();
                            }
                        }    
                    }        
                }
            }
        },
        
		_onKeyDownFromGrid: function(event) {
			if (event.keyCode === dojo.keys.DELETE) {

				// Handle remove of WBS element: Delete key
				this._removeWBSCommand();
			} else if (event.keyCode === dojo.keys.INSERT) {
                
				// Handle creation of new element: Insert key
				
                // This is to override the browser's default (if any)
                event.preventDefault();
                
                var keySetObj = {
                    keyCode: event.keyCode
                };
                
                var data = {
                    keySet: keySetObj,
                    event: event
                };
                console.log("publish the event");
                dojo.publish(EPMTreePubSub.ON_REQUEST_NEW_NODE, [data]);
           }
			// Check if CTRL+S was pressed
            if (event.ctrlKey && event.keyCode === 17) {			
				// This is to override the browser's standard
				// save page dialog from popping up.
				event.preventDefault();
				if (this.eventHandled === false) {
                   this.eventHandled = true;
                   
                   // Check if the grid is already being saved
                   // Ignore this call to save if that was the case
                   if (this._viewlet) {
                      if (!this._viewlet.isSaveInProgress()) {
                         // Save the grid
                         this._viewlet.persistViewlet();
                      }
                   }
               }
               // Reset the handler boolean
               this.eventHandled = false;
			}

		},
        
        /**
         * Method to handle the parent-child change initiated from the tree
         * 
         * @param {Object} publishObj: {
         *      treeID: ID of the tree.
         *      collectionItemHandle: information about the item(s) which need
         *          to be synchronized.
         * }
         */
        _onParentChildChangeSyncGrid: function(publishObj) {
            if (publishObj) {
                
                var unsavedChanges = false;
                
                // Check if the viewlet is active or not
                if (this._viewlet) {
                    if (this._viewlet.getSite){
                        var site = this._viewlet.getSite();
                        if (site) {
                            if (site.isActive) {
                                var active = site.isActive();
                                if (active) {
                                    // Since the viewlet is active, 
                                    // check if its save button is enabled or not
                                    if (this._viewlet.isButtonEnabled) {
                                        unsavedChanges = this._viewlet.isButtonEnabled();
                                    }
                                }
                            }
                        }                    
                    }
                }
                
                if (unsavedChanges) {
                    // Prompt the user if they would like to save the changes
                    this._discardUnsavedChanges(publishObj);
                }
                else {
                    
                    // Nothing needs to be saved. Go ahead and sync the grid.
                    this._requestGridToSync(publishObj);
                }    
            }
        },
        
        /**
         * Prompts the user to indicate if they would like to save/discard
         * unsaved changes in the grid.
         *  
         * @param {Object} publishObj {
         *      treeID: ID of the tree.
         *      collectionItemHandle: information about the items which need
         *          to be synchronized.
         * }
         */
        _discardUnsavedChanges: function(publishObj){
            var buttonlist = [{
                label: WorkMessages.YES,
                action: dojo.hitch(this, this._saveChanges, publishObj)
            }, {
                label: WorkMessages.NO,
                action: dojo.hitch(this, this._cancelOperation, publishObj)
            }];
            
            var labelList = [
                {label: WorkMessages.CONFIRM_TO_SAVE_UNSAVED_CHANGES},
                {label: WorkMessages.CONFIRM_TO_SAVE_UNSAVED_CHANGES_2}
            ];
            
            this.discardUnsavedDialog = new EPMConfirmDialog({
                labelList: labelList,
                title: WorkMessages.DISCARD_CHANGES_TITLE,
                buttonlist: buttonlist
            });
            
            // Make sure that the cancel operation is handled even when the user clicks
            // on the 'X' button to close the dialog or hits ESC on the keyboard
            dojo.connect(this.discardUnsavedDialog.dialog, "onCancel", this, 
                this._handleCancelOperation, publishObj);
                
            this.discardUnsavedDialog.show();
        },
        
        /**
         * Handles the saving of the unsaved changes in the grid.
         * 
         * @param {Object} publishObj {
         *      treeID: ID of the tree.
         *      collectionItemHandle: information about the items which need
         *          to be synchronized.
         * }
         */
        _saveChanges: function(publishObj){
            this.discardUnsavedDialog.destroy();
            
            // Save the grid first
            this.persistGrid();
            
            // Save the request to sync the structure in a variable
            this.pendingSync = true;
            this.pendingSyncPublishObj = publishObj;
        },
        
        /**
         * Handles the discarding of the unsaved changes in the grid.
         * 
         * @param {Object} publishObj {
         *      treeID: ID of the tree.
         *      collectionItemHandle: information about the items which need
         *          to be synchronized.
         * }
         */
        _cancelOperation: function(publishObj){
            this.discardUnsavedDialog.destroy();
            this._handleCancelOperation(publishObj);
        },
        
        /**
         * Discards the unsaved changes and refreshes all rows of the grid.
         * 
         * @param {Object} publishObj {
         *      treeID: ID of the tree.
         *      collectionItemHandle: information about the items which need
         *          to be synchronized.
         * }
         */
        _handleCancelOperation: function(publishObj) {    
            // User indicated nothing needs to be saved. Go ahead and sync the grid.
            if (this._viewlet) {
                if (this._viewlet.setDeleteAndFetch && this._viewlet.refresh) {
                    this._viewlet.setDeleteAndFetch();
                    this._viewlet.refresh();        
                } else {
                    // We should never hit this case but if we ever do,
                    // then make sure the grid matches the tree. Also
                    // logging a message that we hit this block.
                    this._requestGridToSync(publishObj);
                    console.log("WBSGanttGrid._cancelOperation: Viewlet missing refresh method");
                }
            } else {
                // We should never hit this case but if we ever do,
                // then make sure the grid matches the tree. Also
                // logging a message that we hit this block.
                this._requestGridToSync(publishObj);
                console.log("WBSGanttGrid._cancelOperation: Viewlet reference missing");
            }
        },
        
        /**
         * Makes a request to the grid's controller to update itself.
         * 
         * @param {Object} publishObj {
         *      treeID: ID of the tree.
         *      collectionItemHandle: information about the items which need
         *          to be synchronized.
         */
        _requestGridToSync: function(publishObj) {
            if (publishObj && this._controller && this._controller._onParentChildChangeSyncGrid) {
                this._controller._onParentChildChangeSyncGrid(publishObj);
            }
        }
    });

	// Intercept with the DateTextBox setValue to ensure it does not setValue for empty string
	var oldSetValue = dojox.grid.editors.DateTextBox.prototype.setValue;
	dojox.grid.editors.DateTextBox.prototype.setValue = function(inRowIndex, inValue){
		if (inValue == "-") {
			var textbox = this.editor.textbox;
			if ((textbox) && (textbox.value)) {
				textbox.value = "";
			}
			return;
		}
		oldSetValue.apply(this, arguments);
	};
})();
