/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
    dojo.provide("com.ibm.epm.resource.assignment.web.ui.internal2.AssignedResourcesGridModel");
    
    dojo.require("com.ibm.epm.web.core.grid.model.AbstractGridModel");
    dojo.require("com.ibm.epm.web.core.grid.controller.ControllerUtil");
    
    // Localization
    dojo.requireLocalization("com.ibm.epm.resource.assignment.web.ui", "Messages");
    
    //Constants
    dojo.require("com.ibm.epm.resource.assignment.web.ui.internal2.ResourceAssignmentViewletConstants");
    
    //Client
    dojo.require("com.ibm.epm.resource.assignment.web.client.internal.ResourceAssignmentClient");
    dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
    // Dialogs
    dojo.require("com.ibm.epm.web.core.ui.internal.EPMErrorHandler");
    dojo.require("com.ibm.epm.web.core.util.internal.Constants");
    
    //Date Util
    dojo.require("com.ibm.epm.web.core.util.internal.DateUtil");
	
	//Assignment Util
	dojo.require("com.ibm.epm.resource.assignment.web.ui.internal2.AssignmentUtil");
	
	var AssignmentUtil = com.ibm.epm.resource.assignment.web.ui.internal2.AssignmentUtil;
    var abstractGridModel = com.ibm.epm.web.core.grid.model.AbstractGridModel;
    var getLink = com.ibm.epm.web.core.grid.controller.ControllerUtil.getLink;
    var ResourceAssignmentViewletMessages = dojo.i18n.getLocalization("com.ibm.epm.resource.assignment.web.ui", "Messages");
    var ResourceAssignmentClient = com.ibm.epm.resource.assignment.web.client.internal.ResourceAssignmentClient;
    var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
    var DateUtil = com.ibm.epm.web.core.util.internal.DateUtil;
    var Constants = com.ibm.epm.resource.assignment.web.ui.internal2.ResourceAssignmentViewletConstants;
    var EPMConstants = com.ibm.epm.web.core.util.internal.Constants;
    var controllerUtil = com.ibm.epm.web.core.grid.controller.ControllerUtil;
    var EPMErrorHandler = com.ibm.epm.web.core.ui.internal.EPMErrorHandler;
	
	var MAX_TASK_ASSIGNMENT_SHOWN_IN_TOOLTIP = 5;
    
    dojo.declare("com.ibm.epm.resource.assignment.web.ui.internal2.AssignedResourcesGridModel", abstractGridModel, {
        newElementPrefix: Constants.UNSAVED,
        wbsNodeID: "",
        wbsNodeType: "",
		containingProjectId:"",
        
        
        // Stores the grid which is used to assign the resource - queryGrid, ProjectAssignment Grid or ProjectProfile Grid
        sourceGrid: "",
        
        //Schdule check flag
        //        invalidScheduleFlag: [],
        
        /*
         * Constructor
         */
        constructor: function(nodeId, nodeType,containingProjectId){
            this.wbsNodeID = nodeId;
            this.wbsNodeType = nodeType;
			this.containingProjectId = containingProjectId;
        },
        
        
        setWBSNodeIdAndType: function(nodeId, nodeType,containingProjectId){
        
            this.wbsNodeID = nodeId;
            this.wbsNodeType = nodeType;
			this.containingProjectId = containingProjectId;
        },
        /*
         * This is called by controller. Returns the empty row structure to the controller.
         */
        getEmptyRow: function(rowID, collectionItemHandle){
        
            //If the Flag is undefined, the data is pulled from the server and contolled by the 
            //Abstract controller
            //else the data is inserted directly by the View
            
            if (!rowID) {
                return null;
            }
            var row;
            
            if (rowID.indexOf(this.newElementPrefix) == -1) {
                row = {
                    "id": rowID,
                    "href": rowID,
                    "name": " ",
                    "role": "",
                    "proposedstart": "",
                    "proposedduration": "",
                    "proposedfinish": "",
                    "effort": "",
					"assignedeffort":"0",
                    "contourType": "",
                    "value": "", 
                    "resourceRelativeHref": "",
                    "costRate": "",
                    "labourChargecode": "",
                    "labourChargecodeUri": "",
                    "sellingRate": "",
                    "revenueChargecode": "",
                    "revenueChargecodeUri": "",
                    "scheduleId": "",
                    "profileName": "",
                    "profileDescription": "",
                    "profileExperienceInYear": "",
                    "profileSkills": "",
                    "profileCompetencies": "",
                    "action": "",
                    "profileTemplateId": "",
                    "replaceWith": "",
                    "task": "0",
                    "tooltipHTML": "",
					"unassign": false,
					"active": true,
					"lastModifiedField":""
					
                };
            }
            else {
            
            
                row = {
                    "id": rowID,
                    "href": rowID,
                    "name": collectionItemHandle.name,
                    "role": (collectionItemHandle.role == Constants.DEFAULT_ROLE) ? "": collectionItemHandle.role,
                    "proposedstart": collectionItemHandle.proposedstart,
                    "proposedduration": collectionItemHandle.proposedduration,
                    "proposedfinish": collectionItemHandle.proposedfinish,
                    "effort": collectionItemHandle.effort,
					"assignedeffort":collectionItemHandle.assignedeffort,
                    "contourType": collectionItemHandle.contourType,
                    "value": collectionItemHandle.value,
                    "resourceRelativeHref": collectionItemHandle.resourceRelativeHref,
                    "costRate": collectionItemHandle.costRate,
                    "labourChargecode": "",
                    "labourChargecodeUri": "",
                    "sellingRate": collectionItemHandle.sellingRate,
                    "revenueChargecode": "",
                    "revenueChargecodeUri": "",
                    "scheduleId": "",
                    "profileName": collectionItemHandle.profileName,
                    "profileDescription": collectionItemHandle.profileDescription,
                    "profileExperienceInYear": collectionItemHandle.profileExperienceInYear,
                    "profileSkills": collectionItemHandle.profileSkills,
                    "profileCompetencies": collectionItemHandle.profileCompetencies,
                    "action": "",
                    "profileTemplateId": collectionItemHandle.profileTemplateId,
                    "replaceWith": "",
                    "task": "0",
                    "tooltipHTML": "",
					"unassign": false,
					"active": true,
					"lastModifiedField":""
                };
            }
            
            return row;
        },
        
        getAssignedLink: function(loadedElement, linkIDs){
            for (var i in linkIDs) {
                var link = loadedElement[linkIDs[i]];
                if (link) {
                    if (dojo.isArray(link)) {
                        link = link[0];
                    }
                    return link;
                }
            }
        },
        
        
        /*
         * Sets the value for source grid
         */
        setSourceGrid: function(gridName){
        
            this.sourceGrid = gridName;
            
        },
        
        /*
         * This is called by controller.
         * After inserting a row in Grid, the getAndUpdateRow() calls updateRowData with RowURI, RowID params.
         */
        updateRowDetails: function(row, loadedElement){
        
            if (this.wbsNodeType === EPMConstants.EPM_PROJECT) {
                var self = this;
				var resourceId = "";
				var isUserQuery = true;
                if (loadedElement.profile) {
                    resourceId = loadedElement.profile.id;
					isUserQuery = false;
                }
                else if (loadedElement.User) {
                        resourceId = loadedElement.User.relativeHref;
						isUserQuery = true;
                }
				
                var serviceObject = {
                
                    success: function(itemInfo){
                       var tooltipHTML = null;                        
					    if (itemInfo) {					    	
						    tooltipHTML = self.createTooltipHTML(itemInfo, row);
							var taskLength = 0;                       		                  		
							taskLength = row.task;
                        }
                        if (tooltipHTML) {
                            row.tooltipHTML = tooltipHTML;
                        }
						var controller = controllerUtil.getEPMAssignmentGridController(Constants.ASSIGNED_RESOURCES_GRID_ID);
						var dataModel = controller.getDataModel(); 
						if ( dataModel ) {
							var item = dataModel.store._getItemByIdentity(row.id);
							if (item) {
								dataModel.store._setValueOrValues(item, "assignedeffort", row.assignedeffort, true);
								if (taskLength > 0) {								
									dataModel.store._setValueOrValues(item, "task", taskLength, true);								
								}
							}
							
						}
                    },
                    failure: function(errorObj){
                    
                    }
                };
               
			   var srh = new ServiceResponseHandler(serviceObject, "success", "failure");
			   var startDate = DateUtil.formatDateForSave(row.proposedstart, {
                    datePattern: 'yyyy-MM-dd',
                    selector: 'date'
                });
			   var finishDate = DateUtil.formatDateForSave(row.proposedfinish, {
                    datePattern: 'yyyy-MM-dd',
                    selector: 'date'
                });
			   if(isUserQuery){
			   		
	                var titleObj = dojo.fromJson(loadedElement.Project.title);
					var categoryId = titleObj.category;
	                var projectName = titleObj.summary || title;
					
					var args = {
						projectId: self.wbsNodeID.substring(self.wbsNodeID.indexOf("/")+1),
						userId: resourceId.substring(resourceId.lastIndexOf("/")+1),
						projectAllocationId: row.scheduleId,
						expand:true
						};
	                ResourceAssignmentClient.getAllTaskAssignmentForUser(srh, args);
				}else{
					
					var args = {
						profileId: resourceId,
						startDate: startDate,
                		finishDate: finishDate,
						expand:true
					};
					ResourceAssignmentClient.getAllTaskAssignmentsForProfile(srh, args);
					
				}
            }
        },
        
        /*
         *
         */
        createTooltipHTML: function(itemInfo, row){       	
        	 
        	var activeTaskCount = 0; 
            if (itemInfo) {            	
               var resultString = "";
				var totalNumberOfTasks = 0;
				totalNumberOfTasks = itemInfo.length;
				var numberOfTasks = (totalNumberOfTasks > MAX_TASK_ASSIGNMENT_SHOWN_IN_TOOLTIP) ? MAX_TASK_ASSIGNMENT_SHOWN_IN_TOOLTIP : totalNumberOfTasks; 
				if (numberOfTasks > 0) {
					var div = '<div class="com-ibm-epm-resource-assignment-web-ui-internal2-AssignedResourceGrid-tooltipMessageClass">' + totalNumberOfTasks + " " + ResourceAssignmentViewletMessages.NUMBER_OF_TASKS_ASSIGNED_TO + " " + row.name + '</div>';
					resultString = resultString + div;
				}
				var table = '<table class="com-ibm-epm-resource-assignment-web-ui-internal2-AssignedResourceGrid-tooltipTable">';
				var assignedEffort = 0;
                for (var i = 0; i < totalNumberOfTasks; i++) { 
          
          			if(itemInfo[i].taskAssignment.active) {
          				activeTaskCount = activeTaskCount + 1;
          			}
          			    
					var titleObj;
//					if(isUserQuery){
//						titleObj = dojo.fromJson(itemInfo.QueryResult[i].Task.title);
//					}else{
						var title = "";	
						if(itemInfo[i] && itemInfo[i].taskAssignment && 
							itemInfo[i].taskAssignment.Task && itemInfo[i].taskAssignment.Task.title)
						{	
							title = dojo.fromJson(itemInfo[i].taskAssignment.Task.title);
						}	
						titleObj = title;
//					}
                    var _taskName = titleObj.summary;
					var	_effort = "";
					var _startDate = "";
					var _finishDate = "";
                   	
//					if(isUserQuery){
//					    if (itemInfo.QueryResult[i].plannedSchedule) {
//							_effort = itemInfo.QueryResult[i].plannedSchedule.effort;
//							_startDate = DateUtil.formatDate(DateUtil.parseDate(itemInfo.QueryResult[i].plannedSchedule.startDate));
//							_finishDate = DateUtil.formatDate(DateUtil.parseDate(itemInfo.QueryResult[i].plannedSchedule.finishDate));
//	                    }
//					}
//					else{
						
						  if (itemInfo[i] && itemInfo[i].taskAssignment && itemInfo[i].taskAssignment.plannedSchedule) {
						  	var plannedScheduleInfo;
							if(itemInfo[i].taskAssignment.plannedSchedule[0])
								plannedScheduleInfo = itemInfo[i].taskAssignment.plannedSchedule[0];
							else
								plannedScheduleInfo = itemInfo[i].taskAssignment.plannedSchedule;
								
							_effort = plannedScheduleInfo.effort;							
							_startDate = DateUtil.formatDate(DateUtil.parseDate(plannedScheduleInfo.startDate));
							_finishDate = DateUtil.formatDate(DateUtil.parseDate(plannedScheduleInfo.finishDate));
	                    }
//					}
					var rowDetail = {
						name: _taskName,
						effort: _effort,
						startDate: _startDate,
						finishDate: _finishDate
					};
                    
                    assignedEffort = assignedEffort + _effort;                    
                    row.assignedeffort = assignedEffort;
                    
                    var tr;
                    if(i < MAX_TASK_ASSIGNMENT_SHOWN_IN_TOOLTIP && itemInfo[i].taskAssignment.active && row.active) {
                    	tr = this.getTableRow(rowDetail);
                    	table = table + tr;
                    }	
                }
				//Add ellipsis to the end of the table indicating that other tasks have not been loaded
				if (totalNumberOfTasks > MAX_TASK_ASSIGNMENT_SHOWN_IN_TOOLTIP) {
					var tr = '<tr><td>' + '...' + '</td></tr>';
					table = table + tr;
				}
				if(!row.active) {
					activeTaskCount = 0;
				}
				row.task = activeTaskCount; 
                return resultString + table + "</table>";
            }
			return null;
        },
        
        /*
         *
         */
        getTableRow: function(rowDetail){
            var tr = '<tr>';
			var td = '<td class="com-ibm-epm-resource-assignment-web-ui-internal2-AssignedResourceGrid-tooltipTaskNameCell">' + rowDetail.name + "</td>" + 
            '<td class="com-ibm-epm-resource-assignment-web-ui-internal2-AssignedResourceGrid-tooltipEffortCell">' +
            rowDetail.effort +
            " " +
            ResourceAssignmentViewletMessages.HOURS_ABBR +
            "</td>" +
            '<td class="com-ibm-epm-resource-assignment-web-ui-internal2-AssignedResourceGrid-tooltipDatesCell">' +
            rowDetail.startDate +
            " - " +
            rowDetail.finishDate +
            "</td>";
			tr = tr + td;		 
            return tr + "</tr>";
        },
        
        /*
         *
         */
        updateRowData: function(row, loadedElement, linkName){
		    var temp = loadedElement.plannedSchedule;
			if(dojo.isArray(temp) && ! loadedElement.tempPlannedSchedule){
				var controller = controllerUtil.getEPMGridController("AssignedResourcesGrid");
				var dataModel = controller.getDataModel(); 
				var rowIndex = controller.getRowIndex(row.id)+ 1;
				if(loadedElement.User){
					this._removeDiscreteAssignmentRows(loadedElement.User.relativeHref, controller);
				}else if(loadedElement.profile){
					this._removeDiscreteAssignmentRows(Constants.PROFILE_URI + Constants.SLASH + loadedElement.profile.id, controller);
				}
				for(var i = 0; i< temp.length ; i++){
					var NewloadedElement = dojo.clone(loadedElement);
					NewloadedElement.tempPlannedSchedule = temp[i];
					
					if(i == 0){
						controller._updateGridRow(NewloadedElement, NewloadedElement.relativeHref, null);
					}
					else{
						var relativeHref = NewloadedElement.relativeHref + Constants.SUFFIX_FOR_DISCRETE_ASSIGNMENT + ":" + temp[i].id;
						var oldRowIndex = controller.getRowIndex(relativeHref)
						if(oldRowIndex >= 0){
							controller._updateGridRow(NewloadedElement, relativeHref, null);
						}
						else {
							var rowIndex = controller.getRowIndex(NewloadedElement.relativeHref)+ 1;
							var tempRow = this.getEmptyRow(relativeHref);
							controller._addRow(tempRow, rowIndex);
							controller._updateGridRow(NewloadedElement, relativeHref, null);
						}
					}
					controller._gridData.store.save();
				}
				return;
			}        
        
            if (linkName == null) {
            
                var assignedResourceLink = this.getAssignedLink(loadedElement, [Constants.PROJECT_RESOURCE_ASSIGNED, Constants.RESOURCE_ASSIGNED]);
                var assignedProfileLink = this.getAssignedLink(loadedElement, [Constants.PROJECT_PROFILE_ASSIGNED, Constants.PROFILE_ASSIGNED]);
                
                if (assignedResourceLink) {
                    row.resourceRelativeHref = assignedResourceLink.relativeHref;
                    row.name = assignedResourceLink.title;
                }
                else 
                    if (assignedProfileLink) {
                        row.resourceRelativeHref = Constants.PROFILE_URI + Constants.SLASH + assignedProfileLink.id;
                        row.name = assignedProfileLink.name;
                    }
                
                var startDate = "";
                var finishDate = "";
                var duration = "";
                var scheduleId = null;
				var projectContourValue;
				
							var effort = 0;
                if (loadedElement.tempPlannedSchedule) {
                    startDate = DateUtil.parseDate(loadedElement.tempPlannedSchedule.fromDate);
                    finishDate = DateUtil.parseDate(loadedElement.tempPlannedSchedule.toDate);
                    duration = loadedElement.tempPlannedSchedule.duration;
                    scheduleId = loadedElement.tempPlannedSchedule.id;
                    effort = loadedElement.tempPlannedSchedule.effort;
					projectContourValue = loadedElement.tempPlannedSchedule.hoursBlocked;
					row.active = loadedElement.tempPlannedSchedule.active
                    
                    
                }
                else if (loadedElement.plannedSchedule) {
					
					 if (this.wbsNodeType === EPMConstants.EPM_PROJECT) {
					 	
						if(loadedElement.plannedSchedule && loadedElement.plannedSchedule[0])
						{
							var plannedScheduleInfo = loadedElement.plannedSchedule[0];
						
							startDate = DateUtil.parseDate(plannedScheduleInfo.fromDate);
	                  		finishDate = DateUtil.parseDate(plannedScheduleInfo.toDate);
							duration = plannedScheduleInfo.duration;
			                scheduleId = plannedScheduleInfo.id;
			                effort = plannedScheduleInfo.effort;
							projectContourValue = plannedScheduleInfo.hoursBlocked;
							row.active = plannedScheduleInfo.active
							
						}
					 }else{
					 	
						startDate = DateUtil.parseDate(loadedElement.plannedSchedule.startDate);
	                    finishDate = DateUtil.parseDate(loadedElement.plannedSchedule.finishDate);
						duration = loadedElement.plannedSchedule.duration;
		                scheduleId = loadedElement.plannedSchedule.id;
		                effort = loadedElement.plannedSchedule.effort;
						projectContourValue = loadedElement.plannedSchedule.hoursBlocked;
						row.active = loadedElement.plannedSchedule.active
					 }
					 
                    
                }
                else {
                    startDate = DateUtil.parseDate(loadedElement.proposedstart);
                    finishDate = DateUtil.parseDate(loadedElement.proposedfinish);
                    duration = loadedElement.proposedduration;
                }
                
                if (loadedElement.profile) {
                    row.profileName = loadedElement.profile.name;
                    row.profileDescription = loadedElement.profile.description;
                    row.profileExperienceInYear = loadedElement.profile.experienceInYears;
					var skillsString = "";
					if(loadedElement.profile.skillassignment){
						for(var i = 0; i < loadedElement.profile.skillassignment.length; i++){
							skillsString = skillsString + "," + '"' + loadedElement.profile.skillassignment[i].skill.relativeHref + '"';
						}
					}
					var competenciesString = "";
					if(loadedElement.profile.competencyassignment){
						for(var i = 0; i < loadedElement.profile.competencyassignment.length; i++){
							competenciesString = competenciesString + "," + '"' + loadedElement.profile.competencyassignment[i].competency.relativeHref+ '"';
						}
					}
                    row.profileSkills = skillsString.substr(1);
                    row.profileCompetencies = competenciesString.substr(1); 
                    // row.profileRate = loadedElement.profile.profileRate;
                }
                row.proposedstart = startDate;
                row.proposedfinish = finishDate;
                row.proposedduration = duration;
                row.effort = effort;
                row.role = loadedElement.role;
                row.contourType = loadedElement.contourType;
				
				if (this.wbsNodeType === EPMConstants.EPM_PROJECT){
					row.value = projectContourValue;
				}
				else{
					
					row.active = loadedElement.active;
               		row.value = loadedElement.contourValue;
				}
                row.scheduleId = scheduleId;
//				row.active = loadedElement.active;
                if (loadedElement.costRate || loadedElement.costRate == 0) {
                	row.costRate = loadedElement.costRate;
                }
                if (loadedElement.sellingRate || loadedElement.sellingRate == 0) {
					row.sellingRate = loadedElement.sellingRate;                	
                }
				
				row.rates = loadedElement.rate;
				
				//Adding last modified field in the loaded element
				loadedElement.lastModifiedField = "";
                row.lastModifiedField = "";
                row.loadedelement = [loadedElement];
                
                this._updateChargecodes(row, loadedElement);
                if (! loadedElement.runQueryFlag) {
                	this.updateRowDetails(row, loadedElement);
					loadedElement.runQueryFlag = true;
            	}
				
            }
        },
        
        /*
         * Charge code update call
         */
        _updateChargecodes: function(row, loadedElement){
        
            var labourCCLink = getLink(loadedElement, Constants.LABOUR_CHARGE_CODE);
            
            if (labourCCLink) {
                if (dojo.isArray(labourCCLink) && labourCCLink[0]) {
                    labourCCLink = labourCCLink[0];
                }
                row.labourChargecodeUri = labourCCLink.relativeHref;
                row.labourChargecode = labourCCLink.title;
            }
            
            var revenueCCLink = getLink(loadedElement, Constants.REVENUE_CHARGE_CODE);
            if (revenueCCLink) {
                if (dojo.isArray(revenueCCLink) && revenueCCLink[0]) {
                    revenueCCLink = revenueCCLink[0];
                }
                row.revenueChargecodeUri = revenueCCLink.relativeHref;
                row.revenueChargecode = revenueCCLink.title;
            }
        },
        
          /*
         * Called by Controller to get the Save parameters to be sent for the Post Call
         */
		
		//TODO : Very important - Last modified field for update and create call
        prepareSaveParams: function(row){
        	//Inactive assignment should not be updated. Hence do not prepare any save params for it.
            if(row.loadedelement && row.loadedelement[0] && !row.loadedelement[0].active){
            	return "";
            }          
            var plannedSchedule_startDate = "";
            var plannedSchedule_finishDate = "";
            var plannedSchedule_duration = "";
            var plannedSchedule_scheduleId = "";
            
            
            if (row.proposedstart != null && row.proposedstart != "" && row.proposedstart != "-") {
                plannedSchedule_startDate = DateUtil.formatDateForSave(row.proposedstart, {
                    datePattern: 'yyyy-MM-dd',
                    selector: 'date'
                });
            }
            if (row.proposedfinish != null && row.proposedfinish != "" && row.proposedfinish != "-") {
                plannedSchedule_finishDate = DateUtil.formatDateForSave(row.proposedfinish, {
                    datePattern: 'yyyy-MM-dd',
                    selector: 'date'
                });
            }
			plannedSchedule_duration = 0;
            if (row.proposedduration != null && !isNaN(row.proposedduration)  && row.proposedduration >= 0) {
                plannedSchedule_duration = row.proposedduration;
			}
			plannedSchedule_effort = 0;
			if (row.effort != null && !isNaN(row.effort) && row.effort >= 0) {
                plannedSchedule_effort = row.effort;
			}
            if (row.scheduleId != null && row.scheduleId != "") {
                plannedSchedule_scheduleId = row.scheduleId;
            }
            
            var newSaveparam = "";
            
            //Reformat the post paramter map to match the current service code
			var plannedScheduleArray = new Array();
			var plannedScheduleString = "";

			var startDateConstant = Constants.START_DATE;
			var finishDateConstant = Constants.FINISH_DATE;
			var isProjectAllocation = false;
			
			if (this.wbsNodeType === EPMConstants.EPM_PROJECT) {
				isProjectAllocation= true;
				startDateConstant = Constants.SCHEDULE_FROM_DATE;
				finishDateConstant = Constants.SCHEDULE_TO_DATE;
				
			 }
			 
			var plannedScheduleString = startDateConstant + "=" + plannedSchedule_startDate + " 00:00:00" ;
			
			if(row.lastModifiedField == "finishDate"){
				plannedScheduleString += "," + finishDateConstant + "=" +
                plannedSchedule_finishDate +
                " 00:00:00";
				
			}else if(row.lastModifiedField == "duration"){
				plannedScheduleString+= "," + Constants.DURATION +
                "=" +
                plannedSchedule_duration;
				
			}else if(row.lastModifiedField == "effort"){
				
				plannedScheduleString += "," + Constants.ASSIGNMENT_EFFORT +
                "=" +
                plannedSchedule_effort; 
				
			}else{
				
				plannedScheduleString += "," + finishDateConstant + "=" +
                    plannedSchedule_finishDate +
                    " 00:00:00," +
                    Constants.DURATION +
                    "=" +
                    plannedSchedule_duration +
					 "," +
					Constants.ASSIGNMENT_EFFORT +
                    "=" +
                    plannedSchedule_effort;
			}
				
			if (this.wbsNodeType === EPMConstants.EPM_PROJECT) {
				
				//Update the contour value
				if(!isNaN(row.value) && row.value > 0){
					plannedScheduleString = plannedScheduleString + ",hoursBlocked=" + row.value;
				}
			}
			//saved row
            if (plannedSchedule_scheduleId != null && plannedSchedule_scheduleId != "") {
				
				plannedScheduleString += "," + Constants.ID +
                    "=" +
                    plannedSchedule_scheduleId;
					
            }
			
				plannedScheduleArray.push(plannedScheduleString);
				newSaveparam = {
                    plannedSchedule:plannedScheduleArray
				};


             if (this.wbsNodeType === EPMConstants.EPM_PROJECT) {
            
                newSaveparam.Project = this.wbsNodeID;
                if(row.id.indexOf("unsaved") < 0) {
                	// Since arrays are not compared in AbstractGridModel :
                	// Setting a dummy field for use to set the field correctly in _isFieldModified()
					newSaveparam.rate = "";
                }
				
				newSaveparam.role = row.role;
            }
            else {
            
                if (row.labourChargecodeUri != null && row.labourChargecodeUri != "" ) {
				  	var costArray = new Array();
				  	var cost = null;
					if ((row.loadedelement) && (row.loadedelement[0])) {
						cost = getLink(row.loadedelement[0], Constants.LABOUR_CHARGE_CODE);
					}
				  	if (cost != null) {
				  		if (cost.relativeHref != row.labourChargecodeUri) {
				  			var param = cost.relativeHref + Constants.DEL_ACTION;
				  			costArray.push(param);
				  			if (row.labourChargecodeUri != Constants.NULL_STRING) {
				  				costArray.push(row.labourChargecodeUri + Constants.ADD_ACTION);
				  			}
				  		}
				  	}
				  	else {
				  		if (row.labourChargecodeUri != Constants.NULL_STRING) {
				  			costArray.push(row.labourChargecodeUri + Constants.ADD_ACTION);
				  		}
				  	}
				  	
				  	if ((costArray != null) && (costArray.length > 0)) {
				  		newSaveparam.LabourChargeCode = costArray;
				  	}
                }
                
                if (row.revenueChargecodeUri != null && row.revenueChargecodeUri != "") {
                   
				   	var revenueArray = new Array();
				   	var revenue = null;
					if ((row.loadedelement) && (row.loadedelement[0])) {
						revenue = getLink(row.loadedelement[0], Constants.REVENUE_CHARGE_CODE);
					}
				   	if (revenue != null) {
				   		if (revenue.relativeHref != row.revenueChargecodeUri) {
				   			var param = revenue.relativeHref + Constants.DEL_ACTION;
				   			revenueArray.push(param);
				   			if (row.revenueChargecodeUri != Constants.NULL_STRING) {
				   				revenueArray.push(row.revenueChargecodeUri + Constants.ADD_ACTION);
				   			}
				   		}
				   	}
				   	else {
				   		if (row.revenueChargecodeUri != Constants.NULL_STRING) {
				   			revenueArray.push(row.revenueChargecodeUri + Constants.ADD_ACTION);
				   		}
				   	}
				   	if ((revenueArray != null) && (revenueArray.length > 0)) {
				   		newSaveparam.RevenueChargeCode = revenueArray;
				   	}
                }
                
                newSaveparam.Task = this.wbsNodeID;
                
				/**
				 * TODO: Commenting till Task assignment contour value is implemented completely
				 * currently the contour value is full working hours based on project calendar
				 */
				
				//newSaveparam.contourValue = row.value;
				
                newSaveparam.contourType = row.contourType;
				if(!isNaN(row.value) && row.value > 0){
					newSaveparam.contourValue = row.value;
				}				
            }
            
            if (row.resourceRelativeHref.indexOf(Constants.USER_URI) !== -1) {
                newSaveparam.User = row.resourceRelativeHref;
				if(!row.active){
					newSaveparam.profile = Constants.NAME + "=" + row.name + "," + Constants.DESCRIPTION + "=" + row.profileDescription + "," +
                    Constants.EXPERIENCEINYEAR +
                    "=" +
                    row.profileExperienceInYear +
                    "," +
                    Constants.PROFILETEMPLATEURI +
                    "=" +
                    row.profileTemplateId;

				}
            }
            else {
                if (row.resourceRelativeHref == ""){
                    newSaveparam.profile = Constants.NAME + "=" + row.name + "," + Constants.DESCRIPTION + "=" + row.profileDescription + "," +
                    Constants.EXPERIENCEINYEAR +
                    "=" +
                    row.profileExperienceInYear +
                    "," +
                    Constants.PROFILETEMPLATEURI +
                    "=" +
                    row.profileTemplateId;
                }
                else {
					var profileName = row.name;
					if(row.replaceWith != ""){
						profileName = row.profileName;
					}
                    newSaveparam.profile = Constants.NAME + "=" + profileName + "," + Constants.ID + "=" + row.resourceRelativeHref.substring((Constants.PROFILE_URI + Constants.SLASH).length);
                }
                if (row.replaceWith != "") {
					newSaveparam.User = row.replaceWith;
				}
            }
            
            
            //TODO : Move this business logic to the server code
            // For Task assignment we need to roll up the proifle assignment to the containing project level
            
            //            if (this.wbsNodeType !== Constants.EPM_PROJECTS && this.sourceGrid === Constants.QUERY_GRID) {
            //            
            //                newSaveparam.rollUp = Constants.TRUE;
            //                
            //            }
            
            return newSaveparam;
            
            
        },
        
        /**
         * Sets the save parameter for rates
         */
        _setRateParams: function(params, row, loadedelement){
			var paramArray = new Array();
			var newRatesCount = 0;
            for (var i in row.rates) {
				var rate = row.rates[i];
                if (!rate.id) {
					// Newly added rate
					var paramValue = "fromDate=" + rate.fromDate + " 00:00:00,toDate=" + rate.toDate + " 00:00:00,costRate=" + rate.costRate + ",sellingRate=" + rate.sellingRate;
					paramArray.push(paramValue);
					newRatesCount++;
				}
                else {
					// Check if the rate is updated
                    for (var j in loadedelement.rate) {
						var loadedRate = loadedelement.rate[j];
                        if (loadedRate.id == rate.id) {
							// Found the loaded rate values, now comparing.....
							var paramValue = "";
                            if (dojo.date.compare(DateUtil.parseDate(loadedRate.fromDate), DateUtil.parseDate(rate.fromDate)) != 0) {
                                if (paramValue != "") {
                                    paramValue = paramValue + ",";
                                }
								paramValue = paramValue + "fromDate=" + rate.fromDate + " 00:00:00";
							}
                            if (dojo.date.compare(DateUtil.parseDate(loadedRate.toDate), DateUtil.parseDate(rate.toDate)) != 0) {
                                if (paramValue != "") {
                                    paramValue = paramValue + ",";
                                }
								paramValue = paramValue + "toDate=" + rate.toDate + " 00:00:00";
							}
                            if (loadedRate.costRate != rate.costRate) {
                                if (paramValue != "") {
                                    paramValue = paramValue + ",";
                                }
								paramValue = paramValue + "costRate=" + rate.costRate;
							}
                            if (loadedRate.sellingRate != rate.sellingRate) {
                                if (paramValue != "") {
                                    paramValue = paramValue + ",";
                                }
								paramValue = paramValue + "sellingRate=" + rate.sellingRate;
							}
                            if (paramValue != "") {
								// A field was modified
								paramValue = paramValue + ",id=" + rate.id;
								paramArray.push(paramValue);
							}
						}
					}
				}
			}
			// Checking for deleted rates
            if (row.rates.length - newRatesCount < loadedelement.rate.length) {
				// Finding the deleted rates
                for (var i in loadedelement.rate) {
					var loadedRate = loadedelement.rate[i];
					var found = false;
                    for (var j in row.rates) {
						var rate = row.rates[j];
                        if (rate.id == loadedRate.id) {
							found = true;
							break;
						}
					}
                    if (!found) {
						// Setting parameter to delete the rate
						var paramValue = "id=" + loadedRate.id + ":del";
						paramArray.push(paramValue);
					}
				}
			}
            if (paramArray.length > 0) {
				// Setting the rate parameter
				params.rate = paramArray;
				return true;
			}
			return false;
		},
		
		/**
		 * Overridden function from the abstract model to compare the rates.
		 * @param {Object} saveParams : the save params prepared using the model row.
		 * @param {Object} tempSaveParams : The save params prepared using the loaded element.
		 * @param {String} field : The Current field which is checked if it is modified.
		 * @param {Object} row : The Model Row that is mapped to grid and is updated from ui.
		 * @param {Object} loadedelement : The backup data returned by the server.
		 * @return {boolean} if field is rate then 
		 * 						if any of the rate fields are modified then true.
		 * 						else false.
		 * 					else returns the result from the inherited method.
		 */
		_isFieldModified: function(saveParams, tempSaveParams, field, row, loadedelement){
			if(field == "rate"){
				return this._setRateParams(saveParams, row, loadedelement);
            }
			else if(field == "plannedSchedule"){
				return this._setPlannnedScheduleParams(saveParams, row, tempSaveParams);
            }

            else {
				return this.inherited(arguments);
			}
		},
		
        /*
         * Called by the Controller to get the POST Call URI
         */
        _getNewElementURI: function(row){
        
            var returnURI = "";
            if (this.wbsNodeType == EPMConstants.EPM_PROJECT) {
            
                returnURI = this.wbsNodeID + Constants.SLASH + Constants.PROJECT_ASSIGNMENT;
                
            }
            else 
                if (this.wbsNodeType == EPMConstants.EPM_TASK || this.wbsNodeType == EPMConstants.EPM_DEFECT ||
                this.wbsNodeType == EPMConstants.EPM_RISK ||
                this.wbsNodeType == EPMConstants.EPM_ISSUE ||
                this.wbsNodeType == EPMConstants.EPM_SUMMARYTASK ||
                this.wbsNodeType == EPMConstants.EPM_CHANGEREQUEST ||
                this.wbsNodeType == EPMConstants.EPM_MILESTONE ||
                this.wbsNodeType.indexOf(EPMConstants.WORKITEM) != -1) {
                    //TODO needs to be changed when URI will become workitem/id
                    if (row.resourceRelativeHref == "") {
                        returnURI = "profile/dummyid" + Constants.SLASH + Constants.TASK_ASSIGNMENT;
                    }
                    else {
                        returnURI = row.resourceRelativeHref + Constants.SLASH + Constants.TASK_ASSIGNMENT;
                    }
                }
            
            return returnURI;
        },
        
        /*
         * Called by the Controller to get the URI for fetching Row data from the server
         */
        getRowGetURI: function(rowElementHandle, rowID){
            return rowElementHandle.relativeHref;
        },
        
        prepareSaveParams_link: function(row, linkName){
            return null;
        },
        
        getRowPostURI_link: function(row, linkName, newElementID){
        
            return null;
            
        },
        		
		  /**
         * Sets the save parameter for planned Schedule
         */
        _setPlannnedScheduleParams: function(params, row, tempSaveParams){
			var paramArray = new Array();
			var newRatesCount = 0;
			for(i=0;i<tempSaveParams.plannedSchedule.length;i++){
				if(tempSaveParams.plannedSchedule[i] != params.plannedSchedule[i]){
					paramArray.push(params.plannedSchedule[i]);
				}
			}
            if (params.plannedSchedule.length > tempSaveParams.plannedSchedule.length) {
				for(i = tempSaveParams.plannedSchedule.length; i < params.plannedSchedule.length; i++){
					paramArray.push(params.plannedSchedule[i]);
				}
			}
            if (paramArray.length > 0) {
				// Setting the Schedule parameter
				params.plannedSchedule = paramArray;
				return true;
			}
			return false;
		},
        
		/**
		 * 
		 * @param {Object} errorMessage
		 */
		
		_removeDiscreteAssignmentRows: function(resourceRelativeHref, controller){
			var rowCount = controller.getDataModel().getRowCount();
            var rowsToBeRemoved = [];
            for (var i = 0; i < rowCount; i++) {
            
                var row = controller.getDataModel().getRow(i);
				if(row){
					if(row.resourceRelativeHref == resourceRelativeHref && (row.id.indexOf(Constants.UNSAVED) != -1 || row.id.indexOf(Constants.SUFFIX_FOR_DISCRETE_ASSIGNMENT) != -1)){
						rowsToBeRemoved.push(row.id);
					}
				}
				
			}
			for( var i = 0;i < rowsToBeRemoved.length; i++ ){
				controller._removeGridRow(rowsToBeRemoved[i]);
			}
			
		},

        /*
         * Displays the Error Message
         * Incoming : Error message
         * Outgoing : None
         */
        _displayErrorMessage: function(errorMessage){
            this._displayAndClearErrorMessage(errorMessage);
        },
        
        _clearErrorMessage: function(){
            EPMErrorHandler.clearError();
        },
        /*
         * Display and clear the error message
         * incoming : Error Message Object
         * OutGoing : None
         */
        _displayAndClearErrorMessage: function(errorMessage){
            var self = this;
            EPMErrorHandler.setError(errorMessage);
            
            // Set an interval and clear the error message
            var intervalID = setInterval(function(){
                self._clearErrorMessage();
                clearInterval(intervalID);
            }, 10000);
        }
    });
})();
