/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

(function(){
    dojo.provide("com.ibm.epm.resource.assignment.web.ui.internal2.AssignmentUtil");
    
    dojo.require("com.ibm.epm.resource.assignment.web.ui.internal2.ResourceAssignmentViewletConstants");
    dojo.require("com.ibm.epm.admin.web.ui.internal.Util.Constants");
     // Client
    dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
    dojo.require("com.ibm.epm.resource.assignment.web.client.internal.ResourceAssignmentClient");
	
	 //process role dialog
    dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.ProcessRoleDialog");
    dojo.require("com.ibm.team.process.web.client.projectarea");
    dojo.require("com.ibm.team.process.web.client.internal.ProcessClient");
    dojo.require("jazz.ui.Dialog");
	dojo.require("com.ibm.epm.web.core.ui.internal.EPMView.Dashboard.Util");
 
  	var ResourceAssignmentViewletMessages = dojo.i18n.getLocalization("com.ibm.epm.resource.assignment.web.ui", "Messages");
   	var AdminConstants = com.ibm.epm.admin.web.ui.internal.Util.Constants;
    var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
    var ResourceAssignmentClient = com.ibm.epm.resource.assignment.web.client.internal.ResourceAssignmentClient;
    var Constants = com.ibm.epm.resource.assignment.web.ui.internal2.ResourceAssignmentViewletConstants;
 
    var ProcessClient = com.ibm.team.process.web.client.internal.ProcessClient;
	var AssignmentUtilDashboard = com.ibm.epm.web.core.ui.internal.EPMView.Dashboard.Util;
	
    com.ibm.epm.resource.assignment.web.ui.internal2.AssignmentUtil = {
    
	 /**
	  * Function to set default rate
	  * @param {Object} selectedRow
	  */
        setDefaultRate: function(selectedRow) {
        
            var serviceObj = {
                success: function(rateData){                
                    if (!rateData) {
                        self._displayErrorMessage(ResourceAssignmentViewletMessages.FAILED_TO_GET_RATE);
                    }
                    else {
                        selectedRow.costRate = rateData.costRate;
                        selectedRow.sellingRate = rateData.sellingRate;
                   }
                },
                failure: function(errorObj){
                    self._displayErrorMessage(ResourceAssignmentViewletMessages.FAILED_TO_GET_RATE);
                }
            };
            var srh = new ServiceResponseHandler(serviceObj, "success", "failure");
            ResourceAssignmentClient.getURI(srh, AdminConstants.DEFAULT_RATE_URI);        
        },
		
		 /**
		  * populate the role data from the project associated team area.
		  * @param {Object} selectedUserName
		  * @param {Object} projectAreaItemId
		  * @param {Object} selectedRow
		  * @param {Object} classInstance
		  */
        populateRoleDataFromProjectArea: function(selectedUserName, projectAreaItemId, selectedRow,classInstance){
            var self = classInstance;
            
            if (!projectAreaItemId) {
				return;
			}
            var serviceObj2 = {
                success: function(data){
                    var allProcessRoles = data.processDTO.roles;
                    var allMembers = data.members;
                    //search for the selected user
                    var selectedUserDetails = null;
                    if (allMembers != null && allMembers.length > 0) {
                        for (var i = 0; i < allMembers.length; i++) {
                            if (selectedUserName.toString().toLowerCase() == allMembers[i].name.toString().toLowerCase()) {
                                selectedUserDetails = {
                                    selectedUser: allMembers[i],
                                    selectedUserId: allMembers[i].itemId
                                };
                                break;
                                
                            }//if
                        }//for
                    }
                    
                    var roleObj = new Object();
                    if (allProcessRoles) {
                    
                        roleObj.allRoles = allProcessRoles;
                        
                        if (selectedUserDetails) {
                            roleObj.member = selectedUserDetails.selectedUser;
                        }
                        else {
                        
                            //Get the default role from the list of roles
                            var defaultProcessRoles = [];
                            for (var i = 0; i < allProcessRoles.length; i++) {
                            
                                if (allProcessRoles[i].id == Constants.DEFAULT_ROLE) {
                                    defaultProcessRoles = allProcessRoles[i];
                                }
                            }
                            roleObj.member = {
                                name: selectedUserName,
                                processRoles: [defaultProcessRoles]
                            
                            };
                            
                        }
                        var dialogWidget = dijit.byId(Constants.PROCESS_DIALOG_ID); //$NON-NLS-1$
                        if (dialogWidget == null) {
                        
                            var processRoleDialog = new com.ibm.team.process.web.ui.internal.admin.projects.ProcessRoleDialog(roleObj, "");
                            
                            dialogWidget = new jazz.ui.Dialog({
                                id: Constants.PROCESS_DIALOG_ID, //$NON-NLS-1$
                                primaryTitle: Constants.PROCESS_DIALOG_TITLE,
                                contentNode: processRoleDialog.domNode,
                                width: dojo.isIE ? "48em" : "46em",//$NON-NLS-1$ //$NON-NLS-2$
                                execute: function(selectedRoles){
                                    var roleIds = new Array();
                                    for (var i = 0; i < selectedRoles.length; i++) {
                                        // Add all the selected roles to the array
										//14206 - even for default role  post it
										roleIds.push(selectedRoles[i].id);
										
                                    }
    								//Resource Assignment Tab Manager specific funtions
									if(self.roleString)
                                   		 self.roleString = roleIds.join(",");
								    
                                   if(self.assignResourceWithDetails)
								    self.assignResourceWithDetails([selectedRow], false);
									
									//Assigned Resources Grid View specific funtions
									if(self.updateRoles)
										self.updateRoles(selectedRow,roleIds.join(","));
                                }
                                
                            });
                            dialogWidget.targetObj = self;
                            dialogWidget.processRoleDialogObj = processRoleDialog;
                            dojo.connect(processRoleDialog.cancelButton, Constants.ONCLICK, dialogWidget, function(e){
							//Assigned Resources Grid View specific funtions
								if(self.updateRoles){
									self.updateRoles(selectedRow,selectedRow.role);
                            	}
							    dojo.stopEvent(e);
                                this.close();
                            });
                            
                            dojo.connect(processRoleDialog.finishButton, Constants.ONCLICK, dialogWidget, function(e){
                                this.execute(this.processRoleDialogObj.getChosenRoles());
                                this.close();
                            });
                            
                        }
                        
                    }
                    else if (allProcessRoles == null) {
                            //no process roles
                            self._displayAndClearErrorMessage(ResourceAssignmentViewletMessages.FAILED_TO_GET_PROCESSROLES);
                    }
                   	else if (selectedUserDetails == null) {
                                self._displayAndClearErrorMessage(ResourceAssignmentViewletMessages.FAILED_TO_GET_USERDETAILS);
                                
                    }
                	AssignmentUtilDashboard.hideMessageArea();
                },
                failure: function(err){
                    self._displayAndClearErrorMessage(err);
					AssignmentUtilDashboard.hideMessageArea();
                }
                
            };
            
            var srh = new ServiceResponseHandler(serviceObj2, "success", "failure"); //$NON-NLS-1$ //$NON-NLS-2$
            ProcessClient.getProjectAreaByUUID({
                uuid: projectAreaItemId
            }, srh);
        },
        
        /**
         * Fetching the team area associated to the selected project
         * @param {Object} selectedUserName
         * @param {Object} selectedRow
         * @param {Object} projectIdentifier
         * @param {Object} classInstance
         */
        fetchTeamAreaAndRolesForProject: function(selectedUserName, selectedRow, projectIdentifier, classInstance){
			AssignmentUtilDashboard.showMessage(ResourceAssignmentViewletMessages.FETCHING_ROLE_INFORMATION_PROGRESS);
            var self = classInstance;
			var utilClassInstance = this;
            //get the team area
            var serviceObj2 = {
                success: function(projectData){
                    if (!projectData) {
                        self._displayAndClearErrorMessage(ResourceAssignmentViewletMessages.FAILED_TO_GET_PROJECT);
                    }
                    else {
                        //self.projectAreaItemId=projectData.projectAreaItemId;
                        utilClassInstance.populateRoleDataFromProjectArea(selectedUserName, projectData.projectAreaItemID, selectedRow,classInstance);
                        
                    }
                },
                failure: function(errorObj){
                    self._displayAndClearErrorMessage(ResourceAssignmentViewletMessages.FAILED_TO_GET_PROJECT);
					AssignmentUtilDashboard.hideMessageArea();
                }
            };
            var srh2 = new ServiceResponseHandler(serviceObj2, "success", "failure");
            var projectUri = "/" + projectIdentifier;
            ResourceAssignmentClient.getURI(srh2, projectUri);
        },
		
		/**
		 * Fetches the working hours based on resource and project calendar
		 * @param {Object} rowId
		 * @param {Object} args
		 * @param {Object} isProject
		 */
		fetchWorkingHours:function(rowId,args,isProject){
			
			var self = this;
			var controller = controllerFactory.getEPMAssignmentGridController(Constants.ASSIGNED_RESOURCES_GRID_ID);
			var dataModel = controller.getDataModel(); 
			var serviceObject = {
                success: function(itemInfo){
				   if(itemInfo.value){
				   	this.setContourValue(itemInfo.value);
				   }
				   else{
				   		this.setContourValue(8);
				   }
					
                },
                failure: function(errorObj){
					this.setContourValue();
                },
				
				setContourValue:function(workingHours){
					
					if ( dataModel ) {
						if (rowId) {
							var item = dataModel.store._getItemByIdentity(rowId);
							if (item) {
								if(rowId.indexOf(Constants.UNSAVED) != -1){
									if(isProject){
										if(item.proposedduration && item.proposedduration[0]){
											var effort = item.proposedduration[0] * workingHours;
											dataModel.store._setValueOrValues(item, "effort", effort, true);
										}
										else{
											dataModel.store._setValueOrValues(item, "effort", workingHours, true);
										}
										
										// Set the contour value to the working hours
										dataModel.store._setValueOrValues(item, "value", workingHours, true);
									}
									else{
										dataModel.store._setValueOrValues(item, "value", workingHours, true);
									}
								}
								dataModel.store._setValueOrValues(item, "workingHours", workingHours, true);
							}
								
						}
					}
				}
	         };
           
            var srh = new ServiceResponseHandler(serviceObject, "success", "failure");
            ResourceAssignmentClient.getWorkingHours(srh, args);
		}
    
    };
	
})();
