
/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
if (!dojo._hasResource["com.ibm.epm.resource.assignment.web.ui.internal2.AvailabilitySearchDialog"]) {
    dojo._hasResource["com.ibm.epm.resource.assignment.web.ui.internal2.AvailabilitySearchDialog"] = true;
    dojo.provide("com.ibm.epm.resource.assignment.web.ui.internal2.AvailabilitySearchDialog");
    
    dojo.require("jazz.ui.Dialog");
    dojo.require("dijit._Widget");
    dojo.require("dijit._Templated");
	dojo.require("com.ibm.epm.web.core.util.internal.DateUtil");
	// Error handler
    dojo.require("com.ibm.epm.web.core.ui.internal.EPMErrorHandler");
    
	var DateUtil = com.ibm.epm.web.core.util.internal.DateUtil;
    var EPMErrorHandler = com.ibm.epm.web.core.ui.internal.EPMErrorHandler;
	
	//EPM DOM Constants
	dojo.require("com.ibm.epm.web.core.ui.internal.EPMDomNodeConstants");
	var EPMDomNodeConstants = com.ibm.epm.web.core.ui.internal.EPMDomNodeConstants;
	
	//Resource Assignment client
	dojo.require("com.ibm.epm.resource.assignment.web.client.internal.ResourceAssignmentClient");
	var ResourceAssignmentClient = com.ibm.epm.resource.assignment.web.client.internal.ResourceAssignmentClient; 	
	
    // Localization
    dojo.requireLocalization("com.ibm.epm.resource.assignment.web.ui", "Messages");
    
    /*
     * Aliases
     */
    var Constants = com.ibm.epm.resource.assignment.web.ui.internal2.ResourceAssignmentViewletConstants;
    
    dojo.declare("com.ibm.epm.resource.assignment.web.ui.internal2.AvailabilitySearchDialog", [dijit._Widget, dijit._Templated], {
    
        dialog: null,
        widgetsInTemplate: true,
        _context: null,
		startDate: new Date(),
		finishDate: new Date(),
		effort: 1,
		contour:1,
		projectId: "",
		projectCalendarHours: null,
		
        templatePath: dojo.moduleUrl("com.ibm.epm.resource.assignment.web", "ui/internal2/templates/AvailabilitySearchDialog.html"),
        
        /*
         * constructor: To initialize the message variables.
         * Incoming: None
         * Outgoing: None.
         */
        constructor: function(){
    		this.messages = dojo.i18n.getLocalization("com.ibm.epm.resource.assignment.web.ui", "Messages");
			this.dialogSummaryLabel = this.messages.AVL_DIALOG_SUMMARY;
			this.ShowAvailabilityLabel = this.messages.AVL_SHOW_AVAILABILITY_COLUMN_LABEL
			this.StartDateLabel = this.messages.AVL_START_DATE_LABEL;
			this.EndDateLabel = this.messages.AVL_END_DATE_LABEL;
			this.EffortLabel = this.messages.AVL_EFFORT_LABEL;
			this.ContourLabel = this.messages.AVL_CONTOUR_LABEL;
			this.HoursPerDayLabel =  this.messages.AVL_HOURSPERDAY_LABEL;
			this.HoursLabel = this.messages.AVL_HOURS_LABEL;
			this.SearchWithinProjectLabel = this.messages.AVL_SEARCH_WITHIN_PROJECT_LABEL
			this.OkButtonLabel = this.messages.OK;
			this.CancelButtonLabel = this.messages.CANCEL;
        },
        
        /*
         * postCreate: To perform neccessary oprations before rendering the dialog.
         * Incoming: None
         * Outgoing: None.
         */
        postCreate: function(){
			this._startDateControl.constraints.selector = 'date';
            this._startDateControl.constraints.formatLength = 'medium';
			this._endDateControl.constraints.selector = 'date';
            this._endDateControl.constraints.formatLength = 'medium';
						
			this._startDateControl.attr("value",this.startDate);
            this._endDateControl.attr("value", this.finishDate);
			this._effortControl.attr("value", this.effort);
			this._contourControl.attr("value", this.contour);
			

			this._startDateControl.invalidMessage = this.messages.INVALID_DATE;
            this._endDateControl.invalidMessage = this.messages.INVALID_DATE;
			this._startDateControl.attr("disabled", true);
        	this._endDateControl.attr("disabled", true);
            // Key up listener
            this._keyUpHandler = this.connect(dojo.doc, "onkeyup", this._handleEventKeyUp);

			this._startDateCal.src = dojo.moduleUrl("com.ibm.epm.admin.web" ,"ui/internal/view/images/calendar.gif");
			this._endDateCal.src = dojo.moduleUrl("com.ibm.epm.admin.web" ,"ui/internal/view/images/calendar.gif");
			
			this.searchLabelDesc = document.createElement(EPMDomNodeConstants.LABEL);
			this.searchLabelDesc.innerHTML = this.messages.AVAILABILITY_SEARCH_LABEL_DESCRIPTION;
			this._searchWithinProjectLabelDesc.appendChild(this.searchLabelDesc);
			//dojo.style(this._searchWithinProjectLabelDesc, "display", "none");
		},
		
        /*
         * show: Show the dialog
         * Incoming: None
         * Outgoing: None.
         */
		show: function(){
            this.dialog = new jazz.ui.Dialog({
                contentNode: this.contentNode,
                primaryTitle: this.messages.AVL_DIALOG_TITLE,
                width: "500px",
				closeOnEsc: false,//We are handling enter and key ourselves
				onOpen: dojo.hitch(this, this._afterDialogOpen)
            });
		},
		
		_afterDialogOpen: function() {
			this._toggleGroupedControls(this._availabilityCheckBox.checked);
		},

		/* Either the end date or the effort is clicked*/		
		_editorToggle: function(event) {
			if(event && event.currentTarget && event.currentTarget.value) {
				//Value can either be ENDDATE or EFFORT
				var isEndDateControl = (event.currentTarget.value == "ENDDATE");
				this._toggleControl(this._endDateControl, isEndDateControl);
				this._toggleControl(this._effortControl, !isEndDateControl);
				if(isEndDateControl) {
					if ( DateUtil.compareDates(this._startDateControl.attr("value"), this._endDateControl.attr("value") ) > 0 ) {
						this._endDateControl.attr("value", this._startDateControl.attr("value"));
						this._startDateControl.constraints.max = this._startDateControl.attr("value");
					}
					else {
						this._endDateControl.constraints.min = this._startDateControl.attr("value");
						this._startDateControl.constraints.max = this._endDateControl.attr("value");
					}
				}
				else {
					delete this._startDateControl.constraints.max;
				}
			}
		},
		
		_toggleControl: function(/*Control*/control, /*boolean*/ enabled) {
			control.attr("disabled", !enabled);
			control.attr("required", enabled);
			if (enabled) {
				dojo.removeClass(control.domNode, "disabledEditor");
			}
			else {
				dojo.addClass(control.domNode, "disabledEditor");
			}	
		},
		
		_startDateChanged: function(value) {
			this._endDateControl.constraints.min = value;
		},
		
		_endDateChanged: function(value) {
			this._startDateControl.constraints.max = value;
		},
		
		_clickedStartDateImage: function(event) {
			this._endDateControl._close();
            this._startDateControl.focus();
		},
		
		_clickedEndDateImage: function(event) {
			if( !this._endDateControl.attr("disabled") ) {
				this._startDateControl._close();
				this._endDateControl.focus();
			}
		},
		
		_onDlgClose: function(event) {
            dojo.stopEvent(event);
            this.destroy();
		},
		
		_availabilityToggle: function(event) {
			if( this._availabilityCheckBox.checked) {
				this._toggleGroupedControls(true/*enabled*/);
			}
			else {
				this._toggleGroupedControls(false/*disabled*/);
			}
		},
		
		_toggleGroupedControls: function(enabled /*Boolean*/){
			
			if (enabled) {
				if(!this.projectCalendarHours){
					var self = this;
					var serviceObject = {
		                success: function(itemInfo){
						   if(parseInt(itemInfo.value, 10)){
						   		self.projectCalendarHours = itemInfo.value;
								self.enableFields(enabled);
						   }
						   else {
						   	self._displayErrorMessage(self.messages.MAX_VALUE_VALIDATION_FOR_CONTOUR_NOT_POSSIBLE);
						   }
		                },
		                failure: function(errorObj){
			                self._displayErrorMessage(self.messages.MAX_VALUE_VALIDATION_FOR_CONTOUR_NOT_POSSIBLE);
		                }
	          		};
	          		var args = {
	          			projectId:this.projectId
	          		};
	          		
		            var srh = new ServiceResponseHandler(serviceObject, "success", "failure");
		            ResourceAssignmentClient.getWorkingHours(srh, args);
	            }else {
	            	this.enableFields(enabled);
	            }
            }
            else {
				this.enableFields(enabled);
			}
			
		},
		
		_onOK: function() {
			
			//validate only if availability search option has been checked
			if( this.isAvailabilitySearch()){
				
				if(this._startDateControl.isValid() && this._contourControl.isValid() &&
				 (( !this._endDateControl.attr("disabled") && this._endDateControl.isValid()) || 
				 (!this._effortControl.attr("disabled") && this._effortControl.isValid()))){
					
					this._context.availabilitySearchDialog_onOK();
				}
			}
			else{
				
				this._context.availabilitySearchDialog_onOK();
			}
		},
		
		_onCancel: function() {
			this._context.availabilitySearchDialog_onCancel();
		},
		
		getFromDate: function() {
			return this._startDateControl.attr("value");
		},
		
		getEndDate: function() {
			return this._endDateControl.attr("value");	
		},
		
		getEffort: function() {
			return this._effortControl.attr("value");
		},
		
		getContour: function() {
			return this._contourControl.attr("value");
		},
		
		isAvailabilitySearch: function() {
			return this._availabilityCheckBox.checked;
		},
		
		searchWithinProject: function() {
			return this._withinProjectCheckBox.checked;
		},
		
		effortOrDurationType: function() {
			return this._effortRadio.checked;
		},
		
		enableFields: function(enabled){
			if (enabled) {
				dojo.removeClass(this._groupControlNode, "disabledEditor");
			}
			else {
				dojo.addClass(this._groupControlNode, "disabledEditor");
			}
			
			this._startDateControl.attr("disabled", !enabled);
			this._endDateRadio.disabled = !enabled;
			this._endDateControl.attr("disabled", !enabled);
			this._effortRadio.disabled = !enabled;
			this._effortControl.attr("disabled", !enabled);
			this._withinProjectCheckBox.disabled = !enabled;
			if(this.projectCalendarHours){
				this._contourControl.constraints.max = this.projectCalendarHours;
			} else
			this._contourControl.attr("value", "");
			this._contourControl.attr("disabled", !enabled);
			
			if(enabled){
				if(this._endDateRadio.checked) {
					this._toggleControl(this._endDateControl, enabled);
					this._toggleControl(this._effortControl, !enabled);
				}
				if(this._effortRadio.checked) {
					this._toggleControl(this._effortControl, enabled);
					this._toggleControl(this._endDateControl, !enabled);
				}
			}
		},		
        /*
         * _handleEventKeyUp: Handle key event for enter and escape key.
         * Incoming: event.
         * Outgoing: None.
         */
        _handleEventKeyUp: function(event){
            dojo.stopEvent(event);
            
            if (event.keyCode === dojo.keys.ENTER) {
                // Handle enter key presses
                // Default action is clicking OK button 
                this._onOK();
            }
            else 
                if (event.keyCode === dojo.keys.ESCAPE) {
                    // Handle escape key presses
                    // Default action is clicking Cancel button 
                    //this._onCancel();
					this.destroy();
                }
        },
        
        
		/*
         * Displays the Error Message
         * Incoming : Error message
         * Outgoing : None
         */
        _displayErrorMessage: function(errorMessage){
            this._displayAndClearErrorMessage(errorMessage);
        },
        
        _clearErrorMessage: function(){
            EPMErrorHandler.clearError();
        },
        /*
         * Display and clear the error message
         * incoming : Error Message Object
         * OutGoing : None
         */
        _displayAndClearErrorMessage: function(errorMessage){
            var self = this;
            EPMErrorHandler.setError(errorMessage);
            
            // Set an interval and clear the error message
            var intervalID = setInterval(function(){
                self._clearErrorMessage();
                clearInterval(intervalID);
            }, 10000);
        },
        /*
         * destroy: destroy locally created objects and connectors.
         * Incoming: None.
         * Outgoing: None.
         */
        destroy: function(){
            // Disconnect handlers
            if (this._keyUpHandler !== null) {
                this.disconnect(this._keyUpHandler);
                this._keyUpHandler = null;
            }

            this.dialog.close();
            this.dialog.destroy();
			this.inherited("destroy", arguments);
        },
		
		/**
		 * Toggles the lable display - Search within project allocated resources
		 */
		_searchWithinProjectLabelToggle: function(){
			
			if( this.searchWithinProject()){
				dojo.removeClass(this._searchWithinProjectLabelDesc, "searchLabelDescription");
			}
			else{
				dojo.addClass(this._searchWithinProjectLabelDesc, "searchLabelDescription");
			}
			
		}
    });
}
