/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

// Creating an editor for the attachment column
if (!dojo._hasResource["com.ibm.epm.resource.assignment.web.ui.internal2.ChargecodeEditor"]) { //_hasResource checks added by build. Do not use _hasResource directly in your code.
    dojo._hasResource["com.ibm.epm.resource.assignment.web.ui.internal2.ChargecodeEditor"] = true;
    dojo.provide("com.ibm.epm.resource.assignment.web.ui.internal2.ChargecodeEditor");
    
    dojo.require("com.ibm.epm.web.core.ui.internal.EPMGridEditor");
    dojo.require("com.ibm.epm.resource.assignment.web.ui.internal2.ProjectChargecodes");
    dojo.require("com.ibm.epm.web.core.grid.controller.ControllersFactory");
	dojo.require("com.ibm.epm.resource.assignment.web.ui.internal2.ResourceAssignmentViewletConstants");
    //Localization
    dojo.requireLocalization("com.ibm.epm.resource.assignment.web.ui", "Messages");
    var ResourceAssignmentViewletMessages = dojo.i18n.getLocalization("com.ibm.epm.resource.assignment.web.ui", "Messages");
    var controllerFactory = com.ibm.epm.web.core.grid.controller.ControllersFactory;
	var Constants = com.ibm.epm.resource.assignment.web.ui.internal2.ResourceAssignmentViewletConstants;
	var EPMGridEditor = com.ibm.epm.web.core.ui.internal.EPMGridEditor;
    
    dojo.declare("com.ibm.epm.resource.assignment.web.ui.internal2.ChargecodeEditor", EPMGridEditor, {
    
        _selectedRow: null,
        
        // summary:
        /**
         *  constructor : This is the constructor function
         *  Incoming Arguments : inCell
         *  Outgoing Argument :
         *
         */
        constructor: function(inCell){
            this.newDlg = null;
            this.toolbar = null;
        },
        
        /**
         *  format : This function is to format the values in the cell
         *  Incoming Arguments : inDatum, inRowIndex
         *  Outgoing Argument :
         *
         */
        format: function(inDatum, inRowIndex){
            var self = this;
            var presentValues = this.getController().getRowByIndex(inRowIndex).chargecode;
            if (presentValues) {
				presentValues = presentValues.toString();
				return presentValues;
			}
            
        },
        
        /**
         *  getController : This function is to get the controller
         *  Incoming Arguments :
         *  Outgoing Argument :
         *
         */
        getController: function(){
            if (!this._gridController) {
                this._gridController = controllerFactory.getEPMAssignmentGridController("AssignedResourcesGrid");
            }
            return this._gridController;
        },
        
        /**
         *  dodblclick : This function is to handle the double click event
         *  Incoming Arguments : e
         *  Outgoing Argument :
         *
         */
        dodblclick: function(e){
            this._onClick(e);
        },
        
        /**
         *  _onClick : This function is to handle the click event
         *  Incoming Arguments : e
         *  Outgoing Argument :
         *
         */
        _onClick: function(e){
            var self = this;
            self._selectedRow = this.getController().getRowByIndex(e.rowIndex);
            if (self._selectedRow) {
				if(!self._selectedRow.active){
					return;
				}            
                self._selectedRowIndex = e.rowIndex;
                self.fieldtype = "";
                if (e.cell.field == Constants.LABOR_CHARGECODE_FIELD) {
                    self.fieldtype = ResourceAssignmentViewletMessages.LABOUR_COST;
                }
                else 
                    if (e.cell.field == Constants.REVENUE_CHARGECODE_FIELD) {
                        self.fieldtype = ResourceAssignmentViewletMessages.REVENUE_COST;
                    }
					
				// Nullify the dialog if already exists	
	            if (self.newDlg) {
					self.newDlg.destroy();
	                self.newDlg = null;
	            }
				this.chargecodeInfo = new com.ibm.epm.resource.assignment.web.ui.internal2.ProjectChargecodes();
	 		    self.newDlg = new jazz.ui.Dialog({
	                contentNode : this.chargecodeInfo.domNode,
					primaryTitle: self.fieldtype,
					width: "350px",
					height: "auto",
					onOpen: dojo.hitch(this, this._loadInfo),
					onClose: dojo.hitch(this, this._closedialog)
	            });
            }
            
        },
		
        /**
         *  doclick : This function is to handle the click event
         *  Incoming Arguments : e
         *  Outgoing Argument :
         *
         */
        doclick: function(e){
			//Conditions in which the pop up is opened
			//1. When the current row is being edited and this cell is clicked
			if( (e && e.grid && e.grid.edit && e.grid.edit.isEditing() && e.grid.edit.info) &&
				(e.rowIndex == e.grid.edit.info.rowIndex)) {
				this._onClick(e);
			}
		},
        
		/*
         * This method is called when we click on the assign and remove button.
         * Closes the dialog and destroys the widgets.
         */
        destroyAndCloseDialog: function(){
            if (this.chargecodeInfo) {
                this.chargecodeInfo.destroy();
            }
            if (this.newDlg) {
                this.newDlg.close();
                this.newDlg.destroy();
                this.newDlg = null;
            }
        },
		
		 /**
         * This will be called when press closeicon on the top of the dialog
         */
        _closedialog: function(){
			if (this.chargecodeInfo) {
                this.chargecodeInfo.destroy();
            }
            return true;           
        },
        
        /**
         *  _loadInfo : This function is to load the project associated charge codes
         *  Incoming Arguments : data
         *  Outgoing Argument :
         *
         */
        _loadInfo: function(){        
            this.chargecodeInfo.load(this);
        },
		
		/* Enter KeyDown Event on grid bring control here */		
		onEnterKeyDown: function(e){	
			dojo.stopEvent(e);
			this._onClick(e);   
        }
        
        
    });
    
}
