/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

/**
 * @author suryakant
 */
(function(){
    dojo.provide("com.ibm.epm.resource.assignment.web.ui.internal2.ProjectAssignmentGridModel");
    
    dojo.require("com.ibm.epm.web.core.grid.model.AbstractGridModel");
    
    dojo.require("com.ibm.epm.web.core.grid.controller.ControllerUtil");
    
    //Client
    dojo.require("com.ibm.epm.resource.assignment.web.client.internal.ResourceAssignmentClient");
    
    // Constants
    dojo.require("com.ibm.epm.resource.assignment.web.ui.internal2.ResourceAssignmentViewletConstants");
    
    dojo.require("com.ibm.epm.web.core.util.internal.DateUtil");
    
    dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
    var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
    
    var DateUtil = com.ibm.epm.web.core.util.internal.DateUtil;
    
    var Constants = com.ibm.epm.resource.assignment.web.ui.internal2.ResourceAssignmentViewletConstants;
    
    var abstractGridModel = com.ibm.epm.web.core.grid.model.AbstractGridModel;
    
    var controllerUtil = com.ibm.epm.web.core.grid.controller.ControllerUtil;
    
    var ResourceAssignmentClient = com.ibm.epm.resource.assignment.web.client.internal.ResourceAssignmentClient;
    
    dojo.declare("com.ibm.epm.resource.assignment.web.ui.internal2.ProjectAssignmentGridModel", abstractGridModel, {
    
        newElementPrefix: Constants.UNSAVED,
		
        /*
         * This is called by controller. Returns the empty row structure to the controller.
         */
        getEmptyRow: function(rowID, collectionItemHandle){
        
            var row = {
                "id": rowID,
                "href": rowID,
                "name": " ",
                "role": "",
                "proposedstart": "",
                "proposedduration": "",
				"assignedeffort":0,
                "proposedfinish": "",
				"effort": "",
                "costRate": "",
                "sellingRate": "",
                "resourceRelativeHref": "",
				"action":"",
				"active": "",
				"value":"",
				"scheduleId": ""

            };
            
            return row;
        },
        /*
         * Gets the link information from the server retunred data
         */
        getAssignedLink: function(loadedElement, linkIDs){
            for (var i in linkIDs) {
                var link = loadedElement[linkIDs[i]];
                if (link) {
                    if (dojo.isArray(link)) {
                        link = link[0];
                    }
                    return link;
                }
            }
        },
        
        /*
         * This is called by controller.
         * After inserting a row in Grid, the getAndUpdateRow() calls updateRowData with RowURI, RowID params.
         */
        updateRowData: function(row, loadedElement, linkName){
         var temp = loadedElement.plannedSchedule;
			if(dojo.isArray(temp) && ! loadedElement.tempPlannedSchedule){
				for(var i = 0; i< temp.length ; i++){
					var controller = controllerUtil.getEPMGridController(Constants.PROJECT_ASSIGNMENT_GRID_CONTROLLER);
					var dataModel = controller.getDataModel(); 
					var rowIndex = controller.getRowIndex(row.id) + 1;
					loadedElement.tempPlannedSchedule = temp[i];
					if(i == 0){
						controller._updateGridRow(loadedElement, loadedElement.relativeHref, null);
					}
					else{
						loadedElement.relativeHref = loadedElement.relativeHref + Constants.SUFFIX_FOR_DISCRETE_ASSIGNMENT + ":" + temp[i].id;
						var tempRow = this.getEmptyRow(loadedElement.relativeHref);
						controller._addRow(tempRow, rowIndex);
						controller._updateGridRow(loadedElement, loadedElement.relativeHref, null);
					}
					
				}
				return;
			}
            if (linkName == null) {
            
                var assignedResourceLink = this.getAssignedLink(loadedElement, [Constants.PROJECT_RESOURCE_ASSIGNED, Constants.RESOURCE_ASSIGNED]);
                var assignedProfileLink = this.getAssignedLink(loadedElement, [Constants.PROJECT_PROFILE_ASSIGNED, Constants.PROFILE_ASSIGNED]);
                
                if (assignedResourceLink) {
                    row.name = assignedResourceLink.title;
                }
                else 
                    if (assignedProfileLink) {
                        row.name = assignedProfileLink.name;
                    }
                
                if (assignedResourceLink) {
                    row.resourceRelativeHref = assignedResourceLink.relativeHref;
                }
                else 
                    if (assignedProfileLink) {
                        row.resourceRelativeHref = Constants.PROFILE_URI + Constants.SLASH + assignedProfileLink.id;
                    }
                
                var startDate = "";
                var finishDate = "";
                var duration = "";
                var contour = "";
                var scheduleId = "";
				if (loadedElement.tempPlannedSchedule) {
                    startDate = DateUtil.parseDate(loadedElement.tempPlannedSchedule.fromDate);
                    finishDate = DateUtil.parseDate(loadedElement.tempPlannedSchedule.toDate);
                    duration = loadedElement.tempPlannedSchedule.duration;
                    scheduleId = loadedElement.tempPlannedSchedule.id;
                    effort = loadedElement.tempPlannedSchedule.effort;
					if(loadedElement.tempPlannedSchedule.hoursBlocked){
						contour = loadedElement.tempPlannedSchedule.hoursBlocked;
					}
                    
                }
				else if (loadedElement.plannedSchedule) {
					
					if(loadedElement.plannedSchedule && loadedElement.plannedSchedule[0])
						{
							var plannedScheduleInfo = loadedElement.plannedSchedule[0];
						
							startDate = DateUtil.parseDate(plannedScheduleInfo.fromDate);
	                  		finishDate = DateUtil.parseDate(plannedScheduleInfo.toDate);
							duration = plannedScheduleInfo.duration;
			                effort = plannedScheduleInfo.effort;
							scheduleId = plannedScheduleInfo.id;
							if(plannedScheduleInfo.hoursBlocked){
								contour = plannedScheduleInfo.hoursBlocked;
							}
							
						}
					 else{
	                    
							startDate = DateUtil.parseDate(loadedElement.plannedSchedule.fromDate);
	                    	finishDate = DateUtil.parseDate(loadedElement.plannedSchedule.toDate);
	                    	duration = loadedElement.plannedSchedule.duration;
							effort = loadedElement.plannedSchedule.effort;
							scheduleId = plannedScheduleInfo.id;
							if(loadedElement.plannedSchedule.hoursBlocked){
								contour = loadedElement.plannedSchedule.hoursBlocked;
							}
					}
                }
                else {
                    startDate = DateUtil.parseDate(loadedElement.proposedstart);
                    finishDate = DateUtil.parseDate(loadedElement.proposedfinish);
                    duration = loadedElement.proposedduration;
                }
				row.value = contour;
                row.active = loadedElement.active;
                row.proposedstart = startDate;
                row.proposedfinish = finishDate;
                row.proposedduration = duration;
				row.effort = effort;
                row.role = loadedElement.role;
				row.costRate = loadedElement.costRate;
				row.sellingRate = loadedElement.sellingRate;
                row.loadedelement = [loadedElement];
				row.scheduleId = scheduleId;
				
				//update the assigned effort and task count
				this.updateAssignedEffort(row, loadedElement);
            }
        },
        
        /*
         * Update Rate Cell
         */
        _updateRate: function(row, loadedElement){
        
            var rateLink = controllerUtil.getLink(loadedElement, Constants.RATE);
            if (rateLink) {
                var self = this;
                var serviceObj = {
                    success: function(data){
                        if (!data) {
                            //TODO
                        }
                        else {
                            row.costRate = data.costRate;
                            row.sellingRate = data.sellingRate;
                            row.rate = {
                                costRate: data.costRate,
                                sellingRate: data.sellingRate,
                                systemRate: data.systemRate,
                                selfURI: rateLink.relativeHref
                            };
                            var controller = controllerUtil.getEPMAssignmentGridController(Constants.PROJECT_ASSIGNMENT_GRID_CONTROLLER);
                            var rowIndex = controller.getRowIndex(row.id);
                            controller.setRowData(row, row.id, rowIndex);
                        }
                    },
                    failure: function(errorObj){
                        self._displayErrorMessage("Failed to get rate for assignment");
                    }
                };
                var srh = new ServiceResponseHandler(serviceObj, "success", "failure");
                ResourceAssignmentClient.getResourceData_Href(srh, rateLink.relativeHref);
            }
        },
        
        /*
         * URI for Row level Info
         * Incoming : RowHandle, Row Id
         * Outgoing : URI to get row information
         */
        getRowGetURI: function(rowElementHandle, rowID){
            return rowElementHandle.relativeHref;
        },
		
		/**
		 * Updates the assigned effort for the proejct assignment
		 * @param {Object} row
		 * @param {Object} loadedElement
		 */
        updateAssignedEffort: function(row, loadedElement){
        
                var self = this;
				var resourceId = "";
				var isUserQuery = true;
                if (loadedElement.profile) {
                    resourceId = loadedElement.profile.id;
					isUserQuery = false;
                }
                else if (loadedElement.User) {
                        resourceId = loadedElement.User.relativeHref;
						isUserQuery = true;
                }
				
                var serviceObject = {
                
                    success: function(itemInfo){
                       var assignedEffort = 0;                        
					    if (itemInfo) {					    	
						    assignedEffort = self.getAssignedEffort(itemInfo, row);
                        }
						var controller = controllerUtil.getEPMGridController(Constants.PROJECT_ASSIGNMENT_GRID_CONTROLLER);
						var dataModel = controller.getDataModel(); 
						if ( dataModel ) {
							var item = dataModel.store._getItemByIdentity(row.id);
							if (item) {
								
								dataModel.store._setValueOrValues(item, "assignedeffort", assignedEffort, true);
							}
							
						}
                    },
                    failure: function(errorObj){
                    
                    }
                };
               
			   var srh = new ServiceResponseHandler(serviceObject, "success", "failure");
			   var startDate = DateUtil.formatDateForSave(row.proposedstart);
			   var finishDate = DateUtil.formatDateForSave(row.proposedfinish);
			   if(isUserQuery){
			   		
					//get the project id
					var projectId = loadedElement.Project.relativeHref;

					var args = {
						projectId: projectId.substring(projectId.indexOf("/")+1),
						userId: resourceId.substring(resourceId.lastIndexOf("/")+1),
						projectAllocationId: row.scheduleId,
						expand:true
						};
	                ResourceAssignmentClient.getAllTaskAssignmentForUser(srh, args);
				}else{
					
					var args = {
						profileId: resourceId,
						startDate: startDate,
                		finishDate: finishDate,
						expand:true
					};
					ResourceAssignmentClient.getAllTaskAssignmentsForProfile(srh, args);
					
				}
        },
		
		getAssignedEffort: function(itemInfo){       	
        	 
            if (itemInfo) {            	
				var totalNumberOfTasks = 0;
				totalNumberOfTasks = itemInfo.length;
				var assignedEffort = 0;
                for (var i = 0; i < totalNumberOfTasks; i++) { 
					var	_effort = 0;
				
				 	if (itemInfo[i] && itemInfo[i].taskAssignment && itemInfo[i].taskAssignment.plannedSchedule)
					{
				  		var plannedScheduleInfo;
						if(itemInfo[i].taskAssignment.plannedSchedule[0])
							plannedScheduleInfo = itemInfo[i].taskAssignment.plannedSchedule[0];
						else
							plannedScheduleInfo = itemInfo[i].taskAssignment.plannedSchedule;
						
					   _effort = plannedScheduleInfo.effort;							
               		}
                    
                    assignedEffort = assignedEffort + _effort;                    
                }
				return assignedEffort;
            }
			return 0;
        }

    });
})();
