/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
/**
 * @author suryakant
 */
(function(){
    dojo.provide("com.ibm.epm.resource.assignment.web.ui.internal2.ProjectAssignmentGridView");
    
    dojo.require("com.ibm.epm.web.core.grid.view.AbstractGridView");
    
    dojo.require("com.ibm.epm.resource.assignment.web.ui.internal2.ProjectAssignmentGridModel");
    
    dojo.require("com.ibm.epm.web.core.grid.controller.ControllerUtil");
    
    dojo.require("com.ibm.epm.web.core.util.internal.DateUtil");
    
    dojo.require("com.ibm.epm.web.core.ui.internal.EPMGridPubSub");
    
    // Constants
    dojo.require("com.ibm.epm.resource.assignment.web.ui.internal2.ResourceAssignmentViewletConstants");
    
	dojo.require("com.ibm.epm.web.core.util.internal.GridColumnUtil");

    //Localization
    dojo.requireLocalization("com.ibm.epm.resource.assignment.web.ui", "Messages");
    
    var DateUtil = com.ibm.epm.web.core.util.internal.DateUtil;
    
    var controllerUtil = com.ibm.epm.web.core.grid.controller.ControllerUtil;
    
    var abstractView = com.ibm.epm.web.core.grid.view.AbstractGridView;
    
    var Constants = com.ibm.epm.resource.assignment.web.ui.internal2.ResourceAssignmentViewletConstants;
    
    var EPMGridPubSub = com.ibm.epm.web.core.ui.internal.EPMGridPubSub;
    
    var ResourceAssignmentViewletMessages = dojo.i18n.getLocalization("com.ibm.epm.resource.assignment.web.ui", "Messages");

	var GridColumnUtil = com.ibm.epm.web.core.util.internal.GridColumnUtil;
    
    dojo.declare("com.ibm.epm.resource.assignment.web.ui.internal2.ProjectAssignmentGridView", abstractView, {
    
        templateString: '<div class="com-ibm-epm-resource-assignment-web-ui-internal2-ProjectAssignmentGrid">' + 
							'<div class="com-ibm-epm-web-core-ui-internal-templates-EPMGrid" dojoAttachPoint="projectAssignmentGridViewAttachPoint">'+ 
							'</div>' + 
						'</div>',
        //Controller
        projectAssignmentGridController: null,
        context: null,
        itemOfTypeEffort: false,
        
        constructor: function(){
            this._rowHoverArray = [];
            this._pconnects = [];
        },
        
        /* 
         * Creates the Grid view the skill Grid,
         * Inherited to connect event from Grid.
         */
        createView: function(){
        
            this.inherited('createView', arguments);
            
            this._pconnects.push(dojo.connect(this._generalGrid, EPMGridPubSub.ON_CELL_DBL_CLICK, this, this.onCellClick));
            this._pconnects.push(dojo.connect(this._generalGrid, EPMGridPubSub.ON_CELL_CLICK, this, this.onCellClick));
            this._pconnects.push(dojo.connect(this._generalGrid, "onRowMouseOver", this, this._onMouseOver));
            this._pconnects.push(dojo.connect(this._generalGrid, "onRowMouseOut", this, this._onMouseOut));
			this._pconnects.push(dojo.connect(this._generalGrid, 'onStyleRow', this, this._styleRow));
			this._pconnects.push(dojo.connect(this._generalGrid, EPMGridPubSub.ON_KEY_DOWN, this, this._onKeyDown));
        },
        
        /* 
         * Builds the skill Grid
         */
        buildProjectAssignmentGrid: function(itemIsOfTypeEffort){
        
            this.itemOfTypeEffort = itemIsOfTypeEffort;
            if (!this._gridModel) {
                this._gridModel = new com.ibm.epm.resource.assignment.web.ui.internal2.ProjectAssignmentGridModel();
            }
            
            if (!this.projectAssignmentGridController) {
                this.projectAssignmentGridController = controllerUtil.getEPMGridController(Constants.PROJECT_ASSIGNMENT_GRID_CONTROLLER);
            }
            else {
            
                this.projectAssignmentGridController.setAllElementsURI(this._treeID);
            }
			
			this.viewIsBusy = true;
            this.buildGrid(this, this._gridModel, this.projectAssignmentGridController);
            if (this._generalGrid) {
                var updatedLayout = this.getGridLayout();
                this._generalGrid.setStructure(updatedLayout);
            }
        },
        
        
        /*
         * OnBlur funtion - Overriding this funtion to avoid deselection of Rows
         *
         */
        _onBlur: function(data){
        
            //DO nothing
            
            return;
            
        },
        
        /*
         * getGridTitle funtion - Override the abstract class and returns the title of the grid.
         *
         */
        getGridTitle: function(){
            return Constants.PROJECT_ASSIGNMENT_GRID_TITLE;
        },
        
        /*
         * This is called by controller. Returns the Attachpoint to the controller.
         */
        getAttachpoint: function(){
            return this.projectAssignmentGridViewAttachPoint;
        },
        
        /*
         * This is called by abstractView while creating the view.
         * getGridLayout() is to return grid structure to abstractView.
         */
        getGridLayout: function(){
        
        
            var assignedResourcesGridLayout = [{
                noscroll: false,
                defaultCell: {
                    width: 8,
                    styles: 'text-align: left;'
                },
                rows: [[{
                    name: " ",
                    width: 1.5,
					value: "",
                    formatter: this.userOrProfile
                }, {
                    name: ResourceAssignmentViewletMessages.NAME,
                    width: 10,
                    field: "name",
					title: ResourceAssignmentViewletMessages.NAME_TITLE
                }, {
                	name: ResourceAssignmentViewletMessages.ACTIONS,
                	width: 7,
                	field: "action",
                	headerClasses: "com-ibm-epm-resource-assignment-web-ui-internal2-ProjectAssignmentGrid-unsortableColumn",
					title: ResourceAssignmentViewletMessages.ACTIONS_TITLE
				}, {
                    name: ResourceAssignmentViewletMessages.ROLE, //ROLE
                    width: 7,
                    field: "role",
					title: ResourceAssignmentViewletMessages.ROLE_TITLE
                
                }, {
                    name: ResourceAssignmentViewletMessages.START_DATE,
                    width: 7,
                    field: "proposedstart",
                    formatter: DateUtil.formatDate,
					title: ResourceAssignmentViewletMessages.START_DATE_TITLE
                
                }, {
                    name: ResourceAssignmentViewletMessages.END_DATE,
                    width: 7,
                    field: "proposedfinish",
                    formatter: DateUtil.formatDate,
					title: ResourceAssignmentViewletMessages.END_DATE_TITLE
                }, {
                    name: ResourceAssignmentViewletMessages.DURATION,
                    width: 5,
                    field: "proposedduration",
					formatter: GridColumnUtil.formatDays,
					title: ResourceAssignmentViewletMessages.DURATION_TITLE
                }
				
				
				]]
            }];
            
            if (this.itemOfTypeEffort) {
                var effortColumn = {
                    name: ResourceAssignmentViewletMessages.EFFORT,
                    width: 5,
                    field: "effort",
					formatter: GridColumnUtil.formatHours,
					styles: Constants.RIGHT_ALIGN_TEXT_STYLEINVALID_EFFORT_VALUE,
				title: ResourceAssignmentViewletMessages.EFFORT_TITLE

                };
                assignedResourcesGridLayout[0].rows[0].push(effortColumn);
            }
			assignedResourcesGridLayout[0].rows[0].push({
                name: ResourceAssignmentViewletMessages.CONTOUR_LABEL,
                width: 5,
                field: "value",
                formatter: GridColumnUtil.formatHours,
                styles: Constants.RIGHT_ALIGN_TEXT_STYLE,
				title: ResourceAssignmentViewletMessages.CONTOUR_TITLE
            });
			
			assignedResourcesGridLayout[0].rows[0].push({
                name: ResourceAssignmentViewletMessages.ASSIGNED_EFFORT,
                width: 8,
                field: "assignedeffort",
				formatter: GridColumnUtil.formatHours,
				styles: Constants.RIGHT_ALIGN_TEXT_STYLE,
				title: ResourceAssignmentViewletMessages.ASSIGNED_EFFORT_TITLE
            });
            assignedResourcesGridLayout[0].rows[0].push({
                name: ResourceAssignmentViewletMessages.COST_RATE,
                width: 6,
                field: "costRate",
				formatter: GridColumnUtil.formatRates,
				styles: Constants.RIGHT_ALIGN_TEXT_STYLE,
				title: ResourceAssignmentViewletMessages.COST_RATE_TITLE
            });
            
            assignedResourcesGridLayout[0].rows[0].push({
                name: ResourceAssignmentViewletMessages.SELLING_RATE,
                width: 6,
                field: "sellingRate",
				formatter: GridColumnUtil.formatRates,
				styles: Constants.RIGHT_ALIGN_TEXT_STYLE,
				title: ResourceAssignmentViewletMessages.SELLING_RATE_TITLE
            });
            return assignedResourcesGridLayout;
        },
        
        /*
         *
         */
        userOrProfile: function(/*String*/inDatum, /*Integer*/rowIndex){
            var returnString = "";
            if (this.grid) {
                var row = this.grid.model.getRow(rowIndex);
                if (row) {
                    if (row.resourceRelativeHref != "") {
                        if (row.resourceRelativeHref.toUpperCase().indexOf("profile".toUpperCase()) != -1) {
                            returnString = '<img name="profileImage" title="' + ResourceAssignmentViewletMessages.PROFILE_IMAGE +
                            '" alt="' + ResourceAssignmentViewletMessages.PROFILE_IMAGE + '" src =' +
                            dojo.moduleUrl("com.ibm.epm.web.core", "ui/internal/images/profile_obj.gif") +
                            " />";
                        }
                        else 
                            if (row.active && row.resourceRelativeHref.toUpperCase().indexOf("user".toUpperCase()) != -1) {
                                returnString = '<img name="resourceImage" title="' + ResourceAssignmentViewletMessages.RESOURCE_IMAGE +
                                '" alt="' + ResourceAssignmentViewletMessages.RESOURCE_IMAGE + '" src =' +
                                dojo.moduleUrl("com.ibm.epm.web.core", "ui/internal/images/resource_obj.gif") +
                                " />";
                            } else {
								 returnString = '<img name="resourceImage" title="' + ResourceAssignmentViewletMessages.INACTIVE_ASSIGNMENT_IMAGE +
                                '" alt="' + ResourceAssignmentViewletMessages.INACTIVE_ASSIGNMENT_IMAGE + '" src =' +
                                dojo.moduleUrl("com.ibm.epm.web.core", "ui/internal/images/inActiveResource_obj.gif") +
                                " />";
							}
                    }
                }
            }
            return returnString;
        },
        
        /*
         * Called by the Resource Assignment Tab Manager to get the selected rows of the grid
         * Incoming: None
         * Outgoing: Array of Selected Rows
         */
        getSelectedRows: function(){
        
            var selectedProjectResourceRow = [];
            if (this._generalGrid) {
                var selectedRows = this._generalGrid.selection.getSelected();
                
                var length = selectedRows.length;
                
                selectedProjectResourceRow = new Array(length);
                
                for (var rowIndex = 0; rowIndex < selectedRows.length; rowIndex++) {
                
                    selectedProjectResourceRow[rowIndex] = this._generalGrid.model.getRow(selectedRows[rowIndex]);
                }
            }
            return selectedProjectResourceRow;
        },
        
		/*
         * Private Method
         * _onKeyDown: Handle the on key down event on the grid row and do the action 
         * Input: event e
         * outPut: None
         */
		_onKeyDown: function(e){
			//Donot process the row if an editor is open
            if (this._generalGrid.edit && this._generalGrid.edit.isEditing()) {
                return;
            }			          
			switch (e.keyCode){
				case 65 /*a - Assign profile or resource*/:
					if(this._canDoAction(e, ResourceAssignmentViewletMessages.ASSIGN_BUTTON)){
						this.context._assignResource();
					}
					break;
				case 82 /*r - Replace*/:
					if(this._canDoAction(e, ResourceAssignmentViewletMessages.REPLACE)){
						this.context.replaceProfileWithAllocatedUser(this.getSelectedRows());
					}
					break;
			}
					
		},
		
		_canDoAction: function(e, action){
			var row = this._generalGrid.model.getRow(e.rowIndex);
            if(row.markedForDeletion) {
            	return false;
            }
            if (row) {
				if (row.active) {
					if (row.resourceRelativeHref) {
						if (row.resourceRelativeHref.toUpperCase().indexOf("user".toUpperCase()) != -1) {
							if((action == ResourceAssignmentViewletMessages.ASSIGN_BUTTON) ||
								(action == ResourceAssignmentViewletMessages.REPLACE)){
								return true;
							}
	                   	}
	                   	else {
							if(action == ResourceAssignmentViewletMessages.ASSIGN_BUTTON){
								return true;
							}
	                 	}
					 }
				}
			}
			return false;
		},
		
        /*
         * Private Method
         * _MouseOut: Handle the on mouse over event on the grid row and add the action images to action column
         * Input: event e
         * outPut: None
         */
        _onMouseOver: function(e){
            if (e.rowIndex != -1) {
                this._clearAllActionRows();
                
                var row = this._generalGrid.model.getRow(e.rowIndex);
                if (row) {
					if(row.active){
	                    var columnCount = this._generalGrid.hasLayout();
	                    if (columnCount > 0) {
	                        var cellobj = this._generalGrid.getCell(this._getActionColumnIndex());
	                        var cellDomNode = cellobj.getNode(e.rowIndex);
	                        if (row.resourceRelativeHref) {
	                            if (row.resourceRelativeHref.toUpperCase().indexOf("user".toUpperCase()) != -1) {
	                                cellDomNode.innerHTML = '<img name="assignImage" style="margin-right: 7px; cursor: pointer;" title="' + ResourceAssignmentViewletMessages.ASSIGN_BUTTON +
	                                '" alt="' + ResourceAssignmentViewletMessages.ASSIGN_BUTTON + '" src =' +
	                                dojo.moduleUrl("com.ibm.epm.web.core", "ui/internal/images/actions/action_assignresource.gif") +
	                                ' />&nbsp<img name="replaceImage" style="margin-right: 7px; cursor: pointer;" title="' +
	                                ResourceAssignmentViewletMessages.REPLACE +
	                                '" alt="' + ResourceAssignmentViewletMessages.REPLACE + '" src =' +
	                                dojo.moduleUrl("com.ibm.epm.web.core", "ui/internal/images/actions/action_replace.gif") +
	                                ' />';
	                            }
	                            else {
	                                cellDomNode.innerHTML = '<img name="assignImage" style="margin-right: 7px; cursor: pointer;" title="' + ResourceAssignmentViewletMessages.ASSIGN_BUTTON +
	                                '" alt="' + ResourceAssignmentViewletMessages.ASSIGN_BUTTON + '" src =' +
	                                dojo.moduleUrl("com.ibm.epm.web.core", "ui/internal/images/actions/action_assignprofile.gif") +
	                                " />";
	                            }
	                        }
	                        this._rowHoverArray.push(e.rowIndex);
	                    }
	                }
				}
            }
        },
        
        /*
         * Private Method
         * _MouseOut: Handle the on mouse out event on the grid row and remove the action images from action column
         * Input: event e
         * outPut: None
         */
        _onMouseOut: function(e){
            if (e.rowIndex != -1) {
                this._clearAllActionRows();
                this._clearOneActionRow(e.rowIndex);
            }
        },
        
        /*
         * Private Method
         * _clearOneActionRow: Clear action from this row
         * Input: event e
         * outPut: None
         */
        _clearOneActionRow: function(rowIndex){
            var row = this._generalGrid.model.getRow(rowIndex);
            if (row) {
                var actionValue = "";
                var columnCount = this._generalGrid.hasLayout();
                if (columnCount > 0) {
                    var cellobj = this._generalGrid.getCell(this._getActionColumnIndex());
                    var cellDomNode = cellobj.getNode(rowIndex);
                    cellDomNode.innerHTML = actionValue;
                }
            }
        },
        
         /*
         * Private Method
         * _getActionColumnIndex: Returns the  column index of Action Column
         * Input: None
         * outPut: Integer index
         */
		_getActionColumnIndex: function() {
			var index = this._generalGrid.layout.cellCount - 1; //default to the last
			for(i=0; i<this._generalGrid.layout.cellCount; i++){
				if(this._generalGrid.layout.cells[i].field == "action"){
					index = i;
					break;
				}
			}
			return index;
		},

       /*
         * Private Method
         * _clearAllActionRow: Clear all actions from this row
         * Input: event e
         * outPut: None
         */
        _clearAllActionRows: function(){
            for (var i = 0; i < this._rowHoverArray.length; i++) {
                var rowIndex = this._rowHoverArray[i];
                this._clearOneActionRow(rowIndex);
            }
            this._rowHoverArray = [];
        },
        
        /*
         * Private Method
         * onCellClick: Handle the on cell click event on the grid cell to take appropriate action according to the image clicked in action column
         * Input: event e
         * outPut: None
         */
        onCellClick: function(event){
            if (event) {
                if (event.cell.field == "action") {
                    if (event.target.name == "assignImage") {
                        this.context._assignResource(); //TODO: need to replace with proper Function.
                    }
                    else 
                        if (event.target.name == "replaceImage") {
                             this.context.replaceProfileWithAllocatedUser(this.getSelectedRows());
                        }
                }
            }
        },
        
        destroy: function(){
            dojo.forEach(this._pconnects, dojo.disconnect);
            this._pconnects = [];
            
            this.inherited("destroy", arguments);
        },

		/**
		 * @return Retrieves the sortable columns for this grid view
		 */
		
		getSortableColums:function()
		{
			var sortableFields ={};
			sortableFields[Constants.NAME_COL] = Constants.NAME_COL;
			sortableFields[Constants.PROPOSED_START_COL] = Constants.PROPOSED_START_COL;
			sortableFields[Constants.PROPOSED_FINISH_COL] = Constants.PROPOSED_FINISH_COL;
			sortableFields[Constants.PROPOSED_DURATION_COL] = Constants.PROPOSED_DURATION_COL;
			sortableFields[Constants.EFFORT_COL] = Constants.EFFORT_COL;
			
			return sortableFields;
		},
		
		/**
         *
         * @param {Object} row
         * This function is called from the onStyleRow listener event.
         * Depending upon the state of the task or if the timesheet is
         * for the project manager view, approriate class is attached to
         * the row node or the cell node.
         */
        _styleRow: function(row){
        	
			if(this._generalGrid){
				
				var item = this.projectAssignmentGridController.getRowByIndex(row.index);
	            
	            if (item) {
	                var assignmentState = item.active;
	                if (assignmentState) {
	                    return;
	                }
	                row.customClasses = row.customClasses + " " + "rowNonEditable";
	            }
			}
        },
		
		 /**
         * Displays any error that may occur
         */
        handleError: function(errorObject){
            this.inherited("handleError", arguments);
            this._displayError(errorObject);
        }
        
    });
})();
