/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){

    dojo.provide("com.ibm.epm.resource.assignment.web.ui.internal2.ResourceQueryGrid");
    
    // Viewlet
    dojo.require("com.ibm.epm.web.core.ui.internal.EPMGrid");
    
    // Client
    dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
    dojo.require("com.ibm.epm.resource.assignment.web.client.internal.ResourceAssignmentClient");
    dojo.require("com.ibm.epm.web.core.client.internal.QueryClient");
    
    dojo.require("com.ibm.epm.web.core.client.QueryUtil");
    dojo.require("com.ibm.epm.web.core.ui.internal.EPMGridPubSub");
    
    //Constants
    dojo.require("com.ibm.epm.resource.assignment.web.ui.internal2.ResourceAssignmentViewletConstants");
    dojo.require("com.ibm.epm.web.core.ui.internal.EPMDomNodeConstants");
    
    // dojo library
    dojo.require("dojo.data.ItemFileWriteStore");
	
	dojo.require("com.ibm.epm.web.core.util.internal.GridColumnUtil");
    
    // Localization
    dojo.requireLocalization("com.ibm.epm.resource.assignment.web.ui", "Messages");
    
    // Dialogs
    dojo.require("com.ibm.epm.web.core.ui.internal.EPMErrorHandler");
    
    dojo.require("dijit._Widget");
    dojo.require("dijit._Templated");
	
	dojo.require("com.ibm.epm.web.core.util.internal.DateUtil");
	dojo.require("com.ibm.epm.web.core.util.internal.Util");
    var DateUtil = com.ibm.epm.web.core.util.internal.DateUtil;
    
    var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
    
    var ResourceAssignmentClient = com.ibm.epm.resource.assignment.web.client.internal.ResourceAssignmentClient;
    
    var ResourceAssignmentViewletMessages = dojo.i18n.getLocalization("com.ibm.epm.resource.assignment.web.ui", "Messages");
    
    var QueryClient = com.ibm.epm.web.core.client.internal.QueryClient;
    
    var QueryUtil = com.ibm.epm.web.core.client.QueryUtil;
    
    var RESOURCE_QUERY_TYPE = "com.ibm.epm.resource.epmUserType";
    
    var getAuthenticatedContributor = com.ibm.team.repository.web.client.session.getAuthenticatedContributor;
    
    var Constants = com.ibm.epm.resource.assignment.web.ui.internal2.ResourceAssignmentViewletConstants;
    
    var EPMErrorHandler = com.ibm.epm.web.core.ui.internal.EPMErrorHandler;
    
    var EPMGridPubSub = com.ibm.epm.web.core.ui.internal.EPMGridPubSub;
    
    var EPMDomNodeConstants = com.ibm.epm.web.core.ui.internal.EPMDomNodeConstants;
    
	var GridColumnUtil = com.ibm.epm.web.core.util.internal.GridColumnUtil;
    var util = com.ibm.epm.web.core.util.internal.Util;

    dojo.declare("com.ibm.epm.resource.assignment.web.ui.internal2.ResourceQueryGrid", [dijit._Widget, dijit._Templated], {
    
        templatePath: dojo.moduleUrl("com.ibm.epm.resource.assignment.web", "ui/internal2/templates/ResourceQueryGrid.html"),
        
        //Current Query Id
        _currentQueryID: null,
        
        _currentQueryType: null,
        
        _queryParameterForAvailablitySearch: "",
        
        context: null,
        
        _allResourcesLabel: "",
        /*
         * Constructor for the Widget
         * Incoming : Arguments
         * Outgoing : None
         */
        constructor: function(args){
            this._rowHoverArray = [];
            this._pconnects = [];
			
        },
        
        /*
         * Post Create funtion for the Widget
         * Incoming : None
         * Outgoing : None
         */
        postCreate: function(){
        },
        
        /*
         * Refersh Funtion
         */
        refresh: function(){
        
            //Execute the query to fill the upper grid
            if (this._currentQueryID) {
            
                this.executeQuery_n_BuildGrid(this._currentQueryID, this._currentQueryType, this._queryParameterForAvailablitySearch);
            }
            else {
                this._createNoResultLabel();
            }
            
        },
        
        /* 
         * Destory Grid Funtion
         */
        destroy: function(){
        
            if (this._resourceQueryGridDataStore) {
            
                delete this._resourceQueryGridDataStore;
            }
            
            if (this._resourceQueryGrid) {
            
                this._resourceQueryGrid.destroy();
                
                delete this._resourceQueryGrid;
            }
            
            //disconnect
            
            dojo.forEach(this._pconnects, dojo.disconnect);
            this._pconnects = [];
            // Call super class destory method
            
            this.inherited("destroy", arguments);
            
            
        },
        
        /*
         * Returns the Selected Row
         * Incoming : None
         * Outgoing : Selected Rows
         */
        getSelectedRows: function(){
        
            var selectedRows = this._resourceQueryGrid.selection.getSelected();
            
            var length = selectedRows.length;
            
            var selectedProjectResourceRow = new Array(length);
            
            for (var rowIndex = 0; rowIndex < selectedRows.length; rowIndex++) {
            
                selectedProjectResourceRow[rowIndex] = this._resourceQueryGrid.model.getRow(selectedRows[rowIndex]);
            }
            
            return selectedProjectResourceRow;
            
        },
        
        
        /*
         * This function is required for re-sizing the grids displayed in the UI.
         */
        update: function(){
        
            if (this._resourceQueryGrid) {
                this._resourceQueryGrid.resizeGrid(dojo.contentBox(this._resourceQueryGrid.domNode));
            }
            
            
        },
        
        
        
        /*
         * Display No result Label
         */
        _createNoResultLabel: function(){
        
        	this._hideLoadingLabel();
            if (this._resourceQueryGrid && this._projectResourceContent) {
            
                this._projectResourceContent.removeChild(this._resourceQueryGrid.domNode);
            }
            
            // Create the label showing all the resources allocated to project
            this.noResultLabel = document.createElement("label");
            
            dojo.addClass(this.noResultLabel, "errorLabel");
            
            this.noResultLabel.innerHTML = ResourceAssignmentViewletMessages.NO_RESULTS_FROM_QUERY;
            
            this._projectResourceContent.appendChild(this.noResultLabel);
        },
        
        /*
         * Display loading Label
         */
        _createLoadingLabel: function(){
        
        
            if (this._resourceQueryGrid && this._loadingLabel) {
            
                this._loadingLabel.removeChild(this._resourceQueryGrid.domNode);
            }
            
            var loadingLabel = document.createElement(EPMDomNodeConstants.LABEL);
            loadingLabel.innerHTML = ResourceAssignmentViewletMessages.WAITING_TO_LOAD;
            this._loadingLabel.appendChild(loadingLabel);
        },
        
		/*
         * Hide the loading label
         * Incoming : None
         * Outgoing : None
         */
        _hideLoadingLabel: function(){
            dojo.style(this._loadingLabel, "display", "none");
        },
        /*
         * Private Method
         * 		Calls the server to the URI /query/<queryID>?execute=true.
         * @param String queryId: The Item ID of the stored query.
         * @return void
         */
        executeQuery_n_BuildGrid: function(queryId, queryType, queryParameterForAvailablitySearch){
        	this._createLoadingLabel();
            this._currentQueryID = queryId;
            
            this._currentQueryType = queryType;
            
            this._queryParameterForAvailablitySearch = queryParameterForAvailablitySearch;
            
            var self = this;
            
            var serviceObject = {
            
                loadQueryResult: function(queryResult){
                    // if we have no data, no action needed
                    if (!queryResult) {
                    
                        self._createNoResultLabel();
                        
                        return; // early return
                    }
                    self._buildQueryResultsGrid(queryId, queryResult);
                },
                
                failure: function(errorObj){
                
                    self._displayErrorMessage(ResourceAssignmentViewletMessages.GET_QUERY_FAILED + " : " + errorObj.message);
					self._hideLoadingLabel();
                }
            };
            
            var responseHandler = new ServiceResponseHandler(serviceObject, "loadQueryResult", "failure");
            
            if (queryType === "user" && queryParameterForAvailablitySearch.availablitySearchFlag) {
            
                QueryClient._executeQuery_avail(responseHandler, queryId, queryParameterForAvailablitySearch);
                
            }
            else 
                if (queryParameterForAvailablitySearch.profileReplcementSearch) {
                
                    QueryClient._executeQuery_Avail_Json(responseHandler, queryParameterForAvailablitySearch);
                    
                }
                else {
                
                    QueryClient._executeQuery(responseHandler, queryId);
                    
                }
            
            
        },
        
        /*
         * Private Method
         * 		Builds the grid based on the resultset got from the server
         * @param String queryId: The Item ID of the stored query.
         * @param Object queryResult: The query result: has the field list and the results.
         * @return void
         */
        _buildQueryResultsGrid: function(queryId, queryResult){
            var fieldsList = QueryUtil.getQueryFieldsList(queryResult);
            var resultSet = QueryUtil.getQueryResultSet(queryResult);
            if (fieldsList == null || resultSet == null) {
            
                this._createNoResultLabel();
                return;
            }
            var items = new Array(1);
			//Get the first not null item
			var index = 0;
			var firstNotNullItem = null;
			for( var i=index; i<resultSet.length; i++) {
				firstNotNullItem = this._getItemFromResultSetRow(resultSet[i], fieldsList);
				if (firstNotNullItem != null) {
					index = i;
					break;
				}
			}
			//Check if you could find any appropriate item
			if (firstNotNullItem == null) {
				this._createNoResultLabel();
				return;
			}
			
            items[0] = firstNotNullItem;
            
            var check = {
                identifier: 'id',
                items: items
            };
            
            this._resourceQueryGridDataStore = new dojo.data.ItemFileWriteStore({
                data: check
            });
            this._resourceQueryGridDataStore.save();
            
            var _queryGridData = new com.ibm.epm.web.core.ui.internal.DojoData(null, this._resourceQueryGridDataStore);
            _queryGridData.rebuildRowIdentities();
            
            if (this._resourceQueryGrid && this._projectResourceContent) {
                this._projectResourceContent.removeChild(this._resourceQueryGrid.domNode);
            }
            
            var queryResourceGridLayout = this._getQueryGridLayout(fieldsList);
            this._createQueryGrid(_queryGridData, queryResourceGridLayout);
            
			if(this._resourceQueryGrid && this._resourceQueryGrid.beginUpdate){
					this._resourceQueryGrid.beginUpdate();
			}
			try{
	            for (var i = index + 1; i < resultSet.length; i++) {
	                var item = this._getItemFromResultSetRow(resultSet[i], fieldsList);
	                if (item != null) {
	                   
					    _queryGridData.store.newItem(item);
						
	                }
	            }
			}catch(exception){
				
				if(this._resourceQueryGrid && this._resourceQueryGrid.endUpdate){
					this._resourceQueryGrid.endUpdate();
			}
				
			}
			if(this._resourceQueryGrid && this._resourceQueryGrid.endUpdate){
					this._resourceQueryGrid.endUpdate();
			}
            this._hideLoadingLabel();
        },
        
        /*
         * Private Method
         * 		prepares the Object that will be insterted into the store.
         * @param Object resultSetRow: A row in query result.
         * @param Object fieldsList: The fields list in the query result,
         * @return: The Converted result row based on the fields sent from the server.
         */
        _getItemFromResultSetRow: function(resultSetRow, fieldsList){
            var item = {};
            
            if (resultSetRow.self && resultSetRow.self.relativeHref) {
                item.id = resultSetRow.self.relativeHref;
            }
            else if (Constants.USER_ID in resultSetRow) {
            	item.id = "user/" + resultSetRow.userId;
            }
            else if (resultSetRow.itemId) {
            	item.id = resultSetRow.itemId;
            }
            else {
            	return null;
            }
			
			//Check for users only
			//Bail out early if the userId matches ADMIN or GUEST or unassigned or is Archived
			if (resultSetRow.userId &&
				( resultSetRow.archived || 
				  (resultSetRow.userId == Constants.ADMIN_ID) ||
				  (resultSetRow.userId == Constants.GUEST_ID) || 
				  (resultSetRow.userId == Constants.UNASSIGNED_USERID)	)){
					return null;
			}
			
            for (var i in fieldsList) {
                var fieldName;
				if(this._queryParameterForAvailablitySearch.availablitySearchFlag || this._queryParameterForAvailablitySearch.profileReplcementSearch){
					fieldName = fieldsList[i].fieldId;
				} else{
					fieldName = fieldsList[i].label;
				}
                
                if ((resultSetRow[fieldName] && resultSetRow[fieldName] != null) || (fieldName == Constants.EXPERIENCEINYEAR)) {
                    // This If should not be there. 
                    // This is the fix till we finalize on what to be used for headers Ecore or XSD.
					
					if(fieldName == Constants.START_DATE_INTERVAL){
						var temp = resultSetRow[fieldName];
						temp = temp.substring(0,10);
						item[Constants.BEST_START_DATE] = temp;
						
					} else if(fieldName == Constants.FINISH_DATE_INTERVAL){
						var temp = resultSetRow[fieldName];
						var index = temp.lastIndexOf(",");
						if(index != -1)
						{
							temp = temp.substring(index+1, temp.length);	
						}else{
							
							temp = temp.substring(0,10);
						}
						item[Constants.BEST_FINISH_DATE] = temp;
						
					}
					// Imp - For project the available effort column will show the sum of all effort in the interval
					// The availaible effort value retunred from the server is the actual availability of user during that period
					// may and may not be equal to the sum of efforts in the available effort interval.
					else if (fieldName == Constants.AVAILABLE_TIME){
						
						//calculate the sum of all the efforts in the available effort interval
						var effortIntervals = resultSetRow[Constants.AVAILABE_EFFORT_INTERVAL];
						var effortsArray = effortIntervals.split(",");
						var length = effortsArray.length;
						var totalEffort = 0;
						for(var j = 0 ; j < length ; j++){
							
							totalEffort += parseInt(effortsArray[j]);
						}	
						
						item[fieldName] = totalEffort;
						
						//Store the total available effort during that interval
						item[Constants.TOTAL_AVAILABLE_EFFORT] = resultSetRow[fieldName];	
						
						continue;
					}
						
					item[fieldName] = resultSetRow[fieldName];	
                }
				else{	
					item[fieldName] = "-";
				}
            }
			
			//Store the contour information
			if(this._queryParameterForAvailablitySearch.contour){
				
				item.contour = this._queryParameterForAvailablitySearch.contour;
			}
			
			// Add the HTML tool tip info 
			if(this._queryParameterForAvailablitySearch.availablitySearchFlag || this._queryParameterForAvailablitySearch.profileReplcementSearch)
			{
				if(this._queryParameterForAvailablitySearch.searchLevel == Constants.SEARCH_LEVEL_PROJECT)
				{
					item.tooltipHTML = this.createTooltipHTML(item);
				}
				
				//Store the availability search params
                
				item.availabilitySearchFlag = true;
				item.availabilitySearchLevel = this._queryParameterForAvailablitySearch.searchLevel;
				item.availabilitySearchType = this._queryParameterForAvailablitySearch.searchType;
				item.availabilitySearchEffort = this._queryParameterForAvailablitySearch.effort;
				item.availabilitySearchContour = this._queryParameterForAvailablitySearch.contour;
			} 
			
			// Populate the skills and competencies
			
			// Checking whether query is run for User or Profile by resultSetRow.userId.
			// If query is running for user, setting skill and competency to null.
			// Because, skillassignment and competencyassignment are link for user and framework doesn't support to
			// load all the link associated with some resource.
			// Once ContributorDetails is delivered, skillassignment and competencyassignment will become reference from User and
			// then we can get the values of skill and competency from skillassingment and competencyassignment.
			// To avoid make extra call from UI , we are not making loading skill, competency from there respective skillassignment 
			// and competencyassignment URI.
			// If query is run for Profile, skill and competency will be loaded in skillassignment and competencyassignment.
			// 
			
			else //if(!this._queryParameterForAvailablitySearch.availablitySearchFlag)
			{
				var displaySkills = "";
				var skills = [];
				if ((Constants.SKILL_ASSIGNMENT_FIELD in resultSetRow) && resultSetRow.skillassignment.length > 0) {
					for (var i=0; i < resultSetRow.skillassignment.length; i++) {
						if (resultSetRow.skillassignment[i].skill) {
							if(i > 0){
								displaySkills = displaySkills + " , ";
							}
							if (resultSetRow.skillassignment[i].skill.title) {
								displaySkills = displaySkills + resultSetRow.skillassignment[i].skill.title;
							}
							if (resultSetRow.skillassignment[i].skill.relativeHref && resultSetRow.skillassignment[i].proficiency.relativeHref) {
								var sk = Constants.SKILL + "=" + resultSetRow.skillassignment[i].skill.relativeHref + "," + Constants.PROFICIENCY + "=" + resultSetRow.skillassignment[i].proficiency.relativeHref;
								skills.push(sk);
							}
						}
					}
				}
				if( displaySkills == "") {
					displaySkills = "-";
				}

				item[Constants.SKILL] = displaySkills;
				item[Constants.SKILL_URI] = [skills];
				
				var displayCompetency = "";
				var competencies = [];
				if ((Constants.COMPETENCY_ASSIGNMENT_FIELD in resultSetRow) && resultSetRow.competencyassignment.length > 0) {
					for (var k = 0; k < resultSetRow.competencyassignment.length; k++) {
						if (resultSetRow.competencyassignment[k].competency) {
							if(k > 0){
								displayCompetency = displayCompetency + " , ";
							}
							if (resultSetRow.competencyassignment[k].competency.title) {
								displayCompetency = displayCompetency + resultSetRow.competencyassignment[k].competency.title;
							}
							if (resultSetRow.competencyassignment[k].competency.relativeHref && resultSetRow.competencyassignment[k].proficiency.relativeHref) {
								var sk = Constants.COMPETENCY + "=" + resultSetRow.competencyassignment[k].competency.relativeHref + "," + Constants.PROFICIENCY + "=" + resultSetRow.competencyassignment[k].proficiency.relativeHref;
								competencies.push(sk);
							}
						}
					}
				}
				if( displayCompetency == "") {
					displayCompetency = "-";
				}
					
				item[Constants.COMPETENCY] = displayCompetency;
				item[Constants.COMPETENCY_URI] = [competencies];
			}
			
			
            item.action = "";
            // The data store cannot be created without the name field.
            if (!item.name) {
                item.name = "";
            }
            return item;
        },
		
		/**
		 * Returns the string with first letter capitalized
		 * @param {Object} name
		 */
		_initCap:function(name){
			
			if(name == Constants.NULL || name == Constants.BLANK_STRING )
				return name;
			
			name = name.substring(0,1).toUpperCase() + name.substring(1);
			
			return name; 
			
		},
		
		/**
		 * Formats dates
		 * @param {Object} inDatum
		 */
	 	 _formatDate : function(inDatum){
				if (inDatum && (inDatum !== "") && (inDatum !== "?") && (inDatum !== "-")) {
					var leastDate = com.ibm.epm.web.core.util.internal.DateUtil.parseDate(Constants.LEAST_DATE);
					var inDate = com.ibm.epm.web.core.util.internal.DateUtil.parseDate(inDatum);
					if (0 >= dojo.date.compare(leastDate, inDate, 'date')) {
						return dojo.date.locale.format(new Date(inDate), {selector: 'date', formatLength: 'medium'});
					}
				}
				return " - ";
	   	 },
        /*
         * Private Method
         * 		Prepares the layout of the Dojo Grid based on the fields list
         * @param Object fieldsList: The fields list in the query result,
         * @return: For each field in the result set a new column is created in the grid layout.
         */
        _getQueryGridLayout: function(fieldsList){
			
            var rows = [];
            var userOrProfileColumn = {
                name: " ",
                width: 1.5,
                get: this.userOrProfile
            };
            rows.push(userOrProfileColumn);
			var insertActionColumn = false;
            var actionColumn = {
                name: ResourceAssignmentViewletMessages.ACTIONS,
                width: 7,
                field: "action",
                headerClasses: "com-ibm-epm-resource-assignment-web-ui-internal2-ResourceQueryGrid-unsortableColumn"
            };
            for (var i in fieldsList) {
            
                if ( (fieldsList[i].label.indexOf("Id") != -1) || (fieldsList[i].label.indexOf(Constants.ARCHIVED_FIELD) != -1) ||
					(fieldsList[i].label.indexOf(Constants.SKILL_ASSIGNMENT_FIELD) != -1) ||
					(fieldsList[i].label.indexOf(Constants.COMPETENCY_ASSIGNMENT_FIELD) != -1) ||
					(fieldsList[i].label.indexOf(Constants.START_DATE) != -1) ||
					(fieldsList[i].fieldId === (Constants.AVAILABE_EFFORT_INTERVAL)) ) {
                    continue;
                }
                var column ;
				
				if(fieldsList[i].fieldId == Constants.START_DATE_INTERVAL ){
					column = {
                    name: this._initCap(fieldsList[i].label),
                    width: 10,//col.width,
                    field: Constants.BEST_START_DATE,
					formatter:this._formatDate
                };
					
				}
				
				else if (fieldsList[i].fieldId == Constants.FINISH_DATE_INTERVAL ){
					
					column = {
                    name: this._initCap(fieldsList[i].label),
                    width: 10,//col.width,
                    field: Constants.BEST_FINISH_DATE,
					formatter:this._formatDate
                };
					
				}
				else {
					
					if(this._queryParameterForAvailablitySearch.availablitySearchFlag || this._queryParameterForAvailablitySearch.profileReplcementSearch){
						column = {
	                    name: this._initCap(fieldsList[i].label),
	                    width: 10,//col.width,
	                    field: fieldsList[i].fieldId,
						formatter:util.addSpanforWhiteSpace
	                	};
					}
					else{
						column = {
	                    name: this._initCap(fieldsList[i].label),
	                    width: 10,//col.width,
	                    field: fieldsList[i].label,
						formatter:util.addSpanforWhiteSpace
						};
					}
				}
				
				if( fieldsList[i].fieldId == Constants.AVAILABLE_DURATION ) {
					column.formatter = GridColumnUtil.formatDays;
					column.styles = Constants.RIGHT_ALIGN_TEXT_STYLE;
					column.width = 7;
				}
				
				if( fieldsList[i].fieldId == Constants.AVAILABLE_TIME ) {
					column.formatter = GridColumnUtil.formatAvailabilityHours;
					column.styles = Constants.RIGHT_ALIGN_TEXT_STYLE;
					column.width = 10;
				}
                rows.push(column);

				//Insert the action column after the name column.
				if( ( (fieldsList[i].fieldId) && ((fieldsList[i].fieldId).toUpperCase() == (Constants.NAME).toUpperCase()) ) ||
				    ( (fieldsList[i].label) && ((fieldsList[i].label).toUpperCase() == (Constants.NAME).toUpperCase()) ) ) {
					insertActionColumn = true;
					rows.push(actionColumn);
				}						
            }
			
			
			//Add columns for Skills and Competencies only for normal searches as these fileds automatically comes for 
			// availabiltiy search
			//During profile replacement we should not add these columns.
			if((!this._queryParameterForAvailablitySearch.availablitySearchFlag) &&
			   (!this._queryParameterForAvailablitySearch.profileReplcementSearch))
			{
				 var skillColumn = {
	                    name: ResourceAssignmentViewletMessages.SKILLS,
	                    width: 10,//col.width,
	                    field: Constants.SKILL,
						formatter:util.addSpanforWhiteSpace
	                };
	                rows.push(skillColumn);
				
				 var compColumn = {
	                name: ResourceAssignmentViewletMessages.COMPETENCY,
	                width: 10,//col.width,
	                field: Constants.COMPETENCY,
					formatter:util.addSpanforWhiteSpace
	           	 };
			
            	rows.push(compColumn);
			}
			if (!insertActionColumn) {
				rows.push(actionColumn);
			}
			
            var queryResourceGridLayout = [{
                noscroll: false,
                defaultCell: {
                    styles: 'text-align: left;'
                },
                rows: [rows]
            }];
            return queryResourceGridLayout;
        },
        
        /*
         *
         */
        userOrProfile: function(/*Integer*/rowIndex){
            var returnString = "";
            if (this.grid) {
                var row = this.grid.model.getRow(rowIndex);
                if (row) {
                    if (row.id != "") {
                        if (row.id.toUpperCase().indexOf("profile".toUpperCase()) != -1) {
                            returnString = '<img name="profileImage" title="' + ResourceAssignmentViewletMessages.PROFILE_IMAGE +
                            '" alt="' + ResourceAssignmentViewletMessages.PROFILE_IMAGE + '" src =' +
                            dojo.moduleUrl("com.ibm.epm.web.core", "ui/internal/images/profile_obj.gif") +
                            " />";
                        }
                        else 
                            if (row.id.toUpperCase().indexOf("user".toUpperCase()) != -1) {
                                returnString = '<img name="resourceImage" title="' + ResourceAssignmentViewletMessages.RESOURCE_IMAGE +
                                '" alt="' + ResourceAssignmentViewletMessages.RESOURCE_IMAGE + '" src =' +
                                dojo.moduleUrl("com.ibm.epm.web.core", "ui/internal/images/resource_obj.gif") +
                                " />";
                            }
                    }
                }
            }
            return returnString;
        },
        /*
         * methods to do with populating the UI
         * Incoming : Query Summary and Attributes Order
         * Outgoing : None
         */
        _createQueryGrid: function(_queryGridData, queryResourceGridLayout){
        
            // a grid layout is an array of views.
            var layout = [queryResourceGridLayout];
            
            this._resourceQueryGrid = new com.ibm.epm.web.core.ui.internal.EPMGrid({
                title: ResourceAssignmentViewletMessages.RESOURCES_GRID,
                model: _queryGridData,
                structure: queryResourceGridLayout
            });
            
            this._projectResourceContent.appendChild(this._resourceQueryGrid.domNode);
            this._pconnects.push(dojo.connect(this._resourceQueryGrid, EPMGridPubSub.ON_CELL_DBL_CLICK, this, this.onCellClick));
            this._pconnects.push(dojo.connect(this._resourceQueryGrid, EPMGridPubSub.ON_CELL_CLICK, this, this.onCellClick));
            this._pconnects.push(dojo.connect(this._resourceQueryGrid, "onRowMouseOver", this, this._onMouseOver));
            this._pconnects.push(dojo.connect(this._resourceQueryGrid, "onRowMouseOut", this, this._onMouseOut));
			this._pconnects.push(dojo.connect(this._resourceQueryGrid, EPMGridPubSub.ON_KEY_DOWN, this, this._onKeyDown));
			this._pconnects.push(dojo.connect(this._resourceQueryGrid, EPMGridPubSub.ON_CELL_MOUSE_OVER, this, this.onCellMouseOver));
			this._pconnects.push(dojo.connect(this._resourceQueryGrid, EPMGridPubSub.ON_CELL_MOUSE_OUT, this, this.onCellMouseOut));
            this.taskTooltip = new dijit.Tooltip();
            this.update();
            
        },
        
		/*
         * Private Method
         * _onKeyDown: Handle the on key down event on the grid row and do the action 
         * Input: event e
         * outPut: None
         */
		_onKeyDown: function(e){
			//Donot process the row if an editor is open
            if (this._resourceQueryGrid.edit && this._resourceQueryGrid.edit.isEditing()) {
                return;
            }			          
			switch (e.keyCode){
				case 65 /*a - Assign profile or resource*/:
					if(this._canDoAction(e, ResourceAssignmentViewletMessages.ASSIGN_BUTTON)){
						this.context._assignResource();
					}
					break;
				case 82 /*r - Replace*/:
					if(this._canDoAction(e, ResourceAssignmentViewletMessages.REPLACE)){
						this.context.replaceProfileWithAllocatedUser(this.getSelectedRows());
					}
					break;
			}
					
		},
		
		_canDoAction: function(e, action){
			var row = this._resourceQueryGrid.model.getRow(e.rowIndex);
            if(row.markedForDeletion) {
            	return false;
            }
            if (row) {				
				if (row.id) {
                        if (row.id.toUpperCase().indexOf("user".toUpperCase()) != -1) {
						if((action == ResourceAssignmentViewletMessages.ASSIGN_BUTTON) ||
							(action == ResourceAssignmentViewletMessages.REPLACE)){
							return true;
						}
                   	}
                   	else {
						if(action == ResourceAssignmentViewletMessages.ASSIGN_BUTTON){
							return true;
						}
                 	}
				 }
			}
			return false;
		},
		
        /*
         * Private Method
         * _MouseOut: Handle the on mouse over event on the grid row and add the action images to action column
         * Input: event e
         * outPut: None
         */
        _onMouseOver: function(e){
            if (e.rowIndex != -1) {
                this._clearAllActionRows();
                
                var row = this._resourceQueryGrid.model.getRow(e.rowIndex);
                if (row) {
                    var columnCount = this._resourceQueryGrid.hasLayout();
                    if (columnCount > 0) {
                        var cellobj = this._resourceQueryGrid.getCell(this._getActionColumnIndex());
                        var cellDomNode = cellobj.getNode(e.rowIndex);
                        if (row.id) {
                            if (row.id.toUpperCase().indexOf("user".toUpperCase()) != -1) {
                                cellDomNode.innerHTML = '<img name="assignImage" style="margin-right: 7px; cursor: pointer;" title="' + ResourceAssignmentViewletMessages.ASSIGN_BUTTON +
                                '" alt="' + ResourceAssignmentViewletMessages.ASSIGN_BUTTON + '" src =' +
                                dojo.moduleUrl("com.ibm.epm.web.core", "ui/internal/images/actions/action_assignresource.gif") +
                                ' />&nbsp<img name="replaceImage" style="margin-right: 7px; cursor: pointer;" title="' +
                                ResourceAssignmentViewletMessages.REPLACE +
                                '" alt="' + ResourceAssignmentViewletMessages.REPLACE + '" src =' +
                                dojo.moduleUrl("com.ibm.epm.web.core", "ui/internal/images/actions/action_replace.gif") +
                                ' />';
                            }
                            else {
                                cellDomNode.innerHTML = '<img name="assignImage" style="margin-right: 7px; cursor: pointer;" title="' + ResourceAssignmentViewletMessages.ASSIGN_BUTTON +
                                '" alt="' + ResourceAssignmentViewletMessages.ASSIGN_BUTTON + '" src =' +
                                dojo.moduleUrl("com.ibm.epm.web.core", "ui/internal/images/actions/action_assignprofile.gif") +
                                " />";
                            }
                        }
                        
                        this._rowHoverArray.push(e.rowIndex);
                    }
                }
            }
        },
        
        /*
         * Private Method
         * _MouseOut: Handle the on mouse out event on the grid row and remove the action images from action column
         * Input: event e
         * outPut: None
         */
        _onMouseOut: function(e){
            if (e.rowIndex != -1) {
                this._clearAllActionRows();
                this._clearOneActionRow(e.rowIndex);
            }
        },
        
        /*
         * Private Method
         * _clearOneActionRow: Clear action from this row
         * Input: event e
         * outPut: None
         */
        _clearOneActionRow: function(rowIndex){
            var row = this._resourceQueryGrid.model.getRow(rowIndex);
            if (row) {
                var actionValue = "";
                var columnCount = this._resourceQueryGrid.hasLayout();
                if (columnCount > 0) {
                    var cellobj = this._resourceQueryGrid.getCell(this._getActionColumnIndex());
                    var cellDomNode = cellobj.getNode(rowIndex);
                    cellDomNode.innerHTML = actionValue;
                }
            }
        },
        
        /*
         * Private Method
         * _clearAllActionRow: Clear all actions from this row
         * Input: event e
         * outPut: None
         */
        _clearAllActionRows: function(){
            for (var i = 0; i < this._rowHoverArray.length; i++) {
                var rowIndex = this._rowHoverArray[i];
                this._clearOneActionRow(rowIndex);
            }
            this._rowHoverArray = [];
        },
        
        /*
         * Private Method
         * onCellClick: Handle the on cell click event on the grid cell to take appropriate action according to the image clicked in action column
         * Input: event e
         * outPut: None
         */
        onCellClick: function(event){
            if (event) {
                if (event.cell.field == "action") {
                    if (event.target.name == "assignImage") {
                        this.context._assignResource(); //TODO: need to replace with proper Function.
                    }
                    else 
                        if (event.target.name == "replaceImage") {
                        
                        this.context.replaceProfileWithUser(this.getSelectedRows());
                        }
                }
            }
        },
        
        /*
         * Displays the Error Message
         * Incoming : Error message
         * Outgoing : None
         */
        _displayErrorMessage: function(errorMessage){
            this._displayAndClearErrorMessage(errorMessage);
        },
        
        _clearErrorMessage: function(){
            EPMErrorHandler.clearError();
        },
        /*
         * Display and clear the error message
         * incoming : Error Message Object
         * OutGoing : None
         */
        _displayAndClearErrorMessage: function(errorMessage){
            var self = this;
            EPMErrorHandler.setError(errorMessage);
            
            // Set an interval and clear the error message
            var intervalID = setInterval(function(){
                self._clearErrorMessage();
                clearInterval(intervalID);
            }, 10000);
        },

        /*
         * Private Method
         * _getActionColumnIndex: Returns the  column index of Action Column
         * Input: None
         * outPut: Integer index
         */
		_getActionColumnIndex: function() {
			var index = this._resourceQueryGrid.layout.cellCount - 1; //default to the last
			for(i=0; i<this._resourceQueryGrid.layout.cellCount; i++){
				if(this._resourceQueryGrid.layout.cells[i].field == "action"){
					index = i;
					break;
				}
			}
			return index;
		},
		
		
		/**
		 * Creates toop tip to display discrete intervals for availability search
		 * @param {Object} item
		 * @param {Object} row
		 * @param {Object} isUserQuery
		 */ 
        createTooltipHTML: function(item){
            if (item) {
               var resultString = "";
			   
			   var startDateInterval = item.startDateInterval;
			   var finishDateInterval = item.finishDateInterval;
			   var availableEffortInterval = item.availableEffortInterval;
			   
			   var startDates = startDateInterval.split(",");
			   var finishDates = finishDateInterval.split(",");
			   var availableEffort = availableEffortInterval.split(",");
			   
			   var totalNumberOfIntervals = startDates.length;
				
				if (totalNumberOfIntervals > 0) {
					
					//TODO : Show user's name. This line will change
					var div = '<div class="com-ibm-epm-resource-assignment-web-ui-internal2-AssignedResourceGrid-tooltipMessageClass">' +
					'<img name="resourceImage" title="' + ResourceAssignmentViewletMessages.RESOURCE_IMAGE +
                     '" alt="' + ResourceAssignmentViewletMessages.RESOURCE_IMAGE + '" src =' +
                     dojo.moduleUrl("com.ibm.epm.web.core", "ui/internal/images/resource_obj.gif") + " />" +
					 this._initCap(item.name) + "'s Availability " + " " + '</div>';
					
					resultString = resultString + div;
				}
				var table = '<table class="com-ibm-epm-resource-assignment-web-ui-internal2-AssignedResourceGrid-tooltipTable">';
				table += '<tr><td> From </td> <td> To </td> <td> Effort </td></tr>';
                for (var i = 0; i < totalNumberOfIntervals; i++) {
					var titleObj;
					
					var	_effort = availableEffort[i];
					var _startDate = this._formatDate(startDates[i]);
					var _finishDate = this._formatDate(finishDates[i]);
                   	
					var rowDetail = {
						effort: _effort,
						startDate: _startDate,
						finishDate: _finishDate
					};
                    
                    var tr = this.getTableRow(rowDetail);
                    table = table + tr;
                }
                return resultString + table + "</table>";
            }
			return null;
        },
		 
		 getTableRow: function(rowDetail){
            var tr = '<tr>';
			var td = '<td class="com-ibm-epm-resource-assignment-web-ui-internal2-AssignedResourceGrid-tooltipDatesCell">' +
            rowDetail.startDate + "&nbsp;&nbsp;&nbsp;&nbsp;" +'</td>' +
            
			'<td class="com-ibm-epm-resource-assignment-web-ui-internal2-AssignedResourceGrid-tooltipDatesCell">' +
            rowDetail.finishDate + "&nbsp;&nbsp;&nbsp;&nbsp;" +"</td>" +
			
			'<td class="com-ibm-epm-resource-assignment-web-ui-internal2-AssignedResourceGrid-tooltipEffortCell">' +
            rowDetail.effort +
            " " +
            ResourceAssignmentViewletMessages.HOURS_ABBR +"&nbsp;&nbsp;&nbsp;&nbsp;" +
            "</td>" ;
			
			tr = tr + td;		 
            return tr + "</tr>";
        },
		
		
		 onCellMouseOut: function(e){
            this.taskTooltip.close();
        },
		 /**
		  * 
		  * @param {Object} e
		  */
        onCellMouseOver: function(e){
            if (e.rowIndex != -1) {
                if (e.cell.field == "availableEffort" && this._queryParameterForAvailablitySearch.searchLevel == Constants.SEARCH_LEVEL_PROJECT) {
                    var row = this._resourceQueryGrid.model.getRow(e.rowIndex);
                    
                    if (row) {
                        if (row.availableEffort != "0") {
                            this.taskTooltip.label = row.tooltipHTML.toString();
                            this.taskTooltip.open(e.cellNode);
                        }
                    }
                }
            }
        }
        
    });
    
})();
