
/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
if (!dojo._hasResource["com.ibm.epm.web.core.util.internal.ConfirmDeleteDialog"]) {
    dojo._hasResource["com.ibm.epm.web.core.util.internal.ConfirmDeleteDialog"] = true;
    dojo.provide("com.ibm.epm.web.core.util.internal.ConfirmDeleteDialog");
    
    dojo.require("com.ibm.epm.web.core.ui.internal.EPMConfirmDialog");
    
    dojo.require("dijit._Widget");
	dojo.requireLocalization("com.ibm.epm.web.core.ui", "Messages");

	var CoreMessages = dojo.i18n.getLocalization("com.ibm.epm.web.core.ui", "Messages");
    
    dojo.declare("com.ibm.epm.web.core.util.internal.ConfirmDeleteDialog", dijit._Widget, {
    
        confirmDialog: null,
		controller: null,
        selectedRows: null,
		selectedRowsIndex: [],
		postCreate: function(gridController, selectedRows){
			this.selectedRows = this.getSelectedRows();
			this.getDialog();
		},
		
        show : function(){
			this.confirmDialog.show();
		},
		
        getDialog: function(){
			this.selectedRowsIndex = this.grid.selection.getSelected();
            if (this.selectedRowsIndex.length !== 0) {
                var self = this;
                var buttonlist;
                var dialogContent;
				var width = "300px";
                if (this.selectedRowsIndex.length > 1) {
                    buttonlist = [{
                        label: CoreMessages.YES,
                        action: dojo.hitch(this, this.deleteOne)
                    }, {
                        label: CoreMessages.YES_TO_ALL,
                        action: dojo.hitch(this, this.deleteAll)
                    }, {
                        label: CoreMessages.NO,
                        action: dojo.hitch(this, this.noDelete)
                    }, {
                        label: CoreMessages.NO_TO_ALL
                    }];
                    dialogContent = CoreMessages.DIALOG_CONTENT_MULTIPLE_ITEMS_SELECTED;
					width = "350px";
                }
                else {
                    buttonlist = [{
                        label: CoreMessages.YES,
                        action: dojo.hitch(this, this.deleteAll)
                    }, {
                        label: CoreMessages.NO
                    }];
                    dialogContent = CoreMessages.DIALOG_CONTENT_SINGLE_ITEM_SELECTED;
					width = "350px";
                }
                
                var labelList = [{
                    label: dialogContent
                }];
                
                this.confirmDialog = new com.ibm.epm.web.core.ui.internal.EPMConfirmDialog({
                    labelList: labelList,
                    title: CoreMessages.CONFIRM_DELETE_DIALOG_TITLE,
                    buttonlist: buttonlist,
					width: width
                });
                this.confirmDialog.show();
            }
        },
        
         deleteAll: function(){
        	this.selectedRows = this.getSelectedRows();
            for (var i = 0; i < this.selectedRows.length; i++) {
                this.gridController._deleteElementByRow(this.selectedRows[i]);
            }
            this.grid.selection.unselectAll();
            this.confirmDialog.hide();
            this.confirmDialog.destroy();
        },
        
        deleteOne: function(){
			this.selectedRows = this.getSelectedRows();
            if (this.selectedRows.length !== 0) {
                this.gridController._deleteElementByRow(this.selectedRows[0]);
				this.grid.selection.unselectAll();
                for (var i = 1; i < this.selectedRowsIndex.length; i++) {
                    this.grid.selection.addToSelection(this.selectedRowsIndex[i] - 1);
                }
                if (this.selectedRows.length === 1) {
					this.grid.selection.unselectAll();
                    this.confirmDialog.hide();
                    this.confirmDialog.destroy();
                }
            }
        },
        
		/**
		 * Deselect the first selected row
		 */
        noDelete: function(){
			this.selectedRows = this.getSelectedRows();
            if (this.selectedRows.length !== 0) {
				this.grid.selection.deselect(this.grid.selection.getFirstSelected());
                if (this.selectedRows.length === 1) {
					this.grid.selection.unselectAll();
                    this.confirmDialog.hide();
                    this.confirmDialog.destroy();
                }
            }
        },
		
		/**
         * Called to get the selected rows of the grid
         * Incoming: None
         * Outgoing: Array of Selected Rows
         */
        getSelectedRows: function(){
        
            var selectedRow = [];
            if (this.grid) {
                this.selectedRowsIndex = this.grid.selection.getSelected();
                
                var length = this.selectedRowsIndex.length;
                if (length > 0) {
					selectedRow = new Array(length);
					
					for (var i = 0; i < length; i++) {
					
						selectedRow[i] = this.grid.model.getRow(this.selectedRowsIndex[i]);
					}
				}
            }
            return selectedRow;
        }
        
    });
}
