/*******************************************************************************
* Licensed Materials - Property of IBM
* (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
* 
* Note to U.S. Government Users Restricted Rights:
* Use, duplication or disclosure restricted by GSA ADP Schedule
* Contract with IBM Corp. 
*******************************************************************************/

(function(){
	dojo.requireLocalization("com.ibm.epm.web.core.ui", "Messages");

	var CoreMessages = dojo.i18n.getLocalization("com.ibm.epm.web.core.ui", "Messages");

    dojo.provide("com.ibm.epm.web.core.util.internal.GridColumnUtil");
    
    dojo.require("com.ibm.epm.web.core.util.internal.Util");
	
	var util = com.ibm.epm.web.core.util.internal.Util;
    
    /*
     * Date related  purpose utility methods.
     */
    com.ibm.epm.web.core.util.internal.GridColumnUtil = {
        formatDays: function(inDatum){
			var resultString = "";
			var value = parseInt(inDatum, 10);
			if (isNaN(value)) {
				resultString = ' - ';
			}
			else {
				resultString = value + " " + CoreMessages.DAY_ABBREVIATION;
			}
			if (dojo.isIE) {
				resultString = util.addSpanforWhiteSpace(resultString);
			}
			return resultString;
        },
		
		formatHours: function(inDatum){
			var resultString = "";
			var value = parseInt(inDatum, 10);
			if (isNaN(value)) {
				resultString = ' - ';
			}else{
				resultString = value + " " + CoreMessages.HOUR_ABBREVIATION;
			}
			
			if (dojo.isIE) {
				resultString = util.addSpanforWhiteSpace(resultString);
			}
			return resultString;
		},
		
		formatAvailabilityHours: function(inDatum){
			var resultString = "";
			var value = parseInt(inDatum, 10);
			if (!isNaN(value)) {
				resultString = value + " " + CoreMessages.HOUR_ABBREVIATION;
			}else{
				resultString = inDatum;
			}
			
			if (dojo.isIE) {
				resultString = util.addSpanforWhiteSpace(resultString);
			}
			return resultString;
		},
		
		formatRates: function(inDatum){
			var resultString = "";
			var value = parseInt(inDatum, 10);
			if (isNaN(value)) {
				resultString = ' - ';
			}else{
				resultString =inDatum;
			}
			
			if (dojo.isIE) {
				resultString = util.addSpanforWhiteSpace(resultString);
			}
//			//Todo: In future, prefix the currency declared for the application
//			else {
//				return '$ ' + value;
//			}
			return resultString;
		},
		
		formatPercentage: function(inDatum){
			var resultString = "";
			var value = parseInt(inDatum, 10);
			if (isNaN(value)) {
				resultString = ' - ';
			}else{
				resultString = value + "%";
			}
			
			if (dojo.isIE) {
				resultString = util.addSpanforWhiteSpace(resultString);
			}
			return resultString;
		},

		formatYears: function(inDatum){
			var resultString = "";
			var value = parseInt(inDatum, 10);
			if (isNaN(value)) {
				resultString = ' - ';
			}else{
				resultString = value + " " + CoreMessages.YEAR_ABBREVIATION;
			}
			
			if (dojo.isIE) {
				resultString = util.addSpanforWhiteSpace(resultString);
			}
			return resultString;
		}
		
    };
    
})();
